c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      PROGRAM ansum

      IMPLICIT NONE

      CHARACTER AVERSION*6, ADATE*8
      PARAMETER ( AVERSION='2010', ADATE='Jan 2010' )
 
      INTEGER index(100), ns, nv(100), i, j, k, MaxTrials, nsteps,
     & nvmax, idum, nvm, m, ntrials(10000), jtest, Jrot, kro, nk,
     & iv , kk , KIN , ntest
     
      PARAMETER (KIN=2)

      DOUBLE PRECISION w(100), x(100,100), wa, xa,
     &                 w0, Etot, Eu, Eb, Percent, TrialMax, 
     &                 Beta , Sum(10000), Error(10000), Emax, Estep, 
     &                 energy, RAN1, y , fac, succ, succ2, D(100),
     &                 anumb, enrg, dens(10000), eff(10000), Bk, zpe ,
     &                 Estart, an , wf , avewe , avew0, avewf,
     &                 ave , av0 , avf , Viblo
 
      CHARACTER TITLE1*100, TITLE2*100, KEYWORD*5, WW*2 , xx*2

      COMMON/I/ idum
      COMMON/wx/ wa(100) , w0(100) , wf(100) , xa(100,100) ,
     &   zpe , ave , av0 , avf , Viblo

      EXTERNAL nvmax , energy , RAN1, selekro
      SAVE

c --------------------------------------------------------------------------
99001 FORMAT (
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'                                John R. Barker'/8x,
     &'      ansum-',A6,'              University of Michigan'/8x,
     &'                                Ann Arbor, MI 48109-2143'/8x,
     &'        ',A8,'                jrbarker@umich.edu'/8x,
     &'                                (734) 763 6239'//8x,
     &'      http://aoss.engin.umich.edu/multiwell/'//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'Suggested Literature Citation:'//8x,
     &'a) MultiWell-',A6,' Software, ',A8,', designed and'/11x,
     &'maintained by J.R. Barker with contributors N.F. Ortiz,'/11x,
     &'J.M. Preses, L.L. Lohr, A. Maranzana, P.J. Stimac, T. L.'/11x,
     &'Nguyen, and T. J. Dhilip Kumar, University of Michigan,'/11x,
     &'Ann Arbor, MI; http://aoss.engin.umich.edu/multiwell/',//8x,
     &'b) J.R. Barker, J.Phys.Chem., 91, 3849-3854 (1987)',//8x,
     &'c) T.L. Nguyen and J.R. Barker, J. Phys. Chem. A.,',/11x,
     &'submitted (2010).',
     &//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'/)

9002  FORMAT(A100)
9003  FORMAT(//,I3,' Vibrational Frequencies (cm-1)',/,
     & '  We; E = We*(v+1/2) +...; Wo: E = W0*v +...;  0<->1 fund.',/,
     & '  De: BDE for Separable Morse oscillator [0.0 if non-Morse]',//,
     & '  No.     We         Wo      0-1_Fund.   De(cm-1)' )
9004  FORMAT( I5,3(1x, F10.3),1x,F10.1 )
9041  FORMAT( 100(3x,I3,4x) )
9042  FORMAT( I3, 100( 1x , f9.3 ) )
9043  FORMAT( 100(7x,I3) )
9005  FORMAT(/)
9006  FORMAT('Anharmonicity Matrix (cm-1)',/)
9007  FORMAT( 100(f9.1,1x) )
9008  FORMAT(/,'Beta = ',f7.4,//,'Maximum number of Monte Carlo samples 
     &=', 1pe8.1,/)
9009  FORMAT(//,'OUTPUT (without densities)',/,
     &  ' Energy(cm-1)  Ntrials   Efficiency    Sums     %_Error',/)
9091  FORMAT(//,'OUTPUT (approximate densities)',/,
     &' Energy(cm-1)  Ntrials   Efficiency    Sums     %_Error    Densit
     &ies',/)  
9010  FORMAT(2x,f8.1,2x,1pe10.3,2x,1pe10.2,3x,1pe10.3,3x,0pf5.2,3x,
     &       1pe10.3)
9011  FORMAT(A5)
9012  FORMAT(/,'Angular momentum J =',I4,/,
     & 'K-rotor rotational constant (cm-1) Bk = ',1pe9.3)
9013  FORMAT(/,' Ave:', 3(1x, F10.3)/
     &         '(Anharmonic) Zero point energy (cm-1) = ', f10.3,/)
9014  FORMAT(///,'Bond Dissociation Energies (Do, cm-1)  [Do = 0.0 for n
     &on-Morse Oscillator]',/)
9015  FORMAT(10x,'[After conversion from ',A2,' to ',A2,']',/)

c --------------------------------------------------------------------------
      OPEN (UNIT=2,FILE='ansum.dat',STATUS='OLD')
      OPEN (UNIT=4,FILE='ansum.out',STATUS='UNKNOWN')

      WRITE (4,99001) AVERSION , ADATE , AVERSION , ADATE

      CALL DateTime(4)

      READ(2,9002)  TITLE1
      WRITE(4,9002) TITLE1
      READ(2,9002)  TITLE2
      WRITE(4,9002) TITLE2
      WRITE(4,9005)
      READ(2,*)  ns , WW

      CALL READ_WX( KIN , ns , WW )
      
      READ(2,*)  Jrot, Bk                                       ! J quantum number and K-rotor rotational constant (cm-1)
      READ(2,*)  Estart, Emax, Estep, Beta , TrialMax , Percent
    
c   ******* END INPUT *******

      CALL convib( ns , WW )
      
      WRITE(4,9003) ns
      DO i = 1 , ns
        D(i) = 0.0
        IF (xa(i,i) .LT. 0.0) D(i) = -0.25*w0(i)**2/xa(i,i)     ! Bond dissociation energy
        WRITE(4,9004) i, wa(i), w0(i), wf(i), D(i)
      END DO

      WRITE(4, 9013) ave, av0, avf, zpe     ! zero point energy and average frequencies

      WRITE(4,9006)
      WRITE(4,9043) (i, i=1,ns)
      DO j = 1 , ns
        WRITE(4,9042) j, (xa(j,i), i=1,ns)
      END DO
 
      WRITE(4,9012) Jrot, Bk 

      MaxTrials = INT( TrialMax )
      WRITE(4,9008) Beta , TrialMax

      idum = -1147483647                                        ! Random number seed
      y = RAN1( idum )                                          ! initialize random numbers

      nsteps = 1 + (Emax-Estart)/Estep

c      WRITE(4,9009)

      DO i = 1 , nsteps                                         ! energy steps
        Etot = Estart + (i-1)*Estep                             ! Energy for sum of states
        WRITE(*,*) 'Energy: ', Etot
        Eb = Etot*Beta                                          ! Energy for sampling volume boundary
        
        succ  = 0.0d+00
        succ2 = 0.0d+00
        anumb = 0.0d+00
        ntrials(i) = 0

        j=0
        jtest = 0
         
        DO WHILE ( jtest .EQ. 0 )                               ! start stochastic trial
        j = j + 1
        ntrials(i) = j
        CALL initial( ns , nv , Kro)                            ! set quantum numbers to zero
        CALL shuffle( ns , w0 , xa, w, x )                      ! shuffle the selection order

        fac = 1.0d+00
        nk = 1 + INT( ns*RAN1(idum) )                           ! random number for calling k-rotor selection
        Eu = Eb
        k = 1
        DO WHILE ( k .LE. ns .AND. fac .GT. 0.0 )               ! mode numbers
          nvm = nvmax( ns, w, x, nv, k, Eu )
          IF ( nvm .GE. 0 ) THEN
             fac = fac*( nvm + 1.0 )                            ! weighting factor
             nv(k) = INT( (nvm + 1)*RAN1(idum) )
             IF ( Jrot .GT. 0 .AND. nk .EQ. k ) 
     &          CALL selekro( Jrot , fac , Kro , Bk, enrg )     ! randomly call K-rotor selection
             enrg = energy( ns , w , x , nv )
             Eu = Eb - enrg - Bk*Kro*Kro                        ! unassigned energy
          ELSE
             fac = 0.0
          ENDIF
          k = k+1
        ENDDO   ! k mode number

        enrg = enrg + Bk*Kro*Kro
        
        CALL ckderiv( ns , nv , w , x , ntest )                ! test partial derivatives to ensure this is a bound state
        IF ( ntest .NE. 0 ) fac = 0.0                          ! failed test

        IF ( enrg .LE. Etot .AND. fac .GT. 0.0 ) THEN
          succ  = succ + fac                                    ! weighted successes
          succ2 = succ2 + fac*fac
          anumb = anumb + 1.0d+00                               ! number of successes
        ENDIF

        IF ( j .GT. 1000 ) THEN
          Sum(i) = succ/j                                       ! sum of states (average success)
          Error(i) = SQRT( (succ2/j - Sum(i)*Sum(i))/(j-1.0) )  ! Std. deviation of the mean success
          Error(i) = 100.0*Error(i)/Sum(i)
          eff(i) = anumb/j
          IF ( Error(i) .LE. Percent ) jtest = 1
        ENDIF

        IF ( j .GE. MaxTrials ) jtest = 1

        ENDDO   ! j trials

        an = ntrials(i)
c        WRITE(4,9010) Etot,an,eff(i),Sum(i),Error(i)

      ENDDO   ! i energy steps

c   DENSITY OF STATES (assumes ln(Sum) is approximately linear with E)

      dens(1) = Sum(1)*0.5*(log(Sum(2))/Estep)
      dens(nsteps)= Sum(nsteps)*log(Sum(nsteps)/Sum(nsteps-1))/Estep
      DO i = 2 , nsteps-1                                      ! energy steps
        dens(i)=0.5*Sum(i)*log(Sum(i+1)/Sum(i-1))/Estep        ! density of states
      END DO

      CALL DateTime(4)

c    PRINT OUTPUT

      WRITE(4,9091)
      DO i = 1 , nsteps                                         ! energy steps
        Etot = Estart + (i-1)*Estep                             ! Energy for sum of states
c        Eb = Etot*Beta                                         ! Energy for sampling volume boundary
        an = ntrials(i)
        WRITE(4,9010) Etot,an,eff(i),Sum(i),Error(i),dens(i)
      END DO

      END

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker and Thanh Lam Nguyen
c
c Authors: Thanh Lam Nguyen and John R. Barker
c          nguyenlt@umich.edu
c          September 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-----------------------------------------------------------------------------------------
c    Test partial derivatives of Evib with respect to each quantum number
c
c    for bound states, all partial derivatives should be >0
c    ntest = 0 for PASS
c          = 1 for FAIL
c-----------------------------------------------------------------------------------------

      SUBROUTINE ckderiv( ns , nv , w , x , ntest ) 
      
      IMPLICIT NONE
      INTEGER ns , i , j , k , ntest , nv
      DOUBLE PRECISION w , x , sum , deriv
      DIMENSION w(100) , x(100,100) , nv(100)

      SAVE
      
      ntest = 0
      k = 1
      DO WHILE ( (k .LE. ns) .AND. (ntest .EQ. 0) )    ! start checking
         sum = 0.0d+00
         DO i = 1 , ns
           sum = sum + x(i,k)*nv(i)
         END DO
         deriv = w(k) + nv(k)*x(k,k) + sum
         IF ( deriv .LE. 0.0d+00 ) ntest = 1           ! failed test
         k = k + 1
      END DO
        
      RETURN
      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker and Thanh Lam Nguyen
c
c Authors: Thanh Lam Nguyen and John R. Barker
c          nguyenlt@umich.edu
c          September 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-----------------------------------------------------------------------------------------
c     From input as wa, w0, or wf frequencies, convert to the other forms:
c       wa(i): harmonic frequencies with zero of energy at the potential minimum
c          Evib = SUMi( wai*(vi+1/2) ) + SUMi( SUMj( Xij*(vi+1/2)*(vj+1/2) ) )
c       w0(i): frequencies with zero of energy at zpe
c          Evib = SUMi( w0i*vi ) + SUMi( SUMj( Xij*vi*vj ) )
c       wf(i) = fundamental frequencies (for 0-1 transitions with all vj = 0)
c
c     zpe = zero point energy, based on We and X matrix
c
c     Average Frequences:
c       ave = average wa(i)
c       av0 = average w0(i)
c       avf = average wf(i)
c
c     [Herzberg, Infrared and Raman Spectra (D. van Nostrand Co., 1945), p. 206ff]
c     Eq. numbers from Herzberg
c-----------------------------------------------------------------------------------------

      SUBROUTINE convib( ns , WW ) 
      
      IMPLICIT NONE
      INTEGER ns , i , j
      DOUBLE PRECISION wa , w0 , wf , xa , ya , za , zpe, 
     &                 av0 , ave , avf , Viblo
c      DIMENSION  wa(100) , w0(100) , wf(100) , xa(100,100)
      CHARACTER WW*2
      COMMON/wx/ wa(100) , w0(100) , wf(100) , xa(100,100) ,
     &   zpe , ave , av0 , avf , Viblo

      SAVE
      
      IF ( WW .EQ. 'We' ) THEN

      DO i = 1 , ns                               ! start conversion
        w0(i) = wa(i) + xa(i,i)                   ! Eq. (II,273)
        wf(i) = wa(i) + 2.0*xa(i,i)               ! fundamental
          DO j = 1, ns
            IF ( i .NE. j ) THEN
            w0(i) = w0(i) + 0.5*xa(i,j)           ! Eq. (II,273)
            wf(i) = wf(i) + 0.5*xa(i,j)           ! fundamental
            ENDIF
          END DO
      END DO                                      ! end conversion

      ELSEIF ( WW .EQ. 'W0' ) THEN

      DO i = 1 , ns                               ! start conversion
        wa(i) = w0(i) - xa(i,i)                   ! Eq. (II,273)
          DO j = 1, ns
            IF ( i .NE. j ) THEN
            wa(i) = wa(i) - 0.5*xa(i,j)           ! Eq. (II,273)
            ENDIF
          END DO
      END DO                                      ! end conversion
      DO i = 1 , ns                               ! start conversion
        wf(i) = wa(i) + 2.0*xa(i,i)               ! fundamental
          DO j = 1, ns
            IF ( i .NE. j ) THEN
            wf(i) = wf(i) + 0.5*xa(i,j)           ! fundamental
            ENDIF
          END DO
      END DO                                      ! end conversion

      ELSEIF ( WW .EQ. 'Wf' ) THEN

      DO i = 1 , ns                               ! start conversion
        wa(i) = wf(i) - 2.*xa(i,i)
          DO j = 1, ns
            IF ( i .NE. j ) THEN
            wa(i) = wa(i) - 0.5*xa(i,j)           ! Eq. (II,273)
            ENDIF
          END DO
      END DO                                      ! end conversion
      DO i = 1 , ns                               ! start conversion
        w0(i) = wa(i) + xa(i,i)                   ! Eq. (II,273)
          DO j = 1, ns
            IF ( i .NE. j ) THEN
            w0(i) = w0(i) + 0.5*xa(i,j)           ! Eq. (II,273)
            ENDIF
          END DO
      END DO                                      ! end conversion

      ENDIF
      
      zpe = 0.0d+00
      ave = 0.0d+00
      av0 = 0.0d+00
      avf = 0.0d+00
      Viblo = 10000.
      DO i = 1 , ns                               ! start ZPE
        zpe = zpe + 0.5*wa(i)                     ! Eq. (II,267)
        ave = ave + wa(i)                     ! summed frequency
        av0 = av0 + w0(i)                     ! summed frequency
        avf = avf + wf(i)                     ! summed frequency
        DO j = 1, i
          zpe = zpe + 0.25*xa(j,i)                ! Eq. (II,267)
        END DO
        Viblo = MIN( Viblo , wa(i) )              ! find lowest frequency
      END DO                                      ! end 

      ave = ave/ns                            ! average frequency
      av0 = av0/ns                            ! average frequency
      avf = avf/ns                            ! average frequency


      RETURN
      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
      SUBROUTINE DateTime(KUNIT)
c
c	Date & time subroutine
      CHARACTER*24 DateT
      REAL*4 tarray(2) , total
 
      CALL FDATE(DateT)
      WRITE (KUNIT,99001) DateT
      total = ETIME(tarray)
      WRITE (KUNIT,99002) tarray(1)
c      WRITE (KUNIT,99003) tarray(2)
      WRITE (KUNIT,99004) total/60.0
      RETURN
 
99001 FORMAT (/,10x,A24)
99002 FORMAT (10x,'Elapsed User Time: ',f12.3,' sec')
99003 FORMAT (10x,'Elapsed Sytem Time:',f12.3,' sec')
99004 FORMAT (10x,'Total Elapsed Time:',f12.3,' min',/)
      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      DOUBLE PRECISION FUNCTION energy ( ns , w , x , nv )

      IMPLICIT NONE
      INTEGER ns, nv(100), i, j
      DOUBLE PRECISION r(100), w(100), x(100,100), Eu, D, sum
      SAVE

      sum = 0.0d+00
      DO i = 1, ns
        sum = sum + nv(i)*w(i)
        DO j = 1 , i
          sum = sum + nv(i)*nv(j)*x(i,j)
        END DO
      END DO

      energy = sum

      RETURN
      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      SUBROUTINE initial ( ns, nv , Kro )

      IMPLICIT NONE
      INTEGER ns, nv(100), i , Kro
      SAVE

      DO i = 1, ns
        nv(i) = 0
      ENDDO

      Kro = 0

      RETURN
      END

       

      
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      INTEGER FUNCTION nvmax( ns, w, x, nv, k, Eu )

c     Select highest quantum number to be sampled

      IMPLICIT NONE
      INTEGER ns, index(100), nv(100), i, k, nvd
      DOUBLE PRECISION r(100), w(100), x(100,100), Eu, D , vd
      DOUBLE PRECISION vmax, sum, energy, enrg, tp
      EXTERNAL energy
      SAVE

      IF ( Eu .LT. 0.0d+00 ) THEN
         nvmax = -1
         RETURN
      ENDIF
      
      IF ( x(k,k) .NE. 0.0 ) THEN
         sum = 0.0d+00
         DO i = 1, ns
           IF ( i .NE. k ) sum = sum + nv(i)*x(i,k)
         END DO
         
         vd = -(w(k) + sum)/( 2.0d+00*x(k,k) )              ! Eq. 15: quantum no. of highest bound energy level
         D = -( ( w(k) + sum )**2)/( 4.0d+00*x(k,k) )       ! Do (not De)


		tp = 1.0d+00 - Eu/D
	IF(tp.GE.0.0d0) THEN
         vmax = vd*( 1.0d+00 - SQRT( 1.0d+00 - Eu/D) )      ! Eq. 16
	ELSE
		vmax = vd
	ENDIF

         IF ( (w(k) + sum) .GT. 0.0 .AND. x(k,k) .LT. 0.0) THEN
           IF ( Eu .GT. D ) THEN
             nvmax = INT( vd )
           ELSE
             nvmax = INT( vmax )                                
           ENDIF
         ELSEIF ( (w(k) + sum) .GT. 0.0 .AND. x(k,k) .GT. 0.0) THEN
           nvmax = INT( vmax )
         ELSE                                ! (w(k) + sum) < 0
           nvmax = 0
         ENDIF
      ELSEIF ( x(k,k) .EQ. 0.0 ) THEN
           nvmax = INT( Eu/w(k) )                              ! harmonic when x(k,k) = 0
      ENDIF   ! Eu < 0
      
      RETURN
      END
**==ran1.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
 
      DOUBLE PRECISION FUNCTION RAN1(idum)
C---------------------------------------------------------------------------------
C	"Minimal" random number generator of Park and Miller with Bays-Durham shuffle
C	and added safeguards.  Returns a uniform random deviate between 0.0 and 1.0
C	(exclusive of the endpoint values).  Call with idum a negative integer to
C	initialize; thereafter do not alter idum between successive deviates in a
C	sequence.  RNMX should approximate the largest floating value that is less
C	than 1.
C
C	W. H. Press and S. A. Teukolsky, Computers in Physics, 6(5), 522-4 (1992).
C---------------------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER idum , IA , IM , IQ , IR , NTAB , NDIV
      DOUBLE PRECISION AM , EPS , RNMX , T
      PARAMETER (IA=16807,IM=2147483647,AM=1.0D+00/IM,IQ=127773,IR=2836,
     &        NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=2.3D-16,RNMX=1.0D+00-EPS)
      INTEGER j , k , iv(NTAB) , iy
      SAVE iv , iy
      DATA iv/NTAB*0/ , iy/0/
      IF ( idum.LE.0 .OR. iy.EQ.0 ) THEN
                                        ! Initialize
         idum = max(-idum,1)            ! Be sure to prevent idum=0
         DO 50 j = NTAB + 8 , 1 , -1    ! Load shuffle table after 8 warm-ups
            k = idum/IQ
            idum = IA*(idum-k*IQ) - IR*k
            IF ( idum.LT.0 ) idum = idum + IM
            IF ( j.LE.NTAB ) iv(j) = idum
 50      CONTINUE
         iy = iv(1)
      ENDIF
      k = idum/IQ                       ! Start here when not initializing
      idum = IA*(idum-k*IQ) - IR*k      ! Compute idum=mod(IA*idum,IM) without
      IF ( idum.LT.0 ) idum = idum + IM !    overflows by Schrage's Method
      j = 1 + iy/NDIV                   ! Will be in range 1:NTAB
      iy = iv(j)                        ! Output previously stored value
      iv(j) = idum                           ! Refill shuffle table
      T = AM*iy
      RAN1 = min(T,RNMX)        ! Because users don't expect endpoint values
11	format(d90.50)
c	write(6,11)RAN1
      RETURN
      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker and Thanh Lam Nguyen
c
c Authors: Thanh Lam Nguyen and John R. Barker
c          nguyenlt@umich.edu
c          September 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c----------------------------------------------------------------------
c
c      Read vibrational frequencies and anharmonicities
c
c       KIN = input UNIT for READ statements
c       ns  = number of vibrational frequencies
c       WW  = keyword ('we', 'w0', or 'wf') for the three types of frequencies:
c       wa(i): harmonic frequencies with zero of energy at the potential minimum
c          Evib = SUMi( wai*(vi+1/2) ) + SUMi( SUMj( Xij*(vi+1/2)*(vj+1/2) ) )
c       w0(i): frequencies with zero of energy at zpe
c          Evib = SUMi( w0i*vi ) + SUMi( SUMj( Xij*vi*vj ) )
c       wf(i) = fundamental frequencies (for 0-1 transitions with all vj = 0)
c----------------------------------------------------------------------
      SUBROUTINE READ_WX( KIN , ns , WW ) 
      
      IMPLICIT NONE
      CHARACTER WW*2 , KEYWORD*5
      INTEGER KIN , ns , i , j , k , l
      INTEGER NY , NZ , I1 , J1 , K1 , L1
      DOUBLE PRECISION wa , w0 , wf , xa , ya , za
      DOUBLE PRECISION ave , av0 , avf , zpe , Viblo
      COMMON/wx/ wa(100) , w0(100) , wf(100) , xa(100,100) ,
     &   zpe , ave , av0 , avf , Viblo
      SAVE

      IF ( (WW .EQ. 'We') .OR. (WW .EQ. 'we') .OR. (WW .EQ. 'WE') ) THEN
        READ(KIN,*)     (wa(i), i=1,ns)
        WW = 'We'
      ELSEIF ( (WW .EQ. 'W0') .OR. (WW .EQ. 'w0') ) THEN
        READ(KIN,*)     (w0(i), i=1,ns)
        WW = 'W0'
      ELSEIF ( (WW.EQ.'Wf') .OR. (WW.EQ.'wf') .OR. (WW.EQ.'WF') ) THEN
        READ(KIN,*)     (wf(i), i=1,ns)
        WW = 'Wf'
      ENDIF
c                                                        X matrix (vibrational anharmonicity)
      READ(KIN,9011) KEYWORD
      IF ( (KEYWORD .EQ. 'UPPER') .OR. (KEYWORD .EQ. 'upper') 
     &       .OR. (KEYWORD .EQ. 'Upper') ) THEN
        DO j = 1, ns
          READ(KIN,*) (xa(j,i), i=j, ns)
          IF ( j .LT. ns) THEN
            DO k = j+1 , ns
              xa(k,j) = xa(j,k)
            END DO
          ENDIF
        ENDDO
      ELSEIF ( (KEYWORD .EQ. 'LOWER') .OR. (KEYWORD .EQ. 'lower') 
     &           .OR. (KEYWORD .EQ. 'Lower') ) THEN
        DO j = 1, ns
          READ(KIN,*) (xa(j,i), i=1,j)
          IF ( j .GT. 1) THEN
            DO k = 1 , j-1
              xa(k,j) = xa(j,k)
            END DO
          ENDIF
        ENDDO
      ENDIF

9011  FORMAT(A5)

      RETURN
      END
      
      
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      SUBROUTINE selekro( Jrot , fac , Kro , Bk, enrg )

      IMPLICIT NONE
      INTEGER Jrot , Kro , idum
      DOUBLE PRECISION RAN1 , fac , Bk , enrg
      COMMON/I/ idum
      EXTERNAL RAN1
      SAVE

      IF ( Jrot .GT. 0 ) THEN
        Kro = -Jrot + INT( (2*Jrot+1)*RAN1(idum) )           ! select K-rotor quantum number
        fac = fac*(2*Jrot + 1.0d+00)                         ! weighting factor
        enrg = Bk*Kro*Kro                                    ! K-rotor energy
      ELSE
        Kro = 0
        enrg = 0.0d+00
      ENDIF

      RETURN
      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      SUBROUTINE shuffle ( ns, w0, x0, w, x )

      IMPLICIT NONE
      INTEGER ns, index(100), idum, i, j, k, m
      DOUBLE PRECISION r(100), RAN1, rtemp, 
     &                 w(100), x(100,100), w0(100), x0(100,100)
      COMMON/I/ idum
      EXTERNAL RAN1
      SAVE

      DO i = 1, ns
        r(i) = RAN1(idum)
      END DO

      DO j = 1 , ns
        rtemp = r(1)
        k = 1
        DO i = 2, ns
          IF ( r(i) .gt. rtemp ) THEN
            k = i
            rtemp = r(i)
          ENDIF
        END DO
        index(k) = j
        r(k) = 0.0
      END DO

      DO i = 1, ns
        w(i) = w0( index(i) )
        DO j = 1, ns
          x(i,j) = x0( index(i),index(j) )
        END DO
      END DO

      RETURN
      END

       

      
