**==alngam.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
      DOUBLE PRECISION FUNCTION ALNGAM(YY)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c	Natural logarithm of the gamma FUNCTION of X
c
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE 
      PI = 4.0D+00*DATAN(1.0D+00)
      TWOPI = 2.0D+00*PI
      X = YY
      Z = 0.0
 100  IF ( X.GE.1.5 ) THEN
         X2 = X*X
         X3 = X2*X
         X5 = X2*X3
         X7 = X2*X5
         ALNGAM = -Z + (X-0.5)*LOG(X) - X + 0.5*LOG(TWOPI)
     &            + 1.0/(12.0*X) - 1.0/(360.0*X3) + 1.0/(1260.0*X5)
     &            - 1.0/(1680.0*X7)
      ELSE
         ALNGAM = 0.0
         IF ( X.GT.0.0 ) THEN
            Z = Z + LOG(X)
            X = X + 1.0
            GOTO 100
         ENDIF
      ENDIF
 200  RETURN
      END
      SUBROUTINE BOXLEV(DELE,JMAX,WE,IR,NMAX,zpe)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2002 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
C
C
C
C	CALCULATES ENERGY LEVELS FOR PARTICLE-IN-A-BOX TO BE USED
C          WITH STERAB
C
c	DELE	= energy grain
c	JMAX	= index of Emax
c	WE	= vibration frequency (cm-1)
c	IR	= vector of energy level indices
c	NMAX	= ceiling of array
c       zpe     = zero point energy (cm-1)
c
c	E = WE*n^2  for n=1,2,3,...
C
C     OUTPUT ENERGIES IN WAVENUMBERS, relative to ZPE = WE
C
c    2/02 counted as vibs in Whitten-Rabinovitch
c         parameter calculations.
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      EXTERNAL STERAB , GAM , WRAB , WRDEN , ALNGAM
      DIMENSION IR(20001)
      SAVE 
 
      RMAX = SQRT(JMAX*DELE/WE)                           ! Maximum bound level
      NMAX = INT(RMAX) + 1
      IF ( NMAX.GT.20001 ) NMAX = 20001
      zpe = WE                                            ! Zero point energy
      DO 100 I = 1 , NMAX
        v2 = DBLE(I+1)*DBLE(I+1)                          ! "zero" level = 1, start loop at I+1=2
        R = (WE*v2 - zpe)/DELE                            ! Relative to zpe = WE
c        IR(I) = INT(R) + 1                                ! Truncate: number of grains
        IR(I) = IDNINT(R)                                 ! Nearest integer: number of grains
 100  CONTINUE

      RETURN
      END

      Subroutine chkdens(Egrain1,Imax1,Isize,Emax2,bestImax)

      INCLUDE 'declare.inc'
      INTEGER bestImax(6), Imax1, Isize, x
      Double precision Emax2, Egrain1
      
      x=1
      DO i=1,6
       bestImax(i)=0
      ENDDO

      DO i=INT(Emax2/Egrain1), 2, -1    ! Isize= INT(Emax2/Egrain1)+1
       if(Dens(i-1).lt.1E-2) goto 100
       err=ABS((Dens(i)-Dens(i-1))/Dens(i-1))*100
!      write(*,*) i,err
       IF(i.eq.INT(Emax2/Egrain1)) then
         if(err.gt.1.and.err.lt.2) then
           WRITE(*,*) " WARNING: Density fluctuation at Emax2 > 1%."
           bestImax(1)=INT(Emax2/Egrain1)
           x=2
         elseif(err.gt.2.and.err.lt.3) then
           WRITE(*,*) " WARNING: Density fluctuation at Emax2 > 2%."
           bestImax(1)=INT(Emax2/Egrain1)
           bestImax(2)=INT(Emax2/Egrain1)
           x=3
         elseif(err.gt.3.and.err.lt.4) then
           WRITE(*,*) " WARNING: Density fluctuation at Emax2 > 4%."
           bestImax(1)=INT(Emax2/Egrain1)
           bestImax(2)=INT(Emax2/Egrain1)
           bestImax(3)=INT(Emax2/Egrain1)
           x=4
         elseif(err.gt.4.and.err.lt.5) then
           WRITE(*,*) " WARNING: Density fluctuation at Emax2 > 4%."
           bestImax(1)=INT(Emax2/Egrain1)
           bestImax(2)=INT(Emax2/Egrain1)
           bestImax(3)=INT(Emax2/Egrain1)
           bestImax(4)=INT(Emax2/Egrain1)
           x=5
         elseif(err.gt.5) then
           WRITE(*,*) " WARNING: Density fluctuation at Emax2 > 5%."
           bestImax(1)=INT(Emax2/Egrain1)
           bestImax(2)=INT(Emax2/Egrain1)
           bestImax(3)=INT(Emax2/Egrain1)
           bestImax(4)=INT(Emax2/Egrain1)
           bestImax(5)=INT(Emax2/Egrain1)
           return
         endif

       ENDIF

       IF(err.gt.x) then              ! Error > 1%-5%
        bestImax(x)=i
!     bestImax(1): error< 1%, bestImax(2): error< 2%, bestImax(3): error< 3%
!     bestImax(4): error< 4%, bestImax(5): error< 5%
        x=x+1
        if(x.eq.6) goto 100
       ENDIF
      

      ENDDO
      WRITE(*,*) "Wrong definition of energy parameters"
      STOP

100   IF(Imax1.lt.bestImax(5)) THEN
       WRITE(*,'(A45,I6)')" WARNING: Miminum suggested value for Imax1:"
     & , bestImax(5)
      ENDIF
      return
 

      END SUBROUTINE

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful, 
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      PROGRAM DenSum  

      INCLUDE 'declare.inc'
      DOUBLE PRECISION WOBS, E
      INTEGER lenstr       !Added JP 10/03
      CHARACTER TITLE*180 , FNAME*10, VHAR*4, OBS*3, HAR*3, Arg*10
      CHARACTER bestImaxTXT*6
      CHARACTER readline*100, filename*20
      PARAMETER ( OBS='OBS' , HAR='HAR' )
      INTEGER bestImax(6)
      CHARACTER AVERSION*6, ADATE*12, cut*46 , keyword*4 , VROT*4
      DIMENSION keyword(2)
      PARAMETER ( AVERSION='2010', ADATE='Jan 2010' )
      PARAMETER (cut='**************INPUT DATA SUMMARY**************')
      EXTERNAL MORLEV , STERAB , GAM , WRAB , WRDEN , ALNGAM , BOXLEV
 
      SAVE 

      call GETARG(1,Arg)
      Arg=Arg(1:lnblnk(Arg))
      IF(Arg.eq."-batch".or.Arg.eq."-BATCH".or.Arg.eq."-Batch") THEN
       Arg="BATCH"
       OPEN(unit=1,file='densum.batch',status='old')
       READ(1,*) Egrain1, Imax1, Isize, Emax2
c       ELSE
c40      write(*,*) "densum.batch not found"
c        STOP
      ENDIF
 
      DO 

       IF(Arg.eq."BATCH") THEN

       READ(1,'(A100)',END=10) readline
       filename=readline(1:lnblnk(readline))
       IF(readline(1:lnblnk(readline)).eq.'') goto 450
       OPEN(unit=5,file=filename,err=50,status='old')  
       GOTO 51
50     WRITE(*,*) 
       WRITE(*,*) "File ",filename(1:lnblnk(filename))," not found"
       WRITE(*,*) 
       GOTO 450
51     OPEN(unit=2,file='densum.dat',status='unknown')
       DO i=1,3
        READ(5,'(A100)') readline
        WRITE(2,*) readline(1:lnblnk(readline))
       ENDDO
       READ(5,*)
       WRITE(2,*) Egrain1, Imax1, Isize, Emax2
       DO 
        READ(5,'(A100)',END=20) readline
        WRITE(2,*) readline(1:lnblnk(readline))
       ENDDO
20    CLOSE(5)
      REWIND(2)

       ELSE

       OPEN (UNIT=2,STATUS='OLD',FILE='densum.dat')              ! Data file 

      ENDIF

      OPEN (UNIT=3,STATUS='UNKNOWN',FILE='densum.out')  ! Full output
 
      WRITE (3,99016) AVERSION , ADATE ,  AVERSION , ADATE
      READ (2,99017) TITLE
      WRITE (3,99017) TITLE
      READ (2,*) FNAME
      WRITE (3,99023) FNAME
      OPEN(UNIT=4,STATUS='UNKNOWN',FILE=FNAME(1:lenstr(fname))//'.dens')
                                                                ! Succinct output for MultiWell input
      WRITE (4,99030) cut                                       ! Start of data summary block in ____.dens file
      WRITE (4,99016) AVERSION , ADATE ,  AVERSION , ADATE


c
c  VHAR  = 'HAR': for vibrational frequencies input as harmonic freqs.
c        = 'OBS': for vibrational frequencies input as 0-1 observed freqs.
c
      READ (2,*) N , IWR , (keyword(i),i=1,2) ! N=no. of DoF;IWR=0,1 for Stein/Rab or Whitten/Rab

c     KEYWORDS:
c          VHAR = 'HAR' for harmonic vibs, 
c       or VHAR = 'OBS' FOR observed (0-1 transitions)
c      and, for qro and rot types [NOT hindered rotor types]:
c          VROT = 'AMUA' for moment of inertia in units of amu*Ang^2
c       or      = 'GMCM' for moment of inertia units of gram*cm^2
c       or      = 'CM-1' for rotational constant in units of cm^-1
c       or      = 'MHZ' for rotational constant in units of MHz
c         
         DO ki = 1 , 2
           IF ( keyword(ki) .EQ. 'HAR' .OR. keyword(ki) .EQ. 'har' .OR.
     &          keyword(ki) .EQ. 'Har' ) THEN
             VHAR = 'HAR'
           ELSEIF ( keyword(ki) .EQ. 'OBS' .OR. keyword(ki) .EQ. 'obs'
     &         .OR. keyword(ki) .EQ. 'Obs' ) THEN
             VHAR = 'OBS'
           ELSEIF ( keyword(ki) .EQ. 'AMUA' .OR. 
     &              keyword(ki) .EQ. 'amua' )THEN
             VROT = 'AMUA'
           ELSEIF ( keyword(ki) .EQ. 'GMCM' .OR. 
     &              keyword(ki) .EQ. 'gmcm' )THEN
             VROT = 'GMCM'
           ELSEIF ( keyword(ki) .EQ. 'CM-1' .OR. 
     &              keyword(ki) .EQ. 'cm-1' )THEN
             VROT = 'CM-1'
           ELSEIF ( keyword(ki) .EQ. 'MHZ' .OR. 
     &              keyword(ki) .EQ. 'mhz' .OR. 
     &              keyword(ki) .EQ. 'MHz' .OR. 
     &              keyword(ki) .EQ. 'Mhz' )THEN
             VROT = 'MHZ'
           ELSEIF ( keyword(ki) .EQ. 'GHZ' .OR. 
     &              keyword(ki) .EQ. 'ghz' .OR. 
     &              keyword(ki) .EQ. 'GHz' .OR. 
     &              keyword(ki) .EQ. 'Ghz' )THEN
             VROT = 'GHZ'
           ELSE
             write(*,*) 'FATAL: unknown keyword: ', keyword(ki)
             STOP
           ENDIF
         END DO


      IF(Arg.eq."BATCH") THEN
       READ (2,*) 
      ELSE
       READ (2,*) Egrain1 , imax1 , Isize , Emax2
      ENDIF
 
      IF (Emax2/Egrain1 .GT. NMAX) THEN
        WRITE(*,*) '****Grain Size Too Small****'
        STOP
      ENDIF

      Emax1 = Egrain1*(imax1-1)
      Egrain2 = Emax2/(Isize-imax1-1)
      imax2 = Isize - imax1
 
      JMAX = 1 + INT(Emax2/Egrain1)
      JMAX = MIN(JMAX,NMAX)
 
      WRITE (3,99008)
      WRITE (4,99008)
 
      Viblo = 10000.
      SS = 0.0d+00 
      SUM2 = 0.0d+00 
      ALNSUM = 0.0d+00 
      NV = 0 
      NROTS = 0 
      NZ = 0 
      ZPE = 0.0d+00 
      DO 100 I = 1 , N
         READ (2,*) MODE(I) , IDOF(I) , WE(I) , ANH(I) , NG(I)
 
	    IF ( WE(I) .LT. 0.0 ) THEN
           OPEN( 7, status='UNKNOWN', file='densum.ERROR')
		 WRITE(*,*) '***FATAL: WE(i) negative value: ', WE(I)
		 WRITE(7,*) '***FATAL: WE(I) negative value: ', WE(I)
		 STOP
	    ENDIF
     
         IF ( IDOF(I).EQ.VIB ) THEN                                   ! Vibration: Evib = WE(v+1/2) + ANH*(v+1/2)^2
            Viblo = MIN(Viblo,WE(I))         ! lowest vib frequency
            IF ( VHAR .EQ. HAR ) THEN
              WOBS = WE(I)+2.*ANH(I)         ! WOBS = observed freq
            ELSEIF ( VHAR .EQ. OBS ) THEN
              WOBS = WE(I)
              WE(I)= WE(I)-2.*ANH(I)         ! Convert WE to harmonic frequency
            ENDIF
            WRITE (3,99002) MODE(I) , WOBS , WE(I) , ANH(I) , NG(I)
            WRITE (4,99002) MODE(I) , WOBS , WE(I) , ANH(I) , NG(I)
            NV = NV + NG(I) 
            zzpe(I) = 0.5d+00*WE(I) + 0.25d+00*ANH(I)
            SS = SS + NG(I)*zzpe(I) 
            SUM2 = SUM2 + NG(I)*4.0*zzpe(I)**2 
            ALNSUM = ALNSUM + NG(I)*LOG(2.0*zzpe(I)) 
         ELSEIF ( IDOF(I).EQ.BOX ) THEN                               ! Particle-in-a-Box Vibration: Evib = WE*v^2
            Viblo = MIN(Viblo,WE(I))         ! lowest vib frequency
            IF ( VHAR .EQ. HAR ) THEN
              WOBS = 3.d+00*WE(I)            ! WOBS = observed freq
            ELSEIF ( VHAR .EQ. OBS ) THEN
              WOBS = WE(I)
              WE(I)= WE(I)/3.0d+00           ! Convert WE to frequency
            ENDIF
            WRITE (3,99022) MODE(I) , WOBS , WE(I) , NG(I)
            WRITE (4,99022) MODE(I) , WOBS , WE(I) , NG(I)
            NV = NV + NG(I)                                
            zzpe(I) = WOBS/2.d+00 
            SS = SS + NG(I)*zzpe(I)              
            SUM2 = SUM2 + NG(I)*9.d+00*zzpe(I)**2 
            ALNSUM = ALNSUM + NG(I)*LOG(3.d+00*zzpe(I)) 
         ELSEIF ( IDOF(I).EQ.KRO ) THEN                               ! 1-dim. K-rotor
            AMOM(I) = WE(I)                     ! moment of inertia
            call rotunits( VROT , AMOM(I) )     ! unit conversion
            B(I) = 16.85763D+00/AMOM(I)         ! rotational constant (cm-1)
            WRITE (3,99051) MODE(I) , WE(I) , ANH(I) , NG(I) , B(I)
            WRITE (4,99051) MODE(I) , WE(I) , ANH(I) , NG(I) , B(I)
            NROTS = NROTS + 1 
            IF ( ANH(I).LE.0 ) THEN
               WRITE (3,99006)
               WRITE (4,99006)
               STOP
            ENDIF
         ELSEIF ( IDOF(I).EQ.QRO ) THEN                               ! Quantized rotor
            AMOM(I) = WE(I)                     ! moment of inertia
            call rotunits( VROT , AMOM(I) )     ! unit conversion
            B(I) = 16.85763D+00/AMOM(I)         ! rotational constant (cm-1)
            WRITE (3,99005) MODE(I) , AMOM(I) , ANH(I) , NG(I) , B(I)
            WRITE (4,99005) MODE(I) , AMOM(I) , ANH(I) , NG(I) , B(I)
            NROTS = NROTS + 1 
            IF ( ANH(I).LE.0 ) THEN
               WRITE (3,99006)
               WRITE (4,99006)
               STOP
            ENDIF
         ELSEIF ( IDOF(I).EQ.ROT ) THEN                               ! Classical rotor
            AMOM(I) = WE(I)                     ! moment of inertia
            call rotunits( VROT , AMOM(I) )     ! unit conversion
            B(I) = 16.85763D+00/AMOM(I)         ! rotational constant (cm-1)
            WRITE (3,99003) MODE(I) , AMOM(I) , ANH(I) , NG(I) , B(I)
            WRITE (4,99003) MODE(I) , AMOM(I) , ANH(I) , NG(I) , B(I)
            NROTS = NROTS + 1 
            IF ( ANH(I).LE.0 ) THEN
               WRITE (3,99006)
               WRITE (4,99006)
               STOP
            ENDIF
         ELSEIF ( IDOF(I).EQ.HRA ) THEN         ! INPUT MOMENT & VIB FREQ   Hindered rotor
            IF ( NG(I) .LT. 0) THEN
                READ(2,*) NSIG(I)
                NG(I) = -NG(I)
              ELSE
                NSIG(I) = NG(I)
            ENDIF
            W(I) = WE(I)                        ! small vibration frequency
            Viblo = MIN(Viblo,W(I))             ! lowest vib frequency
            AMOM(I) = ANH(I)                    ! moment of inertia
            call rotunits( VROT , AMOM(I) )     ! unit conversion
            B(I) = 16.85763D+00/AMOM(I)         ! rotational constant (cm-1)
            VV(I) = ((W(I)/NG(I))**2)/B(I)      ! hindrance barrier (cm-1)
            WRITE (3,99004) MODE(I) , W(I) , AMOM(I) , NG(I) , NSIG(I) , 
     &             B(I) , VV(I)                         ! Hindered rotor (extended Troe method)
            WRITE (4,99004) MODE(I) , W(I) , AMOM(I) , NG(I) , NSIG(I) , 
     &             B(I) , VV(I)                         ! Hindered rotor (extended Troe method)
            NV = NV + 1                                 
            zzpe(I) = W(I)/2.0d+00  
            SS = SS + zzpe(I) 
            SUM2 = SUM2 + 4.0*zzpe(I)**2 
            ALNSUM = ALNSUM + LOG(2.0*zzpe(I)) 
            IF ( ANH(I).LE.0 .OR. NG(I).EQ.0 ) THEN
               WRITE (3,99007)
               WRITE (4,99007)
               STOP
            ENDIF
         ELSEIF ( IDOF(I).EQ.HRB ) THEN         ! INPUT VIB FREQ & BARRIER   Hindered rotor
            IF ( NG(I) .LT. 0) THEN
                READ(2,*) NSIG(I)
                NG(I) = -NG(I)
              ELSE
                NSIG(I) = NG(I)
            ENDIF
            W(I) = WE(I)                        ! small vibration frequency
            Viblo = MIN(Viblo,W(I))             ! lowest vib frequency
            VV(I) = ANH(I)                      ! hindrance barrier (cm-1)
            IF (VV(I) .LT. 1.0d-05) THEN
              WRITE(*,*)
     &        'Rotation barrier too small. Hit RETURN to terminate' 
              STOP
            ENDIF
            B(I) = ((W(I)/NG(I))**2)/VV(I)      ! rotational constant (cm-1)
            AMOM(I) = 16.85763D+00/B(I)         ! moment of inertia (amu*ang^2)
            WRITE (3,99004) MODE(I) , W(I) , AMOM(I) , NG(I) , NSIG(I) ,
     &             B(I) , VV(I)                         ! Hindered rotor (extended Troe method)
            WRITE (4,99004) MODE(I) , W(I) , AMOM(I) , NG(I) , NSIG(I) ,
     &             B(I) , VV(I)                         ! Hindered rotor (extended Troe method)
            NV = NV + 1                                  
            zzpe(I) = W(I)/2.0d+00   
            SS = SS + zzpe(I)  
            SUM2 = SUM2 + 4.0*zzpe(I)**2  
            ALNSUM = ALNSUM + LOG(2.0*zzpe(I))  
            IF ( ANH(I).LE.0 .OR. NG(I).LE.0 ) THEN
               WRITE (3,99007)
               WRITE (4,99007)
               STOP
            ENDIF

CCC................

         ELSEIF ( IDOF(I).EQ.HRC ) THEN         ! INPUT MOMENT & BARRIER   Hindered rotor
            IF ( NG(I) .LT. 0) THEN
                READ(2,*) NSIG(I)
                NG(I) = -NG(I)
              ELSE
                NSIG(I) = NG(I)
            ENDIF
            AMOM(I) = WE(I)                     ! moment of inertia (amu*ang^2)
            call rotunits( VROT , AMOM(I) )     ! unit conversion
            B(I) = 16.85763D+00/AMOM(I)         ! rotational constant (cm-1)
            VV(I) = ANH(I)                      ! hindrance barrier (cm-1)
            W(I) = NG(I)*SQRT(B(I)*VV(I))       ! small vibration frequency
            Viblo = MIN(Viblo,W(I))             ! lowest vib frequency
            WRITE (3,99004) MODE(I) , W(I) , AMOM(I) , NG(I) , NSIG(I) ,
     &             B(I) , VV(I)                         ! Hindered rotor (extended Troe method)
            WRITE (4,99004) MODE(I) , W(I) , AMOM(I) , NG(I) , NSIG(I) ,
     &             B(I) , VV(I)                         ! Hindered rotor (extended Troe method)
            NV = NV + 1                                  
            zzpe(I) = W(I)/2.0d+00   
            SS = SS + zzpe(I)  
            SUM2 = SUM2 + 4.0*zzpe(I)**2  
            ALNSUM = ALNSUM + LOG(2.0*zzpe(I))  
            IF ( ANH(I).LE.0 .OR. NG(I).EQ.0 ) THEN
               WRITE (3,99007)
               WRITE (4,99007)
               STOP
            ENDIF

CCC...............

	ELSEIF ( IDOF(I).EQ.HRD ) THEN	! non-rigid, unsymmetrical hindered rotor
		NSIG(I)=NG(I)	! rotational symmetry number
		NCV(I)=INT(WE(I))	! number of coefficients in rot. potential energy function  
		NCB(I)=INT(ANH(I))	! number of coefficients in rot. constant
 
		READ(2,*) Vhr(I), NSV(I), Phav(I), (CV(I,Iv), Iv=1, NCV(I))     ! always cm-1 units
		READ(2,*) Bhr(I), NSB(I), Phab(I), (CB(I,Ib), Ib=1, NCB(I))

		IF((Bhr(I).EQ.'Bhrd1').OR.(Bhr(I).EQ.'BHRD1')) THEN             ! always cm-1 units

		WRITE (3,99040) MODE(I), Vhr(I), Bhr(I) 
		WRITE(3,99041) NSV(I), Phav(I), (CV(I,Iv), Iv=1, NCV(I))
		WRITE(3,99042) NSB(I), Phab(I), (CB(I,Ib), Ib=1, NCB(I))

                WRITE (4,99040) MODE(I), Vhr(I), Bhr(I)
                WRITE(4,99041) NSV(I), Phav(I), (CV(I,Iv), Iv=1, NCV(I))
                WRITE(4,99042) NSB(I), Phab(I), (CB(I,Ib), Ib=1, NCB(I))
		ELSEIF((Bhr(I).EQ.'Ihrd1').OR.(Bhr(I).EQ.'IHRD1')) THEN          ! always amu*Ang^2 units
                WRITE (3,99040) MODE(I), Vhr(I), Bhr(I)
                WRITE(3,99041) NSV(I), Phav(I), (CV(I,Iv), Iv=1, NCV(I))
                WRITE(3,99043) NSB(I), Phab(I), (CB(I,Ib), Ib=1, NCB(I))

                WRITE (4,99040) MODE(I), Vhr(I), Bhr(I)
                WRITE(4,99041) NSV(I), Phav(I), (CV(I,Iv), Iv=1, NCV(I))
                WRITE(4,99043) NSB(I), Phab(I), (CB(I,Ib), Ib=1, NCB(I))
		ELSE
		write(*,*) "ERROR at INPUT for Bhr/Ihr"
		ENDIF


CCC..............

         ELSEIF ( IDOF(I) .EQ. TRN ) THEN                 ! RELATIVE TRANSLATION
            AMOM(I) = WE(I)*ANH(I)/( WE(I) + ANH(I) )     ! reduced mass (amu)
            WRITE (3,99021) MODE(I) , WE(I) , ANH(I), AMOM(I)
            WRITE (4,99021) MODE(I) , WE(I) , ANH(I), AMOM(I)
            IF ( NG(I).LE.0 .OR. NG(I).GT.3 ) THEN
               WRITE (3,99022)
               STOP
            ENDIF

         ELSE
          write( 3,*) IDOF(I)
          write( 4,*) IDOF(I)
          WRITE(*,*) 'FATAL ERROR: unrecognized dof-type: ',IDOF(I)

         ENDIF
 
 100  CONTINUE
 
      WRITE (4,99030) cut       ! End of data summary block in ____.dens file
      
      
      ZPE = SS 
      SS = 2.0d+00*SS 
      BETA = (NV-1)*(NV+0.5*NROTS)*SUM2/(NV*SS**2) 
      AVENUE = EXP(ALNSUM/NV) 
C
C     CALCULATE SUMS AND DENSITIES
C
      WRITE (*,99019)
      IF ( IWR.EQ.0 ) THEN              ! Exact counts
         CALL STERAB(N,JMAX,Egrain1)
      ELSEIF ( IWR.EQ.1 ) THEN          ! Whitten-Rabinovitch approximation
         CALL WRAB(NV,NROTS,ZPE,BETA,AVENUE,JMAX,Egrain1,SUM,DENS)
      ENDIF
c
c
c      Check density
c
      call chkdens(Egrain1,Imax1,Isize,Emax2,bestImax)
c
c
c	Write out results
c
c
c      Succinct output for MultiWell input
 
      WRITE (4,*) FNAME(1:lenstr(fname))
      IF(Imax1.lt.bestImax(5)) THEN
       WRITE (4,'(A15,A49,I6)') TITLE(1:lnblnk(TITLE)),
     & "  --  WARNING. Miminum suggested value for Imax1:",bestImax(5)
      ELSE
       WRITE (4,'(A50)') TITLE
      ENDIF
      WRITE (4,99001) Egrain1 , imax1 , Emax2 , Isize , Viblo
 
      IF ( IWR.EQ.0 ) THEN
         WRITE (3,99012) Egrain1
                                ! Exact Counts
      ELSE
         WRITE (3,99013)        ! Whitten-Rabinovitch
      ENDIF

      WRITE (3,99020) NV , NROTS , ZPE , AVENUE , BETA

      x=0
      WRITE(3,*) " Density fluctuations %       Imax1       E(cm-1)"
      DO i=1,5
         if (bestImax(i).ne.INT(Emax2/Egrain1)) then
          E=(bestImax(i)-1)*Egrain1
         else
          E=Emax2
         endif
!      IF(bestImax(i).ne.0) THEN
        IF(Imax1.ge.bestImax(i).AND.x.lt.1) THEN
         x=x+1
         WRITE(3,'(A10,I2,A18,I6,A6,F8.1,A12)') "          ",i,
     &"%                 ", bestImax(i), "      ", E, "  <- Current"
          ELSE
           IF(bestImax(i).eq.INT(Emax2/Egrain1)) then
           WRITE(3,'(A10,I2,A18,I6,A6,F8.1,A12)') "          ",i,
     &"%                >", bestImax(i), "     >", E
           ELSE
           WRITE(3,'(A10,I2,A18,I6,A6,F8.1,A12)') "          ",i,
     &"%                 ", bestImax(i), "      ", E
           ENDIF 
        ENDIF
!      ENDIF
      ENDDO
       WRITE(3,*)
      IF(Imax1.lt.bestImax(5)) THEN
       WRITE (3,*) "WARNING: the current density fluctuation at Imax1 is
     & larger the 5%."
       WRITE (3,'(A35,I6)') " Miminum suggested value for Imax1:",
     & bestImax(5)
       WRITE(3,*)
       DO i=1,5
        IF(bestImax(i).eq.INT(Emax2/Egrain1).AND.
     &   bestImax(i+1).le.INT(Emax2/Egrain1)) then 
       WRITE(3,'(A57,I2,A2)')" WARNING: the density fluctuation at Emax2
     & is larger than",i," %."
         WRITE (3,*) "Increase Emax2"
        ENDIF
       ENDDO
       WRITE(3,*)
       WRITE(3,*)
      ENDIF
 
      WRITE (3,99011)
      WRITE (4,99010)
 
      DO 200 i = 1 , imax1
         E = (i-1)*Egrain1
         WRITE (4,99014) i , E , DENS(i) , SUM(i)
 200  CONTINUE
 
      DO 300 i = imax1 + 1 , Isize
         E = (i-imax1-1)*Egrain2
         j = INT(E/Egrain1) + 1
         WRITE (4,99014) i , E , DENS(j) , SUM(j)
 300  CONTINUE
 
      DO 400 i = 1 , JMAX
         E = (i-1)*Egrain1
         WRITE (3,99015) i , E , DENS(i) , SUM(i)
 400  CONTINUE
 
99001 FORMAT (1x,f10.1,1x,I10,1x,f10.1,1x,I10,1x,f10.1)
99002 FORMAT (I5,2X,'Vibrator',2x,'Freq(0-1)=',F8.2,2x,
     &        'Freq(har)=',F8.2,2x,'Anh(cm-1)=',F8.2,2X,
     &        'g =',I2)
99022 FORMAT (I5,2X,'P-in-Box',2x,'Freq(0-1)=',F8.2,2x,
     &        'Freq.Param.=',F8.2,2x,'g =',I2)
99003 FORMAT (I5,2X,'Clas.Rot',2x,'AmuAng^2 =',F8.2,2x,'Symm =',F4.0,2x,
     &        ' dim =',I2,2x,'B =',F8.4,' cm-1')
99004 FORMAT (I5,2X,'Hind.Rot',2x,'Freq(har)=',F8.2,2x,'Mom=',F8.3,2x,
     &       'fold=',I2,2x,'symm=',I2,2x,'B=',F8.4,' cm-1',2x,
     &        'Uo=',F7.1,' cm-1')
99005 FORMAT (I5,2X,'Quan.Rot',2x,'AmuAng^2 =',F8.2,2x,'Symm =',F4.0,2x,
     &        ' dim =',I2,2x,'B =',F8.4,' cm-1')
99051 FORMAT (I5,2X,'K-rotor ',2x,'AmuAng^2 =',F8.2,2x,'Symm =',F4.0,2x,
     &        ' J   =',I2,2x,'B =',F8.4,' cm-1')
99006 FORMAT (//'Rotor symmetry number must be greater than zero')
99007 FORMAT (//'Hindered rotor parameters incomplete')
99008 FORMAT (//'Degrees of Freedom'/)
99009 FORMAT (/'  No.  Freq(cm-1)  ANH(cm-1)      Degeneracy'/)
99010 FORMAT ('       No.     (cm-1)   Density   Sum')
99011 FORMAT ('       No.     (cm-1)   Density     Sum')
99012 FORMAT (//'Stein-Rabinovitch Method (grain =',F6.1,' cm-1)'//)
99013 FORMAT (//'Whitten-Rabinovitch Method'//)
99014 FORMAT (i10,1x,f10.1,2(1x,1pe10.3))
99015 FORMAT (i10,1x,f10.1,2(1x,1pe12.5))
99016 FORMAT (
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'                                John R. Barker'/8x,
     &'        DenSum-',A6,'           University of Michigan'/8x,
     &'                                Ann Arbor, MI 48109-2143'/8x,
     &'        ',A8,'                jrbarker@umich.edu'/8x,
     &'                                (734) 763 6239'//8x,
     &'      http://aoss.engin.umich.edu/multiwell/'//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'Suggested Literature Citation:'//8x,
     &'a) MultiWell-',A6,' Software, ',A8,', designed and'/11x,
     &'maintained by J.R. Barker with contributors N.F. Ortiz,'/11x,
     &'J.M. Preses, L.L. Lohr, A. Maranzana, P.J. Stimac, T. L.'/11x,
     &'Nguyen, and T. J. Dhilip Kumar, University of Michigan,'/11x,
     &'Ann Arbor, MI; http://aoss.engin.umich.edu/multiwell/',//8x,
     &'b) J.R. Barker, Int. J. Chem. Kinetics, 33, 232-45 (2001)',//8x,
     &//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'/)
99017 FORMAT (A180)
99018 FORMAT (A10)
99019 FORMAT (/'Calculating Densities')
99020 FORMAT (/'WHITTEN-RABINOVITCH PARAMETERS'/'   Vibrations:  ',I10/
     &        '   Rotations:   ',I10,/, '   Zero Point E:',f12.3,/
     &        ' Geo. Mean Freq:',f10.3,/'           Beta:',f10.3,//)
99021 FORMAT (I5,2X,'Translat',2x,'MolWt(A) =',F8.2,2x,'MolWt(B) =',
     &           F8.2,2x,'RedMass =',F8.2,1x,'g/mol')
99023 FORMAT (/A10)
99030 FORMAT (A46)
99040 FORMAT (I5,2X,'Non-Rigid Hind.Rot:',2x,
     &     'Vhr_Type = ',A5,';',1x,'Bhr/Ihr_Type = ',A5)
99041 FORMAT (8X,'Vhr: ',1x,'Symm. = ',I2,2x,'Phase (rad.) = ',F7.4,
     &     2x,'Coeff. (cm-1) = ',20(F10.4,1x))
99042 FORMAT (8X,'Bhr: ',1x,'Symm. = ',I2,2x,'Phase (rad.) = ',F7.4,
     &     2x,'Coeff. (cm-1) = ',20(F10.4,1x))
99043 FORMAT (8X,'Ihr: ',1x,'Symm. = ',I2,2x,'Phase (rad.) = ',F7.4,
     &  2x,'Coeff. (amu.A**2) = ',20(F10.4,1x))


      IF(Arg.ne."BATCH") GOTO 500
     
      CLOSE(2)
      ENDDO

450	write(*,*)

10    CLOSE(1)

500   END
      subroutine rs(nm,n,a,w,matz,z,fv1,fv2,ierr)
c
      integer n,nm,ierr,matz
      double precision a(nm,n),w(n),z(nm,n),fv1(n),fv2(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a real symmetric matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a.
c
c        a  contains the real symmetric matrix.
c
c        matz  is an integer variable set equal to zero if
c        only eigenvalues are desired.  otherwise it is set to
c        any non-zero integer for both eigenvalues and eigenvectors.
c
c     on output
c
c        w  contains the eigenvalues in ascending order.
c
c        z  contains the eigenvectors if matz is not zero.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for tqlrat
c           and tql2.  the normal completion code is zero.
c
c        fv1  and  fv2  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 if (matz .ne. 0) go to 20
c     .......... find eigenvalues only ..........
      call  tred1(nm,n,a,w,fv1,fv2)
*  tqlrat encounters catastrophic underflow on the Vax
*     call  tqlrat(n,w,fv2,ierr)
      call  tql1(n,w,fv1,ierr)
      go to 50
c     .......... find both eigenvalues and eigenvectors ..........
   20 call  tred2(nm,n,a,w,fv1,z)
      call  tql2(nm,n,w,fv1,z,ierr)
   50 return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine tql1(n,d,e,ierr)
c
      integer i,j,l,m,n,ii,l1,l2,mml,ierr
      double precision d(n),e(n)
      double precision c,c2,c3,dl1,el1,f,g,h,p,r,s,s2,tst1,tst2,pythag
c
c     this subroutine is a translation of the algol procedure tql1,
c     num. math. 11, 293-306(1968) by bowdler, martin, reinsch, and
c     wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 227-240(1971).
c
c     this subroutine finds the eigenvalues of a symmetric
c     tridiagonal matrix by the ql method.
c
c     on input
c
c        n is the order of the matrix.
c
c        d contains the diagonal elements of the input matrix.
c
c        e contains the subdiagonal elements of the input matrix
c          in its last n-1 positions.  e(1) is arbitrary.
c
c      on output
c
c        d contains the eigenvalues in ascending order.  if an
c          error exit is made, the eigenvalues are correct and
c          ordered for indices 1,2,...ierr-1, but may not be
c          the smallest eigenvalues.
c
c        e has been destroyed.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the j-th eigenvalue has not been
c                     determined after 30 iterations.
c
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      if (n .eq. 1) go to 1001
c
      do 100 i = 2, n
  100 e(i-1) = e(i)
c
      f = 0.0d0
      tst1 = 0.0d0
      e(n) = 0.0d0
c
      do 290 l = 1, n
         j = 0
         h = dabs(d(l)) + dabs(e(l))
         if (tst1 .lt. h) tst1 = h
c     .......... look for small sub-diagonal element ..........
         do 110 m = l, n
            tst2 = tst1 + dabs(e(m))
            if (tst2 .eq. tst1) go to 120
c     .......... e(n) is always zero, so there is no exit
c                through the bottom of the loop ..........
  110    continue
c
  120    if (m .eq. l) go to 210
  130    if (j .eq. 30) go to 1000
         j = j + 1
c     .......... form shift ..........
         l1 = l + 1
         l2 = l1 + 1
         g = d(l)
         p = (d(l1) - g) / (2.0d0 * e(l))
         r = pythag(p,1.0d0)
         d(l) = e(l) / (p + dsign(r,p))
         d(l1) = e(l) * (p + dsign(r,p))
         dl1 = d(l1)
         h = g - d(l)
         if (l2 .gt. n) go to 145
c
         do 140 i = l2, n
  140    d(i) = d(i) - h
c
  145    f = f + h
c     .......... ql transformation ..........
         p = d(m)
         c = 1.0d0
         c2 = c
         el1 = e(l1)
         s = 0.0d0
         mml = m - l
c     .......... for i=m-1 step -1 until l do -- ..........
         do 200 ii = 1, mml
            c3 = c2
            c2 = c
            s2 = s
            i = m - ii
            g = c * e(i)
            h = c * p
            r = pythag(p,e(i))
            e(i+1) = s * r
            s = e(i) / r
            c = p / r
            p = c * d(i) - s * g
            d(i+1) = h + s * (c * g + s * d(i))
  200    continue
c
         p = -s * s2 * c3 * el1 * e(l) / dl1
         e(l) = s * p
         d(l) = c * p
         tst2 = tst1 + dabs(e(l))
         if (tst2 .gt. tst1) go to 130
  210    p = d(l) + f
c     .......... order eigenvalues ..........
         if (l .eq. 1) go to 250
c     .......... for i=l step -1 until 2 do -- ..........
         do 230 ii = 2, l
            i = l + 2 - ii
            if (p .ge. d(i-1)) go to 270
            d(i) = d(i-1)
  230    continue
c
  250    i = 1
  270    d(i) = p
  290 continue
c
      go to 1001
c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........
 1000 ierr = l
 1001 return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      subroutine tql2(nm,n,d,e,z,ierr)
c
      integer i,j,k,l,m,n,ii,l1,l2,nm,mml,ierr
      double precision d(n),e(n),z(nm,n)
      double precision c,c2,c3,dl1,el1,f,g,h,p,r,s,s2,tst1,tst2,pythag
c
c     this subroutine is a translation of the algol procedure tql2,
c     num. math. 11, 293-306(1968) by bowdler, martin, reinsch, and
c     wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 227-240(1971).
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a symmetric tridiagonal matrix by the ql method.
c     the eigenvectors of a full symmetric matrix can also
c     be found if  tred2  has been used to reduce this
c     full matrix to tridiagonal form.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        d contains the diagonal elements of the input matrix.
c
c        e contains the subdiagonal elements of the input matrix
c          in its last n-1 positions.  e(1) is arbitrary.
c
c        z contains the transformation matrix produced in the
c          reduction by  tred2, if performed.  if the eigenvectors
c          of the tridiagonal matrix are desired, z must contain
c          the identity matrix.
c
c      on output
c
c        d contains the eigenvalues in ascending order.  if an
c          error exit is made, the eigenvalues are correct but
c          unordered for indices 1,2,...,ierr-1.
c
c        e has been destroyed.
c
c        z contains orthonormal eigenvectors of the symmetric
c          tridiagonal (or full) matrix.  if an error exit is made,
c          z contains the eigenvectors associated with the stored
c          eigenvalues.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the j-th eigenvalue has not been
c                     determined after 30 iterations.
c
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      if (n .eq. 1) go to 1001
c
      do 100 i = 2, n
  100 e(i-1) = e(i)
c
      f = 0.0d0
      tst1 = 0.0d0
      e(n) = 0.0d0
c
      do 240 l = 1, n
         j = 0
         h = dabs(d(l)) + dabs(e(l))
         if (tst1 .lt. h) tst1 = h
c     .......... look for small sub-diagonal element ..........
         do 110 m = l, n
            tst2 = tst1 + dabs(e(m))
            if (tst2 .eq. tst1) go to 120
c     .......... e(n) is always zero, so there is no exit
c                through the bottom of the loop ..........
  110    continue
c
  120    if (m .eq. l) go to 220
  130    if (j .eq. 30) go to 1000
         j = j + 1
c     .......... form shift ..........
         l1 = l + 1
         l2 = l1 + 1
         g = d(l)
         p = (d(l1) - g) / (2.0d0 * e(l))
         r = pythag(p,1.0d0)
         d(l) = e(l) / (p + dsign(r,p))
         d(l1) = e(l) * (p + dsign(r,p))
         dl1 = d(l1)
         h = g - d(l)
         if (l2 .gt. n) go to 145
c
         do 140 i = l2, n
  140    d(i) = d(i) - h
c
  145    f = f + h
c     .......... ql transformation ..........
         p = d(m)
         c = 1.0d0
         c2 = c
         el1 = e(l1)
         s = 0.0d0
         mml = m - l
c     .......... for i=m-1 step -1 until l do -- ..........
         do 200 ii = 1, mml
            c3 = c2
            c2 = c
            s2 = s
            i = m - ii
            g = c * e(i)
            h = c * p
            r = pythag(p,e(i))
            e(i+1) = s * r
            s = e(i) / r
            c = p / r
            p = c * d(i) - s * g
            d(i+1) = h + s * (c * g + s * d(i))
c     .......... form vector ..........
            do 180 k = 1, n
               h = z(k,i+1)
               z(k,i+1) = s * z(k,i) + c * h
               z(k,i) = c * z(k,i) - s * h
  180       continue
c
  200    continue
c
         p = -s * s2 * c3 * el1 * e(l) / dl1
         e(l) = s * p
         d(l) = c * p
         tst2 = tst1 + dabs(e(l))
         if (tst2 .gt. tst1) go to 130
  220    d(l) = d(l) + f
  240 continue
c     .......... order eigenvalues and eigenvectors ..........
      do 300 ii = 2, n
         i = ii - 1
         k = i
         p = d(i)
c
         do 260 j = ii, n
            if (d(j) .ge. p) go to 260
            k = j
            p = d(j)
  260    continue
c
         if (k .eq. i) go to 300
         d(k) = d(i)
         d(i) = p
c
         do 280 j = 1, n
            p = z(j,i)
            z(j,i) = z(j,k)
            z(j,k) = p
  280    continue
c
  300 continue
c
      go to 1001
c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........
 1000 ierr = l
 1001 return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      subroutine tred1(nm,n,a,d,e,e2)
c
      integer i,j,k,l,n,ii,nm,jp1
      double precision a(nm,n),d(n),e(n),e2(n)
      double precision f,g,h,scale
c
c     this subroutine is a translation of the algol procedure tred1,
c     num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
c
c     this subroutine reduces a real symmetric matrix
c     to a symmetric tridiagonal matrix using
c     orthogonal similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the real symmetric input matrix.  only the
c          lower triangle of the matrix need be supplied.
c
c     on output
c
c        a contains information about the orthogonal trans-
c          formations used in the reduction in its strict lower
c          triangle.  the full upper triangle of a is unaltered.
c
c        d contains the diagonal elements of the tridiagonal matrix.
c
c        e contains the subdiagonal elements of the tridiagonal
c          matrix in its last n-1 positions.  e(1) is set to zero.
c
c        e2 contains the squares of the corresponding elements of e.
c          e2 may coincide with e if the squares are not needed.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      do 100 i = 1, n
         d(i) = a(n,i)
         a(n,i) = a(i,i)
  100 continue
c     .......... for i=n step -1 until 1 do -- ..........
      do 300 ii = 1, n
         i = n + 1 - ii
         l = i - 1
         h = 0.0d0
         scale = 0.0d0
         if (l .lt. 1) go to 130
c     .......... scale row (algol tol then not needed) ..........
         do 120 k = 1, l
  120    scale = scale + dabs(d(k))
c
         if (scale .ne. 0.0d0) go to 140
c
         do 125 j = 1, l
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = 0.0d0
  125    continue
c
  130    e(i) = 0.0d0
         e2(i) = 0.0d0
         go to 300
c
  140    do 150 k = 1, l
            d(k) = d(k) / scale
            h = h + d(k) * d(k)
  150    continue
c
         e2(i) = scale * scale * h
         f = d(l)
         g = -dsign(dsqrt(h),f)
         e(i) = scale * g
         h = h - f * g
         d(l) = f - g
         if (l .eq. 1) go to 285
c     .......... form a*u ..........
         do 170 j = 1, l
  170    e(j) = 0.0d0
c
         do 240 j = 1, l
            f = d(j)
            g = e(j) + a(j,j) * f
            jp1 = j + 1
            if (l .lt. jp1) go to 220
c
            do 200 k = jp1, l
               g = g + a(k,j) * d(k)
               e(k) = e(k) + a(k,j) * f
  200       continue
c
  220       e(j) = g
  240    continue
c     .......... form p ..........
         f = 0.0d0
c
         do 245 j = 1, l
            e(j) = e(j) / h
            f = f + e(j) * d(j)
  245    continue
c
         h = f / (h + h)
c     .......... form q ..........
         do 250 j = 1, l
  250    e(j) = e(j) - h * d(j)
c     .......... form reduced a ..........
         do 280 j = 1, l
            f = d(j)
            g = e(j)
c
            do 260 k = j, l
  260       a(k,j) = a(k,j) - f * e(k) - g * d(k)
c
  280    continue
c
  285    do 290 j = 1, l
            f = d(j)
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = f * scale
  290    continue
c
  300 continue
c
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      subroutine tred2(nm,n,a,d,e,z)
c
      integer i,j,k,l,n,ii,nm,jp1
      double precision a(nm,n),d(n),e(n),z(nm,n)
      double precision f,g,h,hh,scale
c
c     this subroutine is a translation of the algol procedure tred2,
c     num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
c
c     this subroutine reduces a real symmetric matrix to a
c     symmetric tridiagonal matrix using and accumulating
c     orthogonal similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the real symmetric input matrix.  only the
c          lower triangle of the matrix need be supplied.
c
c     on output
c
c        d contains the diagonal elements of the tridiagonal matrix.
c
c        e contains the subdiagonal elements of the tridiagonal
c          matrix in its last n-1 positions.  e(1) is set to zero.
c
c        z contains the orthogonal transformation matrix
c          produced in the reduction.
c
c        a and z may coincide.  if distinct, a is unaltered.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      do 100 i = 1, n
c
         do 80 j = i, n
   80    z(j,i) = a(j,i)
c
         d(i) = a(n,i)
  100 continue
c
      if (n .eq. 1) go to 510
c     .......... for i=n step -1 until 2 do -- ..........
      do 300 ii = 2, n
         i = n + 2 - ii
         l = i - 1
         h = 0.0d0
         scale = 0.0d0
         if (l .lt. 2) go to 130
c     .......... scale row (algol tol then not needed) ..........
         do 120 k = 1, l
  120    scale = scale + dabs(d(k))
c
         if (scale .ne. 0.0d0) go to 140
  130    e(i) = d(l)
c
         do 135 j = 1, l
            d(j) = z(l,j)
            z(i,j) = 0.0d0
            z(j,i) = 0.0d0
  135    continue
c
         go to 290
c
  140    do 150 k = 1, l
            d(k) = d(k) / scale
            h = h + d(k) * d(k)
  150    continue
c
         f = d(l)
         g = -dsign(dsqrt(h),f)
         e(i) = scale * g
         h = h - f * g
         d(l) = f - g
c     .......... form a*u ..........
         do 170 j = 1, l
  170    e(j) = 0.0d0
c
         do 240 j = 1, l
            f = d(j)
            z(j,i) = f
            g = e(j) + z(j,j) * f
            jp1 = j + 1
            if (l .lt. jp1) go to 220
c
            do 200 k = jp1, l
               g = g + z(k,j) * d(k)
               e(k) = e(k) + z(k,j) * f
  200       continue
c
  220       e(j) = g
  240    continue
c     .......... form p ..........
         f = 0.0d0
c
         do 245 j = 1, l
            e(j) = e(j) / h
            f = f + e(j) * d(j)
  245    continue
c
         hh = f / (h + h)
c     .......... form q ..........
         do 250 j = 1, l
  250    e(j) = e(j) - hh * d(j)
c     .......... form reduced a ..........
         do 280 j = 1, l
            f = d(j)
            g = e(j)
c
            do 260 k = j, l
  260       z(k,j) = z(k,j) - f * e(k) - g * d(k)
c
            d(j) = z(l,j)
            z(i,j) = 0.0d0
  280    continue
c
  290    d(i) = h
  300 continue
c     .......... accumulation of transformation matrices ..........
      do 500 i = 2, n
         l = i - 1
         z(n,l) = z(l,l)
         z(l,l) = 1.0d0
         h = d(i)
         if (h .eq. 0.0d0) go to 380
c
         do 330 k = 1, l
  330    d(k) = z(k,i) / h
c
         do 360 j = 1, l
            g = 0.0d0
c
            do 340 k = 1, l
  340       g = g + z(k,i) * z(k,j)
c
            do 360 k = 1, l
               z(k,j) = z(k,j) - g * d(k)
  360    continue
c
  380    do 400 k = 1, l
  400    z(k,i) = 0.0d0
c
  500 continue
c
  510 do 520 i = 1, n
         d(i) = z(n,i)
         z(n,i) = 0.0d0
  520 continue
c
      z(n,n) = 1.0d0
      e(1) = 0.0d0
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      double precision function pythag(a,b)
      double precision a,b
c
c     finds dsqrt(a**2+b**2) without overflow or destructive underflow
c
      double precision p,r,s,t,u
      p = dmax1(dabs(a),dabs(b))
      if (p .eq. 0.0d0) go to 20
      r = (dmin1(dabs(a),dabs(b))/p)**2
   10 continue
         t = 4.0d0 + r
         if (t .eq. 4.0d0) go to 20
         s = r/t
         u = 1.0d0 + 2.0d0*s
         p = u*p
         r = (s/u)**2 * r
      go to 10
   20 pythag = p
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


**==gam.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
      DOUBLE PRECISION FUNCTION GAM(X)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c    gamma function of X, from FUNCTION ALNGAM
c
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      EXTERNAL ALNGAM
      SAVE 
      XX = X
      GAM = EXP(ALNGAM(XX))
 100  RETURN
      END

	SUBROUTINE GHRLEV(EV,NN,Nmax,Emax,B,NCV,NCF,CV,CF,
     &		Nsiv,Nsif,Vhr,Bhr,Phav,Phab)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c GHRLEV: a code of general purposes to calculate eigenvalues of 1D-hindered internal rotation 
c Copyright (C) 2009 Lam T. Nguyen
c
c	DATE:	Feb. 13, 2009
c
c Lam T. Nguyen
c NGUYENLT@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c
c or contact
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C	INPUT:	
C		1) Emax		: maximum energy in Master Equation
C		2) B		: average rotational constant, defined as:
C			B = (Integral of B(x)dx from 0 to 2*PI) / (2*PI)
C		3) NCV, NCF	: number of elements in vectors of CV and CF, respectively
C		4) CV		: vector of coefficients with NCV elements in torsional 
C			potential energy function, which is expressed as = CVo/2 + Sum of CVi*(1-cos(i*x*Nsig))/2
C		5) CF		: vector of coefficients with NCF elements in rotational constant,
C			which is given by a Fourier series = CFo + Sum of CFi*cos(i*x*Nsig)
C		6) Nsiv, Nsif	: symmetry numbers for tortional potential E function and rotational constant, respectively.
C		7) NN		: maximum number of elements in vector EV
C		8) Vhr		: model for torsional potential energy function
C		9) Bhr		: model for rotational constant
C		10) Phav, Phab	: phases of torsional angles in Vhr and Bhr, respectively.  	 
C
C	OUTPUT:	1) EV(Nmax)	: vector of eigenvalues with Nmax elements
C		2) Nmax		: number of elements of vector EV
C
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
      PARAMETER (NX=201)
C
C.....Declare arrays.
      DIMENSION EV(NN), CV(NCV), CF(NCF)
        CHARACTER Vhr*5, Bhr*5
C
C.....CALVo used to find Vmax and Vmin of torsional potential energy function
	CALL CALVo(Vo,Vm,CV,NCV,Nsiv,Vhr,Phav)

	CALL ODQHR(EV,NN,NCV,NCF,CV,CF,Nsiv,Nsif,Vhr,Bhr,Phav,Phab,Vm)
	Nmax=NX
	CALL CALEI(EV,NN,Nmax,Emax,B)

        write(*,9991) Vo, Vm, EV(1)
9991    FORMAT(11X,'Torsional potential: ',1X,'Vmax (cm-1) = ',F8.1,1X,
     &  '; Vmin (cm-1) = ',F8.1,1X,'; zpe (cm-1) = ',F5.1)


	RETURN 
      END


C****************************************************************************************************************
C	NAME:	Subroutine ODQHR 
C	USE:	To obtain a vector of quantum eigenvalues of 1D-hindered internal rotor, in which  
C		both torsional potential energy function and moment inertia are explicitly treated as 
C		functions of internal rotational angle, i.e. non-rigid rotor, based on Meyer's algorithm:
C		R. Meyer J. Chem. Phys. 52 (1970) 2053-2059.  
C
C	AUTHORS:	Lam T. Nguyen and John R. Barker 
C
C	DATE:	Jan. 26, 2009
C
C****************************************************************************************************************
C     
C	 NX  : Number of grid points
C        XA  : Position on a grid.
C        AR  : Hamiltonian Matrix, i.e. Meyer's symmetrical matrix
C        ER  : Vector of eigenvalues 
C        ZR  : Eigenvectors (X,Y); where
C                                      X : Wavefunction.
C                                      Y : Energy level.       
C        NPR      : 0 for eigenvalue only and 1 for both eigenvalue and eigenvector 
C        RMIN     : Starting point of grid
C        RMAX     : End point of grid
C        ZL       : Grid length
C        DX       : Grid spacings
C
C****************************************************************************************************************
C
C	INPUT:	1) NCV, NCF	= Number of coefficients derived from fitting rotational energy profile and moment inertia
C		2) CV(NCV)	= Vector of coefficients from rotational energy profile, with NCV elements
C		3) CF(NCF)	= Vector of coefficients from moment inertia (rotational constant), with NCF elements
C		4) Nsig		= rotational symmetry number
C	OUTPUT:	1) ER 		= Vector of eigenvalues of 1D-hindered internal rotor, with NX=201 elements 
C
C*****************************************************************************************************************

	SUBROUTINE ODQHR(ER,NN,NCV,NCF,CV,CF,Nsiv,Nsif,
     &	Vhr,Bhr,Phav,Phab,Vm)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
      PARAMETER (NX=201)
C
C.....Declare arrays.
      DIMENSION AR(NX,NX),ER(NN),ZR(NX,NX),XA(NX) 
      DIMENSION D(NX,NX), F(NX), V(NX), DT(NX,NX),
     & T(NX,NX), FT(NX,NX)
	DIMENSION  CF(NCF), CV(NCV), FV1(NX), FV2(NX)
        CHARACTER Vhr*5, Bhr*5

C.....	DIMENSION WORK(NX*3)

C
C.....Variable data input.

      DATA NPR/0/

C.....Now compute Hamiltonian matrix:

	CALL CMM(AR,NCV,NCF,CV,CF,Nsiv,Nsif,Vhr,Bhr,Phav,Phab,Vm)
					
C.....Now call eigenvalue solver using RS subroutine of EISPACK.

	CALL rs(NX,NX,AR,ER,NPR,ZR,FV1,FV2,IERR) 

C...... Alterative option: using subroutine DSYEV from LAPACK 
C......	CALL DSYEV( 'V', 'U', NX, AR, NX, ER, WORK, NX*3, IERR )
C......

	RETURN 
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C.....	CMM stands for Constructing Meyer's Matrix, AR, for 1D-hindered internal rotor using Meyer's method, 
C.....	R. MEYER J. Chem. Phys. 52 (1970) 2053.
C.....	Both rotational energy profile and moment inertia are properly treated as functions of 
C.....	internal rotation angle, i.e. non-rigid rotor
C.....	INPUT:	1) NCF, NCV = Number of coefficients drived from fitting rotational energy profile and moment inertia
C.....		2) CV(NCV) = Vector of coefficients from rotational energy profile, with NCV elements
C.....		3) CF(NCF) = Vector of coefficients from moment inertia, with NCF elements
C.....		4) Nsig = Rotational symmetry number, it can be either one or two or three or whatever 
C.....	OUTPUT: 1) AR(NX,NX) = Meyer's symmetrical matrix, with a size of NX--number of grid points   


	SUBROUTINE CMM(AR,NCV,NCF,CV,CF,Nsiv,Nsif,Vhr,Bhr,Phav,Phab,Vm)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
	PARAMETER (NX=201)
C
C.....Declare arrays.
	DIMENSION AR(NX,NX),XA(NX) 
	DIMENSION D(NX,NX), F(NX), V(NX), DT(NX,NX),
     & T(NX,NX), FT(NX,NX)
	DIMENSION  CF(NCF), CV(NCV)
	CHARACTER Vhr*5, Bhr*5

C
C.....Variable data input.

	PI=acos(-1.D0)
C
C.....Set up grid
	RMIN=0.0D0
	RMAX=PI*2
	ZL=(RMAX-RMIN)
	DX=ZL/NX

C.....Now compute Meyer's symmetrical matrix:

	DO I=1, NX
		XA(I)=RMIN+DX*I
		CALL VX(V(I),XA(I)+Phav,CV,NCV,Nsiv,Vhr,Vm)
		CALL FX(F(I),XA(I)+Phab,CF,NCF,Nsif,Bhr)
		DO J=1, NX
			ImJ=I-J
			IF(ImJ.EQ.0) THEN
				D(I,J)=0.0D0
			ELSE
				tp1=PI*ImJ/dble(NX)
				tp2=(-1.0D0)**ImJ
				D(I,J)=tp2/2.0D0/dsin(tp1)
			ENDIF
			DT(I,J)=-D(I,J)
			FT(I,J)=F(I)*DELTA(I,J)
		ENDDO
	ENDDO

	DO I=1, NX
		DO J=1, NX
			SU=0.0D0
			DO K=1, NX
				SU=SU + FT(I,K)*D(K,J)
			ENDDO
			T(I,J)=SU
		ENDDO
	ENDDO

	DO I=1, NX
		DO J=1, NX
			SU=V(I)*DELTA(I,J)
			DO K=1, NX
				SU=SU + DT(I,K)*T(K,J)
			ENDDO
			AR(I,J)=SU
		ENDDO
	ENDDO	

	RETURN 
      END
C..........
C..........
	SUBROUTINE VX(V,X,CV,N,Nsig,Vhr,Vm)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
	DIMENSION CV(N)
	CHARACTER Vhr*5

	IF((Vhr.EQ.'Vhrd1').OR.(Vhr.EQ.'VHRD1')) THEN
		V=0.0d0
		DO I=1, N
			V=V+CV(I)*(1.0d0-dcos(X*Nsig*I))/2.0d0
		ENDDO
	ELSEIF((Vhr.EQ.'Vhrd2').OR.(Vhr.EQ.'VHRD2')) THEN
		V=CV(1)
		DO I=2, N
			V=V+CV(I)*dcos(X*Nsig*(I-1))
		ENDDO
        ELSEIF((Vhr.EQ.'Vhrd3').OR.(Vhr.EQ.'VHRD3')) THEN
		V=CV(1)
		Nc=(N+1)/2
		DO I=2, N
			IF(I.LE.Nc) THEN
				V=V+CV(I)*dcos(X*Nsig*(I-1))
			ELSE
				V=V+CV(I)*dsin(X*Nsig*(I-Nc))
			ENDIF
		ENDDO
	ELSE
		write(*,*) "ERROR at INPUT for torsional function = Vhrd"
		STOP
	ENDIF

	V=V-Vm

	RETURN
	END
C..........
C..........
	SUBROUTINE FX(F,X,CF,N,Nsig,Bhr)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
	DIMENSION CF(N)
	PARAMETER (CON=16.85763D0)
	CHARACTER Bhr*5

	IF((Bhr.EQ.'Bhrd1').OR.(Bhr.EQ.'BHRD1')) THEN
		F=CF(1)
		DO I=2, N
			F=F+CF(I)*dcos(X*Nsig*(I-1))
		ENDDO
        ELSEIF((Bhr.EQ.'Ihrd1').OR.(Bhr.EQ.'IHRD1')) THEN
                F=CF(1)
                DO I=2, N
                        F=F+CF(I)*dcos(X*Nsig*(I-1))
                ENDDO
		F=CON/F
	ELSE
                write(*,*) "ERROR at INPUT for Bhrd or Ihrd"
		STOP
	ENDIF

	RETURN
	END
C.........
C.........      
	Double Precision Function DELTA(I,J)
	INTEGER I, J

	IF(I.EQ.J) THEN
		DELTA=1.0D0
	ELSE
		DELTA=0.0D0
	ENDIF
	
	RETURN
	END
C.........
C.........

CCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCC

	SUBROUTINE CALEI(EV,NN,Nmax,Emax,B)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c CALEI: a code to compute/select eigenvalues of torsional motion based on Emax 
c Copyright (C) 2009 Lam T. Nguyen and John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C	INPUT:	1) EV(Nmax)	: a vector of eigenvalues with Nmax elements
C		2) Nmax		: number of elements of vector EV
C		3) Emax		: maximum energy in Master Equation
C		4) B		: average rotational constant, defined as:
C			B = (Integral of B(x)dx from 0 to 2*PI) / (2*PI)
C	OUTPUT:	1) EV(Nmax)
C		2) Nmax	
C
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
      DIMENSION EV(NN)

	I=Nmax

C.......IF The largest eigenvalue is larger than the maximum energy, 
C.......THEN searching for an eigenvalue, which is <= Emax
11	E=EV(I)
	IF(E.GT.Emax) THEN
		I=I-1
		goto 11
	ENDIF
	Nmax=I

C.......Looking for higher-lying eigenvalues with double degeneracy
111	NE1=NINT(EV(I))
	NE2=NINT(EV(I-1))
	IF(NE1.GT.NE2) THEN
		I=I-1
		goto 111
	ENDIF

C.......Switching from a hindered rotor to a Pitzer rotor
C.......Pitzer rotor is defined as E = Eo + B*(JP**2)
C.......Two variables Eo and JP will be computed as below
	tp=EV(I-1) - EV(I-2)
	JP=NINT((tp/B - 1.0d0)/2.0d0)
	Eo=EV(I-2)-B*JP*JP

1111	EV(I+1)=Eo + B*(JP+2)*(JP+2)
	EV(I+2)=EV(I+1)
	IF(EV(I+2).LE.Emax) THEN
		I=I+2
		JP=JP+1
		goto 1111
	ENDIF
	Nmax=I

	RETURN
 
      END

CCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCC
C
C CALVo is used to compute Vmax and Vmin 
C of the torsional potential energy function 
C
        SUBROUTINE CALVo(Vo,Vm,CV,NCV,Nsiv,Vhr,Pha)

        IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
        DIMENSION CV(NCV)
        CHARACTER Vhr*5

        PI=acos(-1.0d0)

        RMIN=0.0D0
        RMAX=PI*2
        ZL=(RMAX-RMIN)
        DX=ZL/3600.0d0
        CALL VX(Vo,0.0d0+Pha,CV,NCV,Nsiv,Vhr,0.0d0)
        Vm=Vo
        DO I=1, 3600
                XA = RMIN + DX*I
                CALL VX(Vtp,XA+Pha,CV,NCV,Nsiv,Vhr,0.0d0)
                IF(Vtp.GT.Vo) Vo=Vtp
                IF(Vtp.LT.Vm) Vm=Vtp
        ENDDO
        RETURN
        END

CCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCC









      SUBROUTINE KROTLEV(DELE,JMAX,B,JK,IR,NMAX)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2007 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C	CALCULATES ENERGY LEVELS FOR 1-DIMENSIONAL K-ROTOR TO BE USED
C          WITH STERAB
C
c	DELE	= energy grain size
c	JMAX	= index of Emax
c	B	= rotational constant (cm-1)
c	JK	= quantum number for total angular momentum
c	IR	= vector of energy level indices
c	NMAX	= ceiling of array
c
c
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION IR(20001)
      SAVE 
 
      RMAX = SQRT(JMAX*DELE/B)          ! Highest rotational quantum number consistent with energy ceiling
      NMAX = INT(RMAX) + 1              ! Integer version
      IF ( NMAX .GT. JK ) NMAX = JK
      IF ( NMAX .GT. 20001 ) NMAX = 20001
       
      IF ( NMAX .GT. 0 ) THEN
      DO 100 K = 1 , NMAX               ! K = quantum number of 1-dimensional free rotor
         R = B*K*K/DELE                 ! index number starting at 0
c         IR(K) = INT(R) + 1		! Truncation: number of grains
         IR(K) = IDNINT(R)              ! Nearest integer: number of grains
 100  CONTINUE
      ENDIF
 
      RETURN
      END
c
      function lenstr(string)
c
      implicit      none
c
      character*(*) string,  !input string
     2              null*1   !null character
c
      integer*4     i,       !string index
     2              iend,    !candidate for string length
     3              j,       !index used for stepping through string
     4              length,  !defined length of input
     5              lenstr   !length of string
c
      length=len(string)
c
c     Look for the existence of nulls; if there
c     are any, the first one marks one character past the
c     end of the defined string. If there are no nulls,
c     pick up the final nonspace character, and call that
c     the defined length of the string.
c
      null=char(0)
c
c     Look for nulls
c
      iend=index(string(1:length),null)
c
c     No nulls, look for the location of the last nonspace.
c
      if(iend.eq.0)then
          do i=1,length
              j=length+1-i
              if(string(j:j).ne.' ')then
                  lenstr=j
                  return
              endif
          enddo
c
c         all spaces
c
          lenstr=0
          return
      else
c
c         first null-1
c
          lenstr=iend-1
          return
      endif
      end
**==morlev.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
 
      SUBROUTINE MORLEV(DELE,JMAX,WE,XE,IR,NMAX,zpe)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
C
C
C
C	CALCULATES ENERGY LEVELS FOR MORSE OSCILLATOR TO BE USED
C          WITH STERAB
C
c	DELE	= energy grain
c	JMAX	= index of Emax
c	WE	= harmonic vibration frequency (cm-1)
c	XE	= anharmonicity (cm-1)
c	IR	= vector of energy level indices
c	NMAX	= ceiling of array (e.g. dissociation energy for Morse Osc.)
c       zpe     = zero point energy (cm-1), including anharmonicity
c
C	Input OBSERVED WEo = WE + 2*XE for 0-1 transition
c	Note sign of XE:  negative for usual Morse Oscillator
c
c	E = WE*(v+1/2) + XE*(v+1/2)^2
C
C     ALL ENERGIES AND FREQUENCIES IN WAVENUMBERS, relative to ZPE = WE/2 + XE/4
C
c    2/02 Modification: now, hindered rotors are counted as vibs in Whitten-Rabinovitch
c         parameter calculations. Zero point energy is calculated based on anharmonic
c         vibrations and from the hindered rotor subroutine.
C
c    9/07 fixed small bug in calculation of RMAX 
c
c--------------------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      EXTERNAL STERAB , GAM , WRAB , WRDEN , ALNGAM
      DIMENSION IR(20001)
      SAVE 
 
      w0 = WE + XE
      IF ( XE.LT.0.0 ) THEN
         RMAX = -0.5*w0/XE                              ! Maximum bound level, E relative to ZPE
      ELSE
         RMAX = JMAX*DELE/WE                            ! Maximum bound level
      ENDIF
      NMAX = INT(RMAX) 
      IF ( NMAX.GT.20001 ) NMAX = 20001
      zpe = 0.5d+00*WE + 0.25d+00*XE                    ! Zero point energy at v=0

      DO 100 I = 1 , NMAX                               ! Start at v=1
        vi = DBLE(I)
        R = (w0 + XE*vi)*vi/DELE
c      IR(I) = INT(R) + 1				! Truncation: number of grains
      IR(I) = IDNINT(R)                                 ! Nearest integer: number of grains
 100  CONTINUE
 
      RETURN
      END
**==rotlev.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
 
      SUBROUTINE ROTLEV(DELE,JMAX,B,NDIM,IR,NMAX)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c    Last modified:
c
c    8/01 BUG FIX: fixed 1-D rotor levels: replaced B*J*(J+1) with B*J*J
c    5/99 by J. R. Barker
CC
C	CALCULATES ENERGY LEVELS FOR FREE ROTOR TO BE USED
C          WITH STERAB
C
c	DELE	= energy grain size
c	JMAX	= index of Emax
c	B	= rotational constant (cm-1)
c	NDIM	= rotor dimension
c	IR	= vector of energy level indices
c	NMAX	= ceiling of array
c
c
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION IR(20001)
      SAVE 
 
      RMAX = SQRT(JMAX*DELE/B)  ! Maximum bound level
      NMAX = INT(RMAX) + 2
      IF ( NMAX.GT.20001 ) NMAX = 20001
 
      DO 100 J = 1 , NMAX
         IF ( NDIM.EQ.1 ) THEN
             R = B*J*J/DELE
           ELSE
             R = B*J*(J+1.0D+00)/DELE
         ENDIF
c         IR(J) = INT(R) + 1		! Truncation: number of grains
         IR(J) = IDNINT(R)              ! Nearest integer: number of grains
 100  CONTINUE
 
      RETURN
      END
      SUBROUTINE rotunits( VROT , X )
      
      IMPLICIT NONE
      CHARACTER VROT*4      
      DOUBLE PRECISION X
      SAVE
     
c      CONVERT UNITS TO amu*Ang^2
c      For qro and rot types [NOT hindered rotorS]:
c          VROT = 'AMUA' for moment of inertia in units of amu*Ang^2
c       or      = 'GMCM' for moment of inertia units of gram*cm^2
c       or      = 'CM-1' for rotational constant in units of cm^-1
c       or      = 'MHZ' for rotational constant in units of MHz
c       or      = 'GHZ' for rotational constant in units of GHz
c         
      IF (     VROT .EQ. 'AMUA'
     &    .OR. VROT .EQ. 'amua' 
     &   ) THEN
        RETURN
      ELSEIF ( VROT .EQ. 'GMCM'
     &    .OR. VROT .EQ. 'gmcm'
     &    .OR. VROT .EQ. 'GmCm'
     & ) THEN
        X = X / 1.660538782d-040
        RETURN
      ELSEIF ( VROT .EQ. 'CM-1'
     &    .OR. VROT .EQ. 'cm-1'
     &  ) THEN
        X = 16.85763D+00 / X
        RETURN
      ELSEIF ( VROT .EQ. 'MHZ'
     &    .OR. VROT .EQ. 'MHz' 
     &    .OR. VROT .EQ. 'mhz'
     &    .OR. VROT .EQ. 'Mhz'
     & ) THEN
        X = 5.05379D+005 / X
      ELSEIF ( VROT .EQ. 'GHZ'
     &    .OR. VROT .EQ. 'GHz' 
     &    .OR. VROT .EQ. 'ghz'
     &    .OR. VROT .EQ. 'Ghz'
     & ) THEN
        X = 5.05379D+002 / X
        RETURN
      ELSE
        write (*,*) 'FATAL: units (VROT) for rotations not recongized'
        STOP
      ENDIF

      END
      
      
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c SHRLEV: a code to calculate eigenvalues of symmetrical, rigid 1D-hindered internal rotation
c Copyright (C) 2009 Lam T. Nguyen and John R. Barker
c
c	DATE:	Feb. 13, 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        SUBROUTINE SHRLEV(T,AT,DELE,JMAX,B,V,n1,n2,IMAX,zpe,
     &          Vhr,Bhr,Phav,Phab)

        IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
        PARAMETER (NN=2000, No=1)
        DIMENSION EV(NN), CV(No), CF(No), T(JMAX), AT(JMAX)
	   DIMENSION IR(NN)
        CHARACTER Vhr*5, Bhr*5

        Emax=(JMAX-1)*DELE

        NCV=1
        NCF=1
        CV(1)=V
        CF(1)=B

        CALL GHRLEV(EV,NN,IMAX,Emax,B,NCV,NCF,CV,CF,n1,n2,
     &          Vhr,Bhr,Phav,Phab)

	zpe=EV(1)

C......	write(*,*) "Zero-point energy = ", zpe

	DO I=1, IMAX
		tp=EV(I)-zpe
		IR(I)=NINT(tp/DELE)
C......		write(*,*) I, tp

	ENDDO 

	DO J=1, IMAX
		LL=IR(J)
		DO L=1, JMAX - LL
			AT(L+LL) = AT(L+LL) + T(L)
		ENDDO
	ENDDO
	DO J=1, JMAX
		T(J)=AT(J)/n1
		AT(J)=0.0d0
	ENDDO 

	RETURN
	END



      SUBROUTINE STERAB(N,JMAX,DELE)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2002 John R. Barker 
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
C
C
C    CALCULATES COMPLEXIONS, DENSITIES, AND SUMS OF STATES ACCORDING TO
C     S.E. STEIN AND B.S. RABINOVITCH, J.CHEM.PHYS. 58, 2438 (1973)
C
C     RETURNS SUMS AND DENSITIES OF RO/VIB STATES IN
C           ARRAYS SUM AND DENS
C
C     DELE = GRAIN SIZE (CM-1)
C
C     ALL ENERGIES AND FREQUENCIES IN WAVENUMBERS
C
C	N	= degrees of freedom
C	JMAX	= index of energy increment corresponding to Emax
C	DELE	= energy grain (cm-1)
C
C
C	OTHER VARIABLES:
C	IDOF	= type of degree of freedom
C		= VIB (Morse or harmonic vibration)
C		= ROT (classical free rotation)
C		= QRO (quantized free rotation)
C               = BOX (quantized particle-in-a-box)
C               = HRx (hindered rotation; x=a,b,c; see below)
C               = TRN (relative translation)
C	WE	= vibrational frequency (cm-1)
C    AMOM = moment of inertia (amu Ang^2)
C	ANH	= vector of anharmonicities, or rotor symmetry number
C	NG	= vib. degeneracy, or rotor dimension
C	SUM	= sums of states
C	DENS	= densities of states
C       zzpe    = zero point energy (vibrations and hindered rotors)
C
C     Free Rotations:
C         AMOM(I) is moment of inertia (amu Ang^2)
C         ANH(I) is rotor foldedness (symmetry number)
C         NG(I) is rotor dimension (renamed NDIM)
C
C     1-D Hindered Rotations:
C         B(I) is rotational constant (cm-1)
C         W(I) small vibration frequency (cm-1)
C         NG(I) is internal rotor potential energy periodicity (foldedness)
C         NSIG(I) is internal rotor symmetry number
C         VV(I) is hindrance barrier height (cm-1)
C
C     Vibrations:
C         IF ANH=0.0,  HARMONIC OSCILLATORS ASSUMED
C            NG(I) IS OSCILLATOR DEGENERACY (OR ROTOR DIMENSION);
C         BOX:  NG(I) is oscillator degeneracy
C
C      JMAX IS NUMBER OF GRAINS AND CANNOT EXCEED 20001
C
C
C
C     THIS ROUTINE USES SUBROUTINES MORLEV(....)
C                                   BOXLEV(...)
C                                   GAM(X)
C                                   ROTLEV
C                                   HRLEV
C
c *************************************************************************

      INCLUDE 'declare.inc'

      INTEGER NTRN , NTRNFLAG , JK
      DOUBLE PRECISION FACTR , atr
      EXTERNAL GAM
!      DIMENSION AT(NMAX) , T(NMAX) , IR(NMAX)

	Double precision AT(NMAX) , T(NMAX)  
	Integer IR(NMAX)

      SAVE 
C
C          INITIALIZE T AND AT
C
      T(1) = 1.0D+00
      AT(1) = 0.0D+00
      DO 100 I = 2 , JMAX
         AT(I) = 0.0D+00
         T(I) = 0.0D+00
 100  CONTINUE
C
C          TROE METHOD FOR CLASSICAL ROTATIONS, EXTENDED TO TRANSLATIONS
C          [Astholz, Troe, and Wieters, J.Chem.Phys., 70, 5107, 1979]
C          [Equation numbers from Robinson & Holbrook, Unimolecular Reactions (Wiley, 1973)]
c
      NR = 0
      NTRN = 0
      NTRNFLAG = 0
      FAC = 1.D+00
      NSYMM = 1
      DO 200 I = 1 , N                                        ! TEST FOR CLASS. ROTORS AND TRANSLATION
         IF ( IDOF(I).EQ.ROT ) THEN
            IF ( NG(I).LE.0 ) NG(I) = 1   ! free rotor dimension
            NDIM = NG(I)                  ! free rotor dimension
            BB = 16.85763D+00/AMOM(I)     ! rotational constant (cm-1)
            NR = NR + NDIM                ! number of classical free rotor degrees of freedom
            RG = DBLE(NDIM)/2.D+00        ! in Eq. 5.16
            BG = SQRT( BB**NDIM )         ! in Eq. 5.16
            FAC = FAC*GAM(RG)/(BG*ANH(I)) ! in Eq. 5.16; ANH(I) is free rotor foldedness (symmetry number)
            NSYMM = NSYMM*ANH(I)          ! symmetry number
         ENDIF
         IF (IDOF(I) .EQ. TRN) THEN
            NTRN = I
            NTRNFLAG = NTRNFLAG + 1       ! Flag for presence of relative translation
            IF (NTRNFLAG .GT. 1) THEN
              STOP '**** ONLY ONE 3-D TRANSLATION ALLOWED ***'
            ENDIF
         ENDIF
 200  CONTINUE
 
       IF ( (NR.GT.0) .AND. (NTRN .EQ. 0) ) THEN              ! CLASS. ROTORS BUT NO TRANSLATION
         R2 = DBLE(NR)/2.D+00             ! in Eq. 5.15
         FAC = FAC/GAM( R2+1.D+00 )       ! in Eq. 5.15
         DO 250 K = 2 , JMAX              ! Initialize T(K)
            E = (K-1)*DELE
            T(K) = FAC*( SQRT(E**NR) - SQRT( (E-DELE)**NR ) )           !  number of classical free rotor states in grain
 250     CONTINUE
         T(1) = 0.0d+00
      ELSEIF ( (NTRN .GT. 0) .AND. (NR .EQ. 0) ) THEN         ! TRANSLATION BUT NO CLASS. ROTORS
         FACTR = 2.43980d+20*( AMOM(NTRN) )**1.5d+00                      ! states per cc
         DO 251 K = 2 , JMAX               
            E = (K-1)*DELE
            T(K) = FACTR*( E**1.5d+00 - (E-DELE)**1.5d+00 )               ! number of classical translational states (per cc) in grain
 251     CONTINUE
      ELSEIF ( (NTRN .GT. 0) .AND. (NR .GT. 0) ) THEN         ! TRANSLATION WITH CLASS. ROTORS
         atr = (NR + 3.0D+00) / 2.D+00
         FACTR = 3.24332d+20*( AMOM(NTRN) )**1.5d+00                      ! states per cc
         FACTR =  FACTR*FAC / ( atr * GAM(atr) )
         DO 252 K = 2 , JMAX               
            E = (K-1)*DELE
            T(K) = FACTR*( E**atr - (E-DELE)**atr )                       ! number of classical rot-translational states (per cc) in grain
 252     CONTINUE
         T(1) = 0.0d+00
      ENDIF
C
C
C
      DO 400 I = 1 , N
         WRITE (*,99001) I , WE(I)
 
         IF ( IDOF(I).EQ.KRO ) THEN                             ! ********  1-Dim. free K-rotor *********
 
            BB = 16.85763D+00/AMOM(I)   ! rotational constant (cm-1)
            NDIM  = 1                   ! Rotor dimension
            NSYMM = ANH(I)              ! Symmetry number
            JK    = NG(I)               ! quantum number for total angular momentum
 
            CALL KROTLEV(DELE,JMAX,BB,JK,IR,IMAX)

            IF ( IMAX .GT. 0 ) THEN
            DO 281 J = 1 , IMAX ! J = quantum number for K-rotor;  IMAX is the number of energy levels
               IF ( J.EQ.0 ) THEN
                  F = 1         ! F is the multiplicity of the rotational level (see J.L. McHale, Molecular Spectroscopy (Prentice-Hall, 1999), 216f.
               ELSE
                  F = 2.0       ! 1-D rotor (e.g. single-axis internal rotor)
               ENDIF
               DO 261 K = 1 , JMAX
                  KARG = K - IR(J)
                  IF ( KARG.GT.0 .AND. KARG.LE.NMAX)
     &                   AT(K) = AT(K) + F*T(KARG)
 261           CONTINUE
 281        CONTINUE
            ENDIF
 
            DO 301 J = 1 , JMAX
               T(J) = AT(J) + T(J)
               T(J) = T(J) / NSYMM
               AT(J) = 0.0D+00
 301        CONTINUE
c            T(1) = 1.0d+00/NSYMM                                ! Symmetry number correction
 
 
         ELSEIF ( IDOF(I).EQ.QRO ) THEN                         ! ********  Quantized free rotors *********
 
            BB = 16.85763D+00/AMOM(I)   ! rotational constant (cm-1)
            NDIM = NG(I)                ! Rotor dimension
            NSYMM = ANH(I)              ! Symmetry number
 
            CALL ROTLEV(DELE,JMAX,BB,NDIM,IR,IMAX)

            DO 280 J = 1 , IMAX ! J = rot quantum number;  IMAX is the number of energy levels
               IF ( J.EQ.0 ) THEN
                  F = 1         ! F is the multiplicity of the rotational level (see J.L. McHale, Molecular Spectroscopy (Prentice-Hall, 1999), 216f.
               ELSEIF ( NDIM.EQ.1 ) THEN   ! 1-D rotor (e.g. single-axis internal rotor)
                  F = 2.0
               ELSEIF ( NDIM.EQ.2 ) THEN   ! 2-D rotor
                  F = 2.0*J + 1.0
               ELSEIF ( NDIM.EQ.3 ) THEN   ! 3-D rotor (shperical top)
                  F = (2.0*J+1.0)*(2.0*J+1.0)
               ENDIF
               DO 260 K = 1 , JMAX
                  KARG = K - IR(J)
                  IF ( KARG.GT.0 .AND. KARG.LE.NMAX)
     &                   AT(K) = AT(K) + F*T(KARG)
 260           CONTINUE
 280        CONTINUE
 
           DO 300 J = 1 , JMAX
               T(J) = AT(J) + T(J)
               T(J) = T(J) / NSYMM
               AT(J) = 0.0D+00
 300        CONTINUE
c            T(1) = 1.0d+00/NSYMM                                ! Symmetry number correction
 
         ELSEIF ( (IDOF(I).EQ.HRA) .OR. (IDOF(I).EQ.HRB) .OR. 
     &            (IDOF(I).EQ.HRC) ) THEN                       ! ******  Quantized hindered rotors ********
 
            BB = B(I)           ! rotational constant (cm-1)
            VVV = VV(I)         ! hindrance barrier (cm-1)
            NGG = NG(I)         ! Potential energy symmetry (foldedness)

		CALL SHRLEV(T,AT,DELE,JMAX,BB,VVV,NGG,1,IMAX,zap,
     &          'Vhrd1','Bhrd1',0.0d0,0.0d0)		! rigid, symmetrical hindered rotor

            zzpe(I) = zap                                        ! Zero Point Energy

         ELSEIF ( IDOF(I).EQ.HRD ) THEN

		DO L=1, NCV(I)
			CVt(L)=CV(I,L)
		ENDDO
                DO L=1, NCB(I)
                        CBt(L)=CB(I,L)
                ENDDO

		CALL UHRLEV(T,AT,DELE,JMAX,NCB(I),NCV(I),CBt,CVt,
     &          NSV(I),NSB(I),IMAX,zap,Vhr(I),Bhr(I),Phav(I),Phab(I))	! non-rigid, unsymmetrical hindered rotor


	     zzpe(I) = zap                                        ! Zero Point Energy

         ELSEIF ( IDOF(I).EQ.VIB ) THEN                         ! ********  Vibrations **********************
             CALL MORLEV(DELE,JMAX,WE(I),ANH(I),IR,IMAX,zap)
             zzpe(I) = zap                                       ! Zero Point Energy

            DO 380 L = 1 , NG(I)                                ! Loop for degenerate vibrations
               DO 350 J = 1 , IMAX                              ! IMAX is the number of energy levels
                  DO 345 K = 1 , JMAX
                     KARG = K - IR(J)
                     IF ( KARG.GT.0 .AND. KARG.LE.NMAX )
     &                      AT(K) = AT(K) + T(KARG)
 345              CONTINUE
 350           CONTINUE
 
               DO 360 J = 1 , JMAX
                  T(J) = AT(J) + T(J)
                  AT(J) = 0.0D+00
 360           CONTINUE
 380        CONTINUE
  
         ELSEIF ( IDOF(I).EQ.BOX ) THEN                         ! ********  Particle-in-a-Box ***************
            CALL BOXLEV(DELE,JMAX,WE(I),IR,IMAX,zap)
            zzpe(I) = zap                                       ! Zero Point Energy
            DO 390 L = 1 , NG(I)                                ! Loop for degenerate vibrations
               DO 355 J = 1 , IMAX                              ! IMAX is the number of energy levels
                  DO 365 K = 1 , JMAX
                     KARG = K - IR(J)
                     IF ( KARG.GT.0 .AND. KARG.LE.NMAX )
     &                   AT(K) = AT(K) + T(KARG)
 365              CONTINUE
 355           CONTINUE
 
               DO 370 J = 1 , JMAX
                  T(J) = AT(J) + T(J)
                  AT(J) = 0.0D+00
 370           CONTINUE
 390        CONTINUE

         ENDIF
 
 400  CONTINUE                ! loop quantized degrees of freedom

c
c    Reminder: T(I) is the number of states in the Ith grain.
c
      SUM(1) = T(1)                                    ! Energy at E = 0 (at TOP of first grain)
      DENS(1) = T(1) / DELE
      DO 500 I = 2 , JMAX
         SUM(I)  = T(I) + SUM(I-1)                     ! Sum of states at TOP of energy grain
         DENS(I) = T(I)/DELE
 500  CONTINUE

      RETURN

99001 FORMAT (10X,' Mode no.',I5,F10.2)

      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c UHRLEV: a code to calculate eigenvalues of unsymmetrical, non-rigid 1D-hindered internal rotation
c Copyright (C) 2009 Lam T. Nguyen and John R. Barker
c
c	DATE:	Feb. 13, 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        SUBROUTINE UHRLEV(T,AT,DELE,JMAX,NCB,NCV,CB,CV,n1,n2,IMAX,
     &          zpe,Vhr,Bhr,Phav,Phab)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
      PARAMETER (NN=2000)
      DIMENSION EV(NN), CV(NCV), CB(NCB), T(JMAX), AT(JMAX)
	DIMENSION IR(NN)
        CHARACTER Vhr*5, Bhr*5

        PI=acos(-1.0d0)
        Emax=(JMAX-1)*DELE

        IF((Bhr.EQ.'Bhrd2').OR.(Bhr.EQ.'BHRD2')) THEN   ! Average rotational constant
                B=0.0d0
                DO I=1, n2
                        B=B + (CB(I)/I)*((PI*2)**(I-1))
                ENDDO
        ELSEIF((Bhr.EQ.'Ihrd2').OR.(Bhr.EQ.'IHRD2')) THEN       ! Average moment of inertia
                B=0.0d0
                DO I=1, n2
                        B=B + (CB(I)/I)*((PI*2)**(I-1))
                ENDDO
                B=16.85763d0 / B        ! convert from I to B
        ELSEIF((Bhr.EQ.'Ihrd1').OR.(Bhr.EQ.'IHRD1')) THEN       ! Average moment of inertia
                B=16.85763d0/CB(1)      ! convert from I to B
        ELSEIF((Bhr.EQ.'Bhrd1').OR.(Bhr.EQ.'BHRD1')) THEN       ! Average rotational constant
                B=CB(1)
        ELSE
                write(*,*) "ERROR at INPUT for Bhr or Ihr"
        ENDIF

        CALL GHRLEV(EV,NN,IMAX,Emax,B,NCV,NCB,CV,CB,n1,n2,
     &          Vhr,Bhr,Phav,Phab)

	zpe=EV(1)

C......	write(*,*) "Zero-point energy = ", zpe

	DO I=1, IMAX
		tp=EV(I)-zpe
		IR(I)=NINT(tp/DELE)
C......		write(*,*) I, tp
	ENDDO 

	DO J=1, IMAX
		LL=IR(J)
		DO L=1, JMAX - LL
			AT(L+LL) = AT(L+LL) + T(L)
		ENDDO
	ENDDO
	DO J=1, JMAX
		T(J)=AT(J)/n1
		AT(J)=0.0d0
	ENDDO 

	RETURN
	END


**==wrab.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
 
 
 
      SUBROUTINE WRAB(N,NROTS,EZERO,BETA,AVENU,MAX,DELE,SUM,DENS)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
C
C   Stores Whitten-Rabinovitch densities of states in array DENS
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE 
      EXTERNAL WRDEN
      DIMENSION SUM(20001) , DENS(20001)
      DO 100 I = 1 , MAX
         E = (I-1)*DELE
         CALL WRDEN(E,EZERO,BETA,AVENU,N,NROTS,D,WRSUM)
         SUM(I) = WRSUM
         DENS(I) = D
 100  CONTINUE
      RETURN
      END
**==wrden.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
      SUBROUTINE WRDEN(E,EZERO,BETA,AVENU,NSVIB,NROT,DENS,WRSUM)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
C
C	Calculates sums and densities of vib/rot states, based on
C		Whitten-Rabinovitch approximation
C
C	Uses FUNCTION ALNGAM(X), which calculates natural logarithm
C		of the gamma FUNCTION of x
C
C	E	= energy (cm-1)
C	EZERO	= zero point energy (cm-1)
C	BETA	= W-R beta parameter
C	AVENU	= geometric mean frequency (cm-1)
C	NSVIB	= number of vibs
C	NROT	= number of rots
C	DENS	= density of states (states/cm-1)
C	WRSUM	= sum of states
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE 
      EXTERNAL ALNGAM
      SVIB = DBLE(NSVIB)
      SROT = DBLE(NROT)
      GMF = ALNGAM(SVIB+.5*SROT)
      WRE = E/EZERO
      ALHNUP = SVIB*LOG(AVENU)
      IF ( WRE.GT.0.0 ) THEN
         IF ( WRE.LT.1.0 ) THEN
            W = 1.0/((5.0*WRE)+2.73*(SQRT(WRE))+3.51)
            DW = -W*W*(5.0+1.365/(SQRT(WRE)))
         ELSE
            W14 = SQRT(SQRT(WRE))
            W = EXP(-2.4191*(W14))
            W34 = W14**3
            DW = -W*0.60478/W34
         ENDIF
         A = 1.0 - (BETA*W)
         BRAC = LOG(1.0-(BETA*DW))
         ALNDEN = (SVIB+.5*SROT-1.0)*(LOG(E+A*EZERO)) + BRAC - GMF - 
     &            ALHNUP
         WRSUM = (SVIB+.5*SROT)*LOG(E+A*EZERO) - GMF - ALHNUP - 
     &           LOG(SVIB+.5*SROT)
      ELSE
         AWR = 1.0 - BETA/3.51
         ALNDEN = (SVIB+.5*SROT-1)*LOG(AWR*EZERO) - ALHNUP - GMF
         WRSUM = -LOG(SVIB+.5*SROT) + (SVIB+.5*SROT)*LOG(AWR*EZERO)
     &           - ALHNUP - GMF
      ENDIF
      WRSUM = EXP(WRSUM)
      DENS = EXP(ALNDEN)
      RETURN
      END
