 
      SUBROUTINE CMdist(XCOORD,YCOORD,ZCOORD,MASS,FRGM1,FRGM2,NATOMS,
     &   re,XCM1,XCM,YCM1,YCM,ZCM1,ZCM)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c MomInert: a code for calculating moments of inertia
c Copyright (C) 2001 Nicolas F. Ortiz and John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c     Calculate distance between centers of mass
 
      IMPLICIT NONE
      INTEGER I , J, NUMROT, NATOMS, FRGM1, FRGM2
      DOUBLE PRECISION XCOORD(100) , YCOORD(100) , ZCOORD(100)
      DOUBLE PRECISION MASS(100)
      DOUBLE PRECISION XCM1, XCM, YCM1, YCM, ZCM1, ZCM
      DOUBLE PRECISION MASSFRG1, MASSFRG2, re , xx

        XCM1=0  
        YCM1=0  
        ZCM1=0  
        XCM=0
        YCM=0
        ZCM=0
        MASSFRG1=0
        MASSFRG2=0

        do I=1,FRGM1     !   CM fragment1
         XCM=XCM+XCOORD(I)*MASS(I)
         YCM=YCM+YCOORD(I)*MASS(I)
         ZCM=ZCM+ZCOORD(I)*MASS(I)
         MASSFRG1=MASSFRG1+MASS(I)
        enddo
        XCM=XCM/MASSFRG1
        YCM=YCM/MASSFRG1
        ZCM=ZCM/MASSFRG1


        do I=FRGM1+1,NATOMS    !   CM fragment2
         XCM1=XCM1+XCOORD(I)*MASS(I)
         YCM1=YCM1+YCOORD(I)*MASS(I)
         ZCM1=ZCM1+ZCOORD(I)*MASS(I)
         MASSFRG2=MASSFRG2+MASS(I)
        enddo
        XCM1=XCM1/MASSFRG2
        YCM1=YCM1/MASSFRG2
        ZCM1=ZCM1/MASSFRG2


       re=((XCM1-XCM)**2+(YCM1-YCM)**2+(ZCM1-ZCM)**2)**0.5  !distance

      RETURN
      END
 
 
c
c     EISPACK SUBROUTINES
c
c     http://www.netlib.org/eispack/
c
c     B.T. Smith, J.M. Boyle, J.J. Dongarra, B.S. Garbow, Y. Ikebe, 
c     V.C. Klema, and C.B. Moler. Matrix Eigensystem Routines - 
c     EISPACK Guide, volume 6 of Lecture Notes in Computer Science, 
c     Springer-Verlag, Berlin, 1976.
c
c     B.S. Garbow, J.M. Boyle, J.J. Dongarra, and C.B. Moler. Matrix 
c     Eigensystem Routines - EISPACK Guide Extension, volume 51 of
c     Lecture Notes in Computer Science, Springer-Verlag, Berlin, 
c     1977.
c    
c
      subroutine rs(nm,n,a,w,matz,z,fv1,fv2,ierr)
c
      integer n,nm,ierr,matz
      double precision a(nm,n),w(n),z(nm,n),fv1(n),fv2(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a real symmetric matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a.
c
c        a  contains the real symmetric matrix.
c
c        matz  is an integer variable set equal to zero if
c        only eigenvalues are desired.  otherwise it is set to
c        any non-zero integer for both eigenvalues and eigenvectors.
c
c     on output
c
c        w  contains the eigenvalues in ascending order.
c
c        z  contains the eigenvectors if matz is not zero.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for tqlrat
c           and tql2.  the normal completion code is zero.
c
c        fv1  and  fv2  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 if (matz .ne. 0) go to 20
c     .......... find eigenvalues only ..........
      call  tred1(nm,n,a,w,fv1,fv2)
*  tqlrat encounters catastrophic underflow on the Vax
*     call  tqlrat(n,w,fv2,ierr)
      call  tql1(n,w,fv1,ierr)
      go to 50
c     .......... find both eigenvalues and eigenvectors ..........
   20 call  tred2(nm,n,a,w,fv1,z)
      call  tql2(nm,n,w,fv1,z,ierr)
   50 return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine tql1(n,d,e,ierr)
c
      integer i,j,l,m,n,ii,l1,l2,mml,ierr
      double precision d(n),e(n)
      double precision c,c2,c3,dl1,el1,f,g,h,p,r,s,s2,tst1,tst2,pythag
c
c     this subroutine is a translation of the algol procedure tql1,
c     num. math. 11, 293-306(1968) by bowdler, martin, reinsch, and
c     wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 227-240(1971).
c
c     this subroutine finds the eigenvalues of a symmetric
c     tridiagonal matrix by the ql method.
c
c     on input
c
c        n is the order of the matrix.
c
c        d contains the diagonal elements of the input matrix.
c
c        e contains the subdiagonal elements of the input matrix
c          in its last n-1 positions.  e(1) is arbitrary.
c
c      on output
c
c        d contains the eigenvalues in ascending order.  if an
c          error exit is made, the eigenvalues are correct and
c          ordered for indices 1,2,...ierr-1, but may not be
c          the smallest eigenvalues.
c
c        e has been destroyed.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the j-th eigenvalue has not been
c                     determined after 30 iterations.
c
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      if (n .eq. 1) go to 1001
c
      do 100 i = 2, n
  100 e(i-1) = e(i)
c
      f = 0.0d0
      tst1 = 0.0d0
      e(n) = 0.0d0
c
      do 290 l = 1, n
         j = 0
         h = dabs(d(l)) + dabs(e(l))
         if (tst1 .lt. h) tst1 = h
c     .......... look for small sub-diagonal element ..........
         do 110 m = l, n
            tst2 = tst1 + dabs(e(m))
            if (tst2 .eq. tst1) go to 120
c     .......... e(n) is always zero, so there is no exit
c                through the bottom of the loop ..........
  110    continue
c
  120    if (m .eq. l) go to 210
  130    if (j .eq. 30) go to 1000
         j = j + 1
c     .......... form shift ..........
         l1 = l + 1
         l2 = l1 + 1
         g = d(l)
         p = (d(l1) - g) / (2.0d0 * e(l))
         r = pythag(p,1.0d0)
         d(l) = e(l) / (p + dsign(r,p))
         d(l1) = e(l) * (p + dsign(r,p))
         dl1 = d(l1)
         h = g - d(l)
         if (l2 .gt. n) go to 145
c
         do 140 i = l2, n
  140    d(i) = d(i) - h
c
  145    f = f + h
c     .......... ql transformation ..........
         p = d(m)
         c = 1.0d0
         c2 = c
         el1 = e(l1)
         s = 0.0d0
         mml = m - l
c     .......... for i=m-1 step -1 until l do -- ..........
         do 200 ii = 1, mml
            c3 = c2
            c2 = c
            s2 = s
            i = m - ii
            g = c * e(i)
            h = c * p
            r = pythag(p,e(i))
            e(i+1) = s * r
            s = e(i) / r
            c = p / r
            p = c * d(i) - s * g
            d(i+1) = h + s * (c * g + s * d(i))
  200    continue
c
         p = -s * s2 * c3 * el1 * e(l) / dl1
         e(l) = s * p
         d(l) = c * p
         tst2 = tst1 + dabs(e(l))
         if (tst2 .gt. tst1) go to 130
  210    p = d(l) + f
c     .......... order eigenvalues ..........
         if (l .eq. 1) go to 250
c     .......... for i=l step -1 until 2 do -- ..........
         do 230 ii = 2, l
            i = l + 2 - ii
            if (p .ge. d(i-1)) go to 270
            d(i) = d(i-1)
  230    continue
c
  250    i = 1
  270    d(i) = p
  290 continue
c
      go to 1001
c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........
 1000 ierr = l
 1001 return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      subroutine tql2(nm,n,d,e,z,ierr)
c
      integer i,j,k,l,m,n,ii,l1,l2,nm,mml,ierr
      double precision d(n),e(n),z(nm,n)
      double precision c,c2,c3,dl1,el1,f,g,h,p,r,s,s2,tst1,tst2,pythag
c
c     this subroutine is a translation of the algol procedure tql2,
c     num. math. 11, 293-306(1968) by bowdler, martin, reinsch, and
c     wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 227-240(1971).
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a symmetric tridiagonal matrix by the ql method.
c     the eigenvectors of a full symmetric matrix can also
c     be found if  tred2  has been used to reduce this
c     full matrix to tridiagonal form.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        d contains the diagonal elements of the input matrix.
c
c        e contains the subdiagonal elements of the input matrix
c          in its last n-1 positions.  e(1) is arbitrary.
c
c        z contains the transformation matrix produced in the
c          reduction by  tred2, if performed.  if the eigenvectors
c          of the tridiagonal matrix are desired, z must contain
c          the identity matrix.
c
c      on output
c
c        d contains the eigenvalues in ascending order.  if an
c          error exit is made, the eigenvalues are correct but
c          unordered for indices 1,2,...,ierr-1.
c
c        e has been destroyed.
c
c        z contains orthonormal eigenvectors of the symmetric
c          tridiagonal (or full) matrix.  if an error exit is made,
c          z contains the eigenvectors associated with the stored
c          eigenvalues.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the j-th eigenvalue has not been
c                     determined after 30 iterations.
c
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      if (n .eq. 1) go to 1001
c
      do 100 i = 2, n
  100 e(i-1) = e(i)
c
      f = 0.0d0
      tst1 = 0.0d0
      e(n) = 0.0d0
c
      do 240 l = 1, n
         j = 0
         h = dabs(d(l)) + dabs(e(l))
         if (tst1 .lt. h) tst1 = h
c     .......... look for small sub-diagonal element ..........
         do 110 m = l, n
            tst2 = tst1 + dabs(e(m))
            if (tst2 .eq. tst1) go to 120
c     .......... e(n) is always zero, so there is no exit
c                through the bottom of the loop ..........
  110    continue
c
  120    if (m .eq. l) go to 220
  130    if (j .eq. 30) go to 1000
         j = j + 1
c     .......... form shift ..........
         l1 = l + 1
         l2 = l1 + 1
         g = d(l)
         p = (d(l1) - g) / (2.0d0 * e(l))
         r = pythag(p,1.0d0)
         d(l) = e(l) / (p + dsign(r,p))
         d(l1) = e(l) * (p + dsign(r,p))
         dl1 = d(l1)
         h = g - d(l)
         if (l2 .gt. n) go to 145
c
         do 140 i = l2, n
  140    d(i) = d(i) - h
c
  145    f = f + h
c     .......... ql transformation ..........
         p = d(m)
         c = 1.0d0
         c2 = c
         el1 = e(l1)
         s = 0.0d0
         mml = m - l
c     .......... for i=m-1 step -1 until l do -- ..........
         do 200 ii = 1, mml
            c3 = c2
            c2 = c
            s2 = s
            i = m - ii
            g = c * e(i)
            h = c * p
            r = pythag(p,e(i))
            e(i+1) = s * r
            s = e(i) / r
            c = p / r
            p = c * d(i) - s * g
            d(i+1) = h + s * (c * g + s * d(i))
c     .......... form vector ..........
            do 180 k = 1, n
               h = z(k,i+1)
               z(k,i+1) = s * z(k,i) + c * h
               z(k,i) = c * z(k,i) - s * h
  180       continue
c
  200    continue
c
         p = -s * s2 * c3 * el1 * e(l) / dl1
         e(l) = s * p
         d(l) = c * p
         tst2 = tst1 + dabs(e(l))
         if (tst2 .gt. tst1) go to 130
  220    d(l) = d(l) + f
  240 continue
c     .......... order eigenvalues and eigenvectors ..........
      do 300 ii = 2, n
         i = ii - 1
         k = i
         p = d(i)
c
         do 260 j = ii, n
            if (d(j) .ge. p) go to 260
            k = j
            p = d(j)
  260    continue
c
         if (k .eq. i) go to 300
         d(k) = d(i)
         d(i) = p
c
         do 280 j = 1, n
            p = z(j,i)
            z(j,i) = z(j,k)
            z(j,k) = p
  280    continue
c
  300 continue
c
      go to 1001
c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........
 1000 ierr = l
 1001 return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      subroutine tred1(nm,n,a,d,e,e2)
c
      integer i,j,k,l,n,ii,nm,jp1
      double precision a(nm,n),d(n),e(n),e2(n)
      double precision f,g,h,scale
c
c     this subroutine is a translation of the algol procedure tred1,
c     num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
c
c     this subroutine reduces a real symmetric matrix
c     to a symmetric tridiagonal matrix using
c     orthogonal similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the real symmetric input matrix.  only the
c          lower triangle of the matrix need be supplied.
c
c     on output
c
c        a contains information about the orthogonal trans-
c          formations used in the reduction in its strict lower
c          triangle.  the full upper triangle of a is unaltered.
c
c        d contains the diagonal elements of the tridiagonal matrix.
c
c        e contains the subdiagonal elements of the tridiagonal
c          matrix in its last n-1 positions.  e(1) is set to zero.
c
c        e2 contains the squares of the corresponding elements of e.
c          e2 may coincide with e if the squares are not needed.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      do 100 i = 1, n
         d(i) = a(n,i)
         a(n,i) = a(i,i)
  100 continue
c     .......... for i=n step -1 until 1 do -- ..........
      do 300 ii = 1, n
         i = n + 1 - ii
         l = i - 1
         h = 0.0d0
         scale = 0.0d0
         if (l .lt. 1) go to 130
c     .......... scale row (algol tol then not needed) ..........
         do 120 k = 1, l
  120    scale = scale + dabs(d(k))
c
         if (scale .ne. 0.0d0) go to 140
c
         do 125 j = 1, l
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = 0.0d0
  125    continue
c
  130    e(i) = 0.0d0
         e2(i) = 0.0d0
         go to 300
c
  140    do 150 k = 1, l
            d(k) = d(k) / scale
            h = h + d(k) * d(k)
  150    continue
c
         e2(i) = scale * scale * h
         f = d(l)
         g = -dsign(dsqrt(h),f)
         e(i) = scale * g
         h = h - f * g
         d(l) = f - g
         if (l .eq. 1) go to 285
c     .......... form a*u ..........
         do 170 j = 1, l
  170    e(j) = 0.0d0
c
         do 240 j = 1, l
            f = d(j)
            g = e(j) + a(j,j) * f
            jp1 = j + 1
            if (l .lt. jp1) go to 220
c
            do 200 k = jp1, l
               g = g + a(k,j) * d(k)
               e(k) = e(k) + a(k,j) * f
  200       continue
c
  220       e(j) = g
  240    continue
c     .......... form p ..........
         f = 0.0d0
c
         do 245 j = 1, l
            e(j) = e(j) / h
            f = f + e(j) * d(j)
  245    continue
c
         h = f / (h + h)
c     .......... form q ..........
         do 250 j = 1, l
  250    e(j) = e(j) - h * d(j)
c     .......... form reduced a ..........
         do 280 j = 1, l
            f = d(j)
            g = e(j)
c
            do 260 k = j, l
  260       a(k,j) = a(k,j) - f * e(k) - g * d(k)
c
  280    continue
c
  285    do 290 j = 1, l
            f = d(j)
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = f * scale
  290    continue
c
  300 continue
c
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      subroutine tred2(nm,n,a,d,e,z)
c
      integer i,j,k,l,n,ii,nm,jp1
      double precision a(nm,n),d(n),e(n),z(nm,n)
      double precision f,g,h,hh,scale
c
c     this subroutine is a translation of the algol procedure tred2,
c     num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
c
c     this subroutine reduces a real symmetric matrix to a
c     symmetric tridiagonal matrix using and accumulating
c     orthogonal similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the real symmetric input matrix.  only the
c          lower triangle of the matrix need be supplied.
c
c     on output
c
c        d contains the diagonal elements of the tridiagonal matrix.
c
c        e contains the subdiagonal elements of the tridiagonal
c          matrix in its last n-1 positions.  e(1) is set to zero.
c
c        z contains the orthogonal transformation matrix
c          produced in the reduction.
c
c        a and z may coincide.  if distinct, a is unaltered.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      do 100 i = 1, n
c
         do 80 j = i, n
   80    z(j,i) = a(j,i)
c
         d(i) = a(n,i)
  100 continue
c
      if (n .eq. 1) go to 510
c     .......... for i=n step -1 until 2 do -- ..........
      do 300 ii = 2, n
         i = n + 2 - ii
         l = i - 1
         h = 0.0d0
         scale = 0.0d0
         if (l .lt. 2) go to 130
c     .......... scale row (algol tol then not needed) ..........
         do 120 k = 1, l
  120    scale = scale + dabs(d(k))
c
         if (scale .ne. 0.0d0) go to 140
  130    e(i) = d(l)
c
         do 135 j = 1, l
            d(j) = z(l,j)
            z(i,j) = 0.0d0
            z(j,i) = 0.0d0
  135    continue
c
         go to 290
c
  140    do 150 k = 1, l
            d(k) = d(k) / scale
            h = h + d(k) * d(k)
  150    continue
c
         f = d(l)
         g = -dsign(dsqrt(h),f)
         e(i) = scale * g
         h = h - f * g
         d(l) = f - g
c     .......... form a*u ..........
         do 170 j = 1, l
  170    e(j) = 0.0d0
c
         do 240 j = 1, l
            f = d(j)
            z(j,i) = f
            g = e(j) + z(j,j) * f
            jp1 = j + 1
            if (l .lt. jp1) go to 220
c
            do 200 k = jp1, l
               g = g + z(k,j) * d(k)
               e(k) = e(k) + z(k,j) * f
  200       continue
c
  220       e(j) = g
  240    continue
c     .......... form p ..........
         f = 0.0d0
c
         do 245 j = 1, l
            e(j) = e(j) / h
            f = f + e(j) * d(j)
  245    continue
c
         hh = f / (h + h)
c     .......... form q ..........
         do 250 j = 1, l
  250    e(j) = e(j) - hh * d(j)
c     .......... form reduced a ..........
         do 280 j = 1, l
            f = d(j)
            g = e(j)
c
            do 260 k = j, l
  260       z(k,j) = z(k,j) - f * e(k) - g * d(k)
c
            d(j) = z(l,j)
            z(i,j) = 0.0d0
  280    continue
c
  290    d(i) = h
  300 continue
c     .......... accumulation of transformation matrices ..........
      do 500 i = 2, n
         l = i - 1
         z(n,l) = z(l,l)
         z(l,l) = 1.0d0
         h = d(i)
         if (h .eq. 0.0d0) go to 380
c
         do 330 k = 1, l
  330    d(k) = z(k,i) / h
c
         do 360 j = 1, l
            g = 0.0d0
c
            do 340 k = 1, l
  340       g = g + z(k,i) * z(k,j)
c
            do 360 k = 1, l
               z(k,j) = z(k,j) - g * d(k)
  360    continue
c
  380    do 400 k = 1, l
  400    z(k,i) = 0.0d0
c
  500 continue
c
  510 do 520 i = 1, n
         d(i) = z(n,i)
         z(n,i) = 0.0d0
  520 continue
c
      z(n,n) = 1.0d0
      e(1) = 0.0d0
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      double precision function pythag(a,b)
      double precision a,b
c
c     finds dsqrt(a**2+b**2) without overflow or destructive underflow
c
      double precision p,r,s,t,u
      p = dmax1(dabs(a),dabs(b))
      if (p .eq. 0.0d0) go to 20
      r = (dmin1(dabs(a),dabs(b))/p)**2
   10 continue
         t = 4.0d0 + r
         if (t .eq. 4.0d0) go to 20
         s = r/t
         u = 1.0d0 + 2.0d0*s
         p = u*p
         r = (s/u)**2 * r
      go to 10
   20 pythag = p
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Element: a subroutine for calculating atomic masses and enthalpy functions.
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful, 
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      SUBROUTINE element( ATYPE , MASS , Hfxn )
      
      DOUBLE PRECISION MASS , Hfxn , R
      CHARACTER ATYPE*6
      SAVE
c
c	MASS (atomic mass units) from NIST / JANAF 1998
c         Hfxn = [H(298.15) - H(0)]/R per atom   [NIST / JANAF]
c
      R = 8.314472D+00

         IF ( ATYPE.EQ.'C' ) THEN
            MASS = 12.011D+00
            Hfxn = 1.051/R
         ELSEIF ( ATYPE.EQ.'C12' ) THEN
            MASS = 12.0D+00
            Hfxn = 1.051 / R                ! assumed to be the same as "C"
         ELSEIF ( ATYPE.EQ.'C13' ) THEN
            MASS = 13.003355D+00
            Hfxn = 1.051 / R                ! assumed to be the same as "C"
         ELSEIF ( ATYPE.EQ.'C14' ) THEN
            MASS = 14.003242D+00
            Hfxn = 1.051 / R                ! assumed to be the same as "C"
         ELSEIF ( ATYPE.EQ.'C16' ) THEN
            MASS = 16.0147D+00
            Hfxn = 1.051 / R                ! assumed to be the same as "C"
         ELSEIF ( ATYPE.EQ.'H' ) THEN
            MASS = 1.00794D+00
            Hfxn = 8.467 / (2.0*R)
         ELSEIF ( ATYPE.EQ.'H1' ) THEN
            MASS = 1.007825D+00
            Hfxn = 8.467 / (2.0*R)          ! assumed to be the same as "H"
         ELSEIF ( ATYPE.EQ.'D' ) THEN
            MASS = 2.014102D+00
            Hfxn = 8.56 / (2.0*R)           ! calculated by using parameters found in NIST web-book
         ELSEIF ( ATYPE.EQ.'T' ) THEN
            MASS = 3.016049D+00
            Hfxn = 8.60 / (2.0*R)           ! calculated by using parameters found in NIST web-book
         ELSEIF ( ATYPE.EQ.'O' ) THEN
            MASS = 15.9994D+00
            Hfxn = 8.683 / (2.0*R)
         ELSEIF ( ATYPE.EQ.'O16' ) THEN
            MASS = 15.994915D+00
            Hfxn = 8.68 / (2.0*R)    ! Calculated using rot and vib constants from Edwards et al., J. Raman Spectrosc., 10, 60-63 (1981)
         ELSEIF ( ATYPE.EQ.'O17' ) THEN
            MASS = 16.9991315D+00
            Hfxn = 8.68 / (2.0*R)    ! Calculated using rot and vib constants from Edwards et al., J. Raman Spectrosc., 10, 60-63 (1981)
         ELSEIF ( ATYPE.EQ.'O18' ) THEN
            MASS = 17.999160D+00
            Hfxn = 8.69 / (2.0*R)    ! Calculated using rot and vib constants from Edwards et al., J. Raman Spectrosc., 10, 60-63 (1981)
         ELSEIF ( ATYPE.EQ.'N' ) THEN
            MASS = 14.00674D+00
            Hfxn = 8.670 / (2.0*R)
         ELSEIF ( ATYPE.EQ.'N14' ) THEN
            MASS = 14.003074D+00
            Hfxn = 8.670 / (2.0*R)    ! Calculated using rot and vib constants from Gilson et al., J. Raman Spectrosc. 9, 361-368 (1980) & Bendtsen, J. Raman Spectrosc. 2, 133-145 (1974)
         ELSEIF ( ATYPE.EQ.'N15' ) THEN
            MASS = 15.00010897D+00
            Hfxn = 8.670 / (2.0*R)    ! Calculated using rot and vib constants from Gilson et al., J. Raman Spectrosc. 9, 361-368 (1980) & Bendtsen, J. Raman Spectrosc. 2, 133-145 (1974)
         ELSEIF ( ATYPE.EQ.'F' ) THEN
            MASS = 18.998403D+00
            Hfxn = 8.825 / (2.0*R)
         ELSEIF ( ATYPE.EQ.'Cl' ) THEN
            MASS = 35.453D+00
            Hfxn = 9.181 / (2.0*R)
         ELSEIF ( ATYPE.EQ.'Cl35' ) THEN
            MASS = 34.96885271D+00
            Hfxn = 9.17 / (2.0*R)      ! Calculated using rot and vib constants from Bermejo et al., J. Mol. Spectrosc. 212, 186-193 (2002)
         ELSEIF ( ATYPE.EQ.'Cl37' ) THEN
            MASS = 36.9659D+00
            Hfxn = 9.16 / (2.0*R)      ! Calculated using rot and vib constants from Bermejo et al., J. Mol. Spectrosc. 212, 186-193 (2002)
         ELSEIF ( ATYPE.EQ.'Br' ) THEN
            MASS = 79.904D+00
            Hfxn = 24.509 / (2.0*R)
         ELSEIF ( ATYPE.EQ.'Br79' ) THEN
            MASS = 78.918338D+00
            Hfxn = 24.509 / (2.0*R)    ! assumed to be the same as "Br"
         ELSEIF ( ATYPE.EQ.'Br81' ) THEN
            MASS = 80.916291D+00
            Hfxn = 24.509 / (2.0*R)    ! assumed to be the same as "Br"
         ELSEIF ( ATYPE.EQ.'I ' ) THEN
            MASS = 126.9045D+00
            Hfxn = 13.198 / (2.0*R)
         ELSEIF ( ATYPE.EQ.'S' ) THEN
            MASS = 32.06D+00
            Hfxn = 4.412 / R
         ELSEIF ( ATYPE.EQ.'S32' ) THEN
            MASS = 31.9720707D+00
            Hfxn = 4.412 / R             ! assumed to be the same as "S"
         ELSEIF ( ATYPE.EQ.'S34' ) THEN
            MASS = 33.9678668D+00
            Hfxn = 4.412 / R             ! assumed to be the same as "S"
         ELSEIF ( ATYPE.EQ.'P' ) THEN
            MASS = 30.97376D+00
            Hfxn = 5.360 / R
         ELSEIF ( ATYPE.EQ.'Si' ) THEN
            MASS = 28.0855D+00
            Hfxn = 3.218/ R
         ELSEIF ( ATYPE.EQ.'B' ) THEN
            MASS = 10.81D+00
            Hfxn = 1.214/ R
         ELSEIF ( ATYPE.EQ.'Li' ) THEN
            MASS = 6.941D+00
            Hfxn = 4.622/ R
         ELSEIF ( ATYPE.EQ.'Hg' ) THEN
            MASS = 200.59D+00
            Hfxn = 9.343/ R
         ELSEIF ( ATYPE.EQ.'K' ) THEN
            MASS = 39.0983D+00
            Hfxn = 7.082/ R
         ELSEIF ( ATYPE.EQ.'Rb' ) THEN
            MASS = 85.4678D+00
            Hfxn = 7.490/ R
         ELSEIF ( ATYPE.EQ.'Se' ) THEN
            MASS = 78.96D+00
            Hfxn = 5.519/ R
         ELSEIF ( ATYPE.EQ.'Na' ) THEN
            MASS = 22.98977D+00
            Hfxn = 6.447/ R
         ELSEIF ( ATYPE.EQ.'Te' ) THEN
            MASS = 127.60D+00
            Hfxn = 6.121/ R
         ELSEIF ( ATYPE.EQ.'Sn' ) THEN
            MASS = 118.69D+00
            Hfxn = 6.297/ R
         ELSEIF ( ATYPE.EQ.'Si' ) THEN
            MASS = 28.0855D+00
            Hfxn = 3.218 / R
         ELSEIF ( ATYPE.EQ.'Si29' ) THEN
            MASS = 28.98D+00
            Hfxn = 3.218 / R              ! assumed to be the same as Si
         ELSEIF ( ATYPE.EQ.'Si30' ) THEN
            MASS = 29.97D+00
            Hfxn = 3.218 / R              ! assumed to be the same as Si
         ELSEIF ( ATYPE.EQ.'He' ) THEN
            MASS = 4.00260D+00
            Hfxn = 6.197 / R
         ELSEIF ( ATYPE.EQ.'Ne' ) THEN
            MASS = 20.179D+00
            Hfxn = 6.197 / R
         ELSEIF ( ATYPE.EQ.'Ar' ) THEN
            MASS = 39.948D+00
            Hfxn = 6.197 / R
         ELSEIF ( ATYPE.EQ.'Kr' ) THEN
            MASS = 83.80D+00
            Hfxn = 6.197 / R
         ELSEIF ( ATYPE.EQ.'Xe' ) THEN
            MASS = 131.29D+00
            Hfxn = 6.197 / R
         ELSE
            STOP 'Element not recognized in subroutine element.f'
         ENDIF

      RETURN
      END
      
      
 
      PROGRAM MOMINERT
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c MomInert: a code for moments of inertia.
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C     Designed to calculated moments of inertia for internal rotations.
C     These can either be connected to a larger mass object or stand-alone.
C
C     Input File Specifications:
C
C     1. Title
C             A line, up to 100 characters, describing the data.  This title is
C        reproduced in the output file.
C
C     2. Total number of atoms in the molecule, NATOMS.
C
C     3. Atom type, Atom index, X-coordinate, Y-coordinate, Z-coordinate
C        Atom type: Character*2, case sensitive atomic symbol, eg C, Br
C        Atom index: Identification number of the atom (1 to NATOMS)
C        X-coordinate, Y-coordinate, Z-coordinate in angstroms
C
C        Repeat for every atom.
C
C     4. Atom indices for the two atoms defining the axis of rotation. If the
C       atom indices are set equal to zero, then internal rotor is not calculated
C       and lines #5 and #6 can be omitted.
C
C     5. Number of atoms in one of the rotating moieties.
C
C     6. List of the atoms in that moiety.
C
C     7. If you wish to include more 1-D rotors, repeat steps 4-6 for each.
C        TO TERMINATE, ENTER A LINE CONTAINING TWO ZEROS: 0 , 0
C
C     8. BLANK LINE
C
C     Cartesian coordinates are in Angstroms, and the moments of inertia
C     are reported in amu*Ang*Ang.
 
      IMPLICIT NONE
 
      CHARACTER AVERSION*6, ADATE*8
      PARAMETER ( AVERSION='2010', ADATE='Jan 2010' )

      INTEGER NATOMS , I , J , K , ROT1 , ROT2 , NUMROT , ROTING1(100)
      INTEGER ROTING2(100) , NUMROT2 , MOL , ATOM3 , N , NP , ierr , IV
      CHARACTER*6 ATYPE(100) , AT
      CHARACTER*100 TITLE
      DOUBLE PRECISION XCOORD(100) , YCOORD(100) , ZCOORD(100) , X1 , 
     &                 X2 , X3
      DOUBLE PRECISION Y1 , Y2 , Y3 , Z1 , Z2 , Z3 , R(100) , A1 , A2 , 
     &                 C1 , C2
      DOUBLE PRECISION D1 , D2 , A , C , DIST1(100) , DIST2(100) , X , 
     &                 Y , Z
      DOUBLE PRECISION MASS(100) , MOMENT1 , MOMENT2 , REDMOM , XC , 
     &                 YC , ZC
      DOUBLE PRECISION TOTMASS , XCM , YCM , ZCM , XPRIME(100) , 
     &                 YPRIME(100)
      DOUBLE PRECISION ZPRIME(100) , IXX , IYY , IZZ , IYZ , IXY , IXZ
      DOUBLE PRECISION MAT(3,3) , EIG(3) , fv1(3) , fv2(3) , ZZ(3,3)
      DOUBLE PRECISION TESTX12 , TESTX13 , TESTY12 , TESTY13 , TESTZ12 ,
     &                 TESTZ13 , CONV
      DOUBLE PRECISION XCM1 , YCM1 , ZCM1 , re
      INTEGER  FRGM1, FRGM2 , ncount
      DOUBLE PRECISION Hfxn
 
      OPEN (UNIT=4,FILE='mominert.out',STATUS='UNKNOWN')
      OPEN (UNIT=2,FILE='mominert.dat',STATUS='OLD')
 
      READ (2,99001) TITLE
!-------------------------------------------------------------------
      READ (2,*,err=50) NATOMS, FRGM1, FRGM2
      READ (2,*,err=50) NATOMS
      IF(FRGM1+FRGM2.NE.NATOMS) then
       write(*,*) " Wrong fragments definition. Program stopped"
       stop
      ENDIF 
      goto 60
50    backspace(2)
      backspace(2)
      READ (2,*) NATOMS
!-------------------------------------------------------------------
 
60    WRITE (4,99002) AVERSION , ADATE , AVERSION , ADATE
      WRITE (4,*) TITLE
      WRITE (4,*)
      WRITE (4,99003) 'NUMBER' , 'TYPE  ' , 'X' , 'Y' , 'Z'
  
C     Here zero all arrays to avoid external interference with calculations.
 
      DO 100 I = 1 , 100
         DIST1(I) = 0.D+00
         DIST2(I) = 0.D+00
         XCOORD(I) = 0.D+00
         YCOORD(I) = 0.D+00
         ZCOORD(I) = 0.D+00
         R(I) = 0.D+00
         ROTING1(I) = 0
         ROTING2(I) = 0
 100  CONTINUE
 
      DO 200 I = 1 , NATOMS
         READ (2,*) AT , MOL , XC , YC , ZC
         ATYPE(MOL) = AT
         XCOORD(MOL) = XC
         YCOORD(MOL) = YC
         ZCOORD(MOL) = ZC
 200  CONTINUE
 
      DO 300 I = 1 , NATOMS
         WRITE (4,99004) I , ATYPE(I) , XCOORD(I) , YCOORD(I) , 
     &                   ZCOORD(I)
 300  CONTINUE
 
C     Define the mass of each atom.
C     This is done with simple character recognition, and the masses are
C     given in units of amu.
 
      DO 400 I = 1 , NATOMS
        CALL element( ATYPE(I), MASS(I) , Hfxn )    ! Note: Hfxn not used by this program
 400  CONTINUE
 
C     Read atoms which define rotation axis and report them to user.
 
      DO

      WRITE (4,*)
      READ (2,*) ROT1 , ROT2

      IF ( ROT1 .GT. 0 ) THEN
         WRITE (4,99005) ROT1 , ROT2 
         READ (2,*) NUMROT
 
C     Read atoms which make up the first rotating moiety and report them.
C     Reporting allows for ease in finding mistakes.
 
         WRITE (4,*)
         READ (2,*) (ROTING1(I),I=1,NUMROT)

99941  FORMAT('  MOIETY 1 CONTAINS ATOMS:',50I3)

         WRITE (4,99941) (ROTING1(I),I=1,NUMROT)
 
         WRITE (4,*)
 
C     All atoms which are not in the first moiety must be in the second
C     moiety.  Define it here.
 
         NUMROT2 = NATOMS - NUMROT
         K = 1
         DO 450 I = 1 , NATOMS
            DO 420 J = 1 , NUMROT
               IF ( I.EQ.ROTING1(J) ) GOTO 450
 420        CONTINUE
            ROTING2(K) = I
            K = K + 1
 450     CONTINUE
 
99942  FORMAT('  MOIETY 2 CONTAINS ATOMS:',50I3)

         WRITE (4,99942) (ROTING2(I),I=1,NUMROT2)
 
         WRITE (4,*)

c
c
c
C     Some quick idiot lights...
         
         IF ( ROT1.LT.0 ) THEN
            WRITE (4,*) 'ROTATION AXIS UNDEFINED'
            STOP
         ENDIF
 
         IF ( ROT1.GT.NATOMS ) THEN
            WRITE (4,*) 'ROTATION AXIS UNDEFINED'
            STOP
         ENDIF
 
         IF ( ROT2.LE.0 ) THEN
            WRITE (4,*) 'ROTATION AXIS UNDEFINED'
            STOP
         ENDIF
 
         IF ( ROT2.GT.NATOMS ) THEN
            WRITE (4,*) 'ROTATION AXIS UNDEFINED'
            STOP
         ENDIF
 
         IF ( NUMROT.GT.(NATOMS-1) ) THEN
            WRITE (4,*) 'ROTATING MOIETY IMPROPERLY DEFINED'
            STOP
         ENDIF
 
         DO 500 I = 1 , NUMROT
            IF ( ROTING1(I).LE.0 ) THEN
               WRITE (4,*) 'ROTATING MOIETY IMPROPERLY DEFINED'
               STOP
            ENDIF
 
            IF ( ROTING1(I).GT.NATOMS ) THEN
               WRITE (4,*) 'ROTATING MOIETY IMPROPERLY DEFINED'
               STOP
            ENDIF
 
 500     CONTINUE

C     Begin defining planes as used to determine radial distance to
C     axis of rotation.  Use the coord.s of each axis-defining atom to
C     start, but you need one more point. Take the first atom in the list
C     which is neither ROT1 nor ROT2 to be the other defining point for
C     the first plane.
 
         DO 550 I = 1 , NATOMS
            IF ( I.NE.ROT1 ) THEN
               IF ( I.NE.ROT2 ) GOTO 600
            ENDIF
 550     CONTINUE
 
 600     ATOM3 = I
 
C     If (X2-X1) or (X3-X1) or (Z2-Z1) or (Z3-Z1) is equal to zero, the
C     definition of the planes as here will not work.  So, if this is true,
C     send the coordinates to a subroutine which will rotate the molecule
C     while  leaving it unchanged.
c
c     If one rotation isn't effective, do it over, and over, and over...
 
         ncount = 0
         CONV = 1.0D-04
650      ncount = ncount + 1
         IF ( ncount .GT. 10 ) go to 651
         
         X1 = XCOORD(ROT1)
         Y1 = YCOORD(ROT1)
         Z1 = ZCOORD(ROT1)
 
         X2 = XCOORD(ROT2)
         Y2 = YCOORD(ROT2)
         Z2 = ZCOORD(ROT2)
 
         X3 = XCOORD(ATOM3)
         Y3 = YCOORD(ATOM3)
         Z3 = ZCOORD(ATOM3)
 
         TESTX12 = ABS(X1-X2)
         TESTX13 = ABS(X1-X3)
         TESTY12 = ABS(Y1-Y2)
         TESTY13 = ABS(Y1-Y3)
         TESTZ12 = ABS(Z1-Z2)
         TESTZ13 = ABS(Z1-Z3)
         
         IF ( (TESTX12.LE.CONV) .OR. (TESTX13.LE.CONV) .OR. 
     &        (TESTY13.LE.CONV) .OR. (TESTY12.LE.CONV) .OR.
     &        (TESTZ13.LE.CONV) .OR. (TESTZ12.LE.CONV) ) THEN
            CALL ROTATE(XCOORD,YCOORD,ZCOORD,NATOMS)
C            WRITE (*,*) 'Rotations: ', ncount
            GOTO 650
         ENDIF
         
651      CONTINUE
 
C     Define each plane according to 'Direction Numbers' A, B, C, and D
C     such that Ax+By+Cz+D=0.  Start by fitting the plane through the
C     three atoms selected.  That's why only one can have coordinates of
C     zero.  For simplicity, B=1.
 
         A = ((Y3-Y1)/(Z3-Z1)) - ((Y2-Y1)/(Z2-Z1))
         A1 = A/(((X2-X1)/(Z2-Z1))-((X3-X1)/(Z3-Z1)))
 
         C = ((Y3-Y1)/(X3-X1)) - ((Y2-Y1)/(X2-X1))
         C1 = C/(((Z2-Z1)/(X2-X1))-((Z3-Z1)/(X3-X1)))
 
         D1 = -(A1*X1) - Y1 - (C1*Z1)
 
C     Now, using the two axis-defining atoms and the other plane (which
C     is perpendicular to this one) define the second plane.  The
C     intersection of these two planes is the rotation axis in three
C     dimensions.  Again, B=1.
 
         A = (1/C1) - ((Y2-Y1)/(Z2-Z1))
         A2 = A/(((X2-X1)/(Z2-Z1))-(A1/C1))
 
         C = (1/A1) - ((Y2-Y1)/(X2-X1))
         C2 = C/(((Z2-Z1)/(X2-X1))-(C1/A1))
 
         D2 = -(A2*X1) - Y1 - (C2*Z1)
         
         
c         write(*,*) A1 , C1, D1, A2, C2, D2
         
C     Find the distance from each atom to each of the two planes.  Since
C     the planes are perpendicular, the distance to the intersection is
C     the hypoteneuse of the right triangle.  It's not necessary, but
C     to ensure positive radial distances take the absolute values of the
C     distance to each plane.
C     Then use the Pythagorean Theorem to calculate the radial distance of
C     each atom to the rotation axis.
 
         DO 700 I = 1 , NATOMS
            X = XCOORD(I)
            Y = YCOORD(I)
            Z = ZCOORD(I)
            DIST1(I) = ((A1*X)+Y+(C1*Z)+D1)/(SQRT((A1*A1)+1+(C1*C1)))
            DIST1(I) = ABS(DIST1(I))
            DIST2(I) = ((A2*X)+Y+(C2*Z)+D2)/(SQRT((A2*A2)+1+(C2*C2)))
            DIST2(I) = ABS(DIST2(I))
            R(I) = SQRT((DIST1(I)**2)+(DIST2(I)**2))
700     CONTINUE
 
C     Compute the moment of inertia for the first rotor,  using the
C     formula Im=sum(m*r*r)
 
         MOMENT1 = 0
         DO 750 I = 1 , NUMROT
            MOMENT1 = MOMENT1 + (MASS(ROTING1(I))*R(ROTING1(I))
     &                *R(ROTING1(I)))
 750     CONTINUE
 
         WRITE (4,99006) MOMENT1
         WRITE (4,99906) MOMENT1*1.66053878d-040
         WRITE (4,99996) 16.85763D+00/MOMENT1, 5.05379D+005/MOMENT1,
     &          5.05379D+002/MOMENT1
 
         WRITE (4,*)
 
C     Compute the moment of inertia for the second rotor,  using the
C     formula Im=sum(m*r*r)
 
         MOMENT2 = 0
         DO 800 I = 1 , NUMROT2
            MOMENT2 = MOMENT2 + (MASS(ROTING2(I))*R(ROTING2(I))
     &                *R(ROTING2(I)))
 800     CONTINUE
 
         WRITE (4,99007) MOMENT2
         WRITE (4,99906) MOMENT2*1.660538782d-040
         WRITE (4,99996) 16.85763D+00/MOMENT2, 5.05379D+005/MOMENT2,
     &          5.05379D+002/MOMENT2
 
         WRITE (4,*)
 
         REDMOM = (MOMENT1*MOMENT2)/(MOMENT1+MOMENT2)
         WRITE (4,99008) ROT1, ROT2, REDMOM
         WRITE (4,99906) REDMOM*1.660538782d-040
         WRITE (4,99996) 16.85763D+00/REDMOM, 5.05379D+005/REDMOM,
     &          5.05379D+002/REDMOM

      ELSE
        GO TO 999
      ENDIF
      enddo

999   TOTMASS = 0.D+00
      XCM = 0.D+00
      YCM = 0.D+00
      ZCM = 0.D+00
      IXX = 0.D+00
      IYY = 0.D+00
      IZZ = 0.D+00
      IXY = 0.D+00
      IYZ = 0.D+00
      IXZ = 0.D+00
 
C     Calculate center-of-mass of molecule
 
      DO 900 I = 1 , NATOMS
         TOTMASS = TOTMASS + MASS(I)
         XCM = XCM + (MASS(I)*XCOORD(I))
         YCM = YCM + (MASS(I)*YCOORD(I))
         ZCM = ZCM + (MASS(I)*ZCOORD(I))
 900  CONTINUE
 
      XCM = XCM/TOTMASS
      YCM = YCM/TOTMASS
      ZCM = ZCM/TOTMASS

C     Use existing coordinates and center-of-mass coordinates to find
C     new, 'internal' coordinates x', y', z'
 
      DO 1000 I = 1 , NATOMS
         XPRIME(I) = XCOORD(I) - XCM
         YPRIME(I) = YCOORD(I) - YCM
         ZPRIME(I) = ZCOORD(I) - ZCM
      
C    Use x', y', and z' to calculate moments and products of inertia

         IXX = IXX + (MASS(I)*(YPRIME(I)**2+ZPRIME(I)**2))
         IYY = IYY + (MASS(I)*(XPRIME(I)**2+ZPRIME(I)**2))
         IZZ = IZZ + (MASS(I)*(XPRIME(I)**2+YPRIME(I)**2))
         IXY = IXY + MASS(I)*XPRIME(I)*YPRIME(I)
         IXZ = IXZ + MASS(I)*XPRIME(I)*ZPRIME(I)
         IYZ = IYZ + MASS(I)*YPRIME(I)*ZPRIME(I)
 1000 CONTINUE
 
C     Compose matrix of moments and products of inertia
      MAT(1,1) = IXX
      MAT(1,2) = -IXY
      MAT(1,3) = -IXZ
      MAT(2,1) = -IXY
      MAT(2,2) = IYY
      MAT(2,3) = -IYZ
      MAT(3,1) = -IXZ
      MAT(3,2) = -IYZ
      MAT(3,3) = IZZ
 
      N = 3
      NP = 3
      IV = 0
 
C     Find eigenvalues
 
      CALL rs(N,NP,MAT,EIG,IV,ZZ,fv1,fv2,ierr)
 
      WRITE (4,99010) ( EIG(i) , i=1,3 ) ,
     &     ( EIG(i)*1.660538782d-040 , i=1,3 ) , 
     &     ( 16.85763D+00/EIG(i) , i=1,3 ) ,
     &     ( 5.05379D+005/EIG(i) , i=1,3 ) ,
     &     ( 5.05379D+002/EIG(i) , i=1,3 ) 


!----------------------------------------------------------------
c     Distance between center of mass

       IF(FRGM1.GT.0) then
        CALL CMdist(XCOORD,YCOORD,ZCOORD,MASS,FRGM1,FRGM2,NATOMS,re,
     & XCM1,XCM,YCM1,YCM,ZCM1,ZCM)
        WRITE(4,99012) re
        WRITE(4,99013)
        WRITE(4,99014) "   MOIETY  1 ( 1-",FRGM1,") :   ",XCM,YCM,ZCM
        WRITE(4,99015) "   MOIETY  2 (",FRGM1+1,"-",NATOMS,") :   ",
     & XCM1,YCM1,ZCM1
       ENDIF

!----------------------------------------------------------------
!
!      WRITE(4,99011) NATOMS-FRGM2, NATOMS-FRGM2+1, NATOMS 
!      WRITE(4,99012) re
!----------------------------------------------------------------

 
99001 FORMAT (A100)
99002 FORMAT (
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'                                John R. Barker'/8x,
     &'       Mominert-',A6,'          University of Michigan'/8x,
     &'                                Ann Arbor, MI 48109-2143'/8x,
     &'       ',A8,'                 jrbarker@umich.edu'/8x,
     &'                                (734) 763 6239'//8x,
     &'      http://aoss.engin.umich.edu/multiwell/'//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'Suggested Literature Citation:'//8x,
     &'a) MultiWell-',A6,' Software, ',A8,', designed and'/11x,
     &'maintained by J.R. Barker with contributors N.F. Ortiz,'/11x,
     &'J.M. Preses, L.L. Lohr, A. Maranzana, P.J. Stimac, T. L.'/11x,
     &'Nguyen, and T. J. Dhilip Kumar, University of Michigan,'/11x,
     &'Ann Arbor, MI; http://aoss.engin.umich.edu/multiwell/',//8x,
     &'b) J.R. Barker, Int. J. Chem. Kinetics, 33, 232-45 (2001)',//8x,
     &//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'/)
99003 FORMAT (1X,A6,2X,A6,7X,A1,2(11X,A1))
99004 FORMAT (2X,I3,5X,A6,3(3X,F9.6))
99005 FORMAT (//,2X,'ATOMS ',I3,' AND ',I3,
     &         ' DEFINE INTERNAL ROTATION AXIS')
99006 FORMAT (2X,'MOMENT OF INERTIA ABOUT BOND FOR MOIETY #1: ',
     &            F9.3,'   amu*Ang^2')
99906 FORMAT (45X,1PE10.3,'   g*cm^2')
99996 FORMAT (14X,'Rotational constant:  B = ',F15.5,'   cm-1',/,
     &        14X,'                      B = ',F15.5,'   MHz',/ ,
     &        14X,'                      B = ',F15.5,'   GHz',/ )
99007 FORMAT (2X,'MOMENT OF INERTIA ABOUT BOND FOR MOIETY #2: ',
     &            F9.3,'   amu*Ang^2')
99008 FORMAT (2X,'REDUCED MOMENT OF INERTIA ABOUT ',I2,'--',I2,' BOND:',
     &         F9.3,'   amu*Ang^2')
99009 FORMAT (5X,A31,1X,I3,1X,A3,1X,I3)
99010 FORMAT (/,'PRINCIPAL MOMENTS OF INERTIA AND ROTATIONAL CONSTANTS',
     & /,
     & 5x,'Ia = ',F12.4,10x,'Ib = ',F12.4,10x,'Ic = ',F12.4,3x,
     & ' amu*ang^2',/,
     & 5x,'Ia = ',1pe12.4,10x,'Ib = ',1pe12.4,10x,'Ic = ',1pe12.4,3x,
     & ' g*cm^2',/,
     & 5x,'Ba = ',0pF12.4,10x,'Bb = ',0pF12.4, 10x,'Bc = ',0pF12.4,3x,
     & ' cm-1',/,
     & 5x,'Ba = ',0pF12.4,10x,'Bb = ',0pF12.4, 10x,'Bc = ',0pF12.4,3x,
     & ' MHz',/,
     & 5x,'Ba = ',0pF12.4,10x,'Bb = ',0pF12.4, 10x,'Bc = ',0pF12.4,3x,
     & ' GHz',/ )
99012 FORMAT (//,"DISTANCE BETWEEN CENTERS OF MASS = ", F11.6," Ang"/)
99013 FORMAT ("   CENTER OF MASS COORDINATES: ")
99014 FORMAT (A16,I2,A6,T23,3F12.6)
99015 FORMAT (A14,I2,A1,I2,A6,T23,3F12.6,//)
 
      END
**==rotate.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
 
      SUBROUTINE ROTATE(XCOORD,YCOORD,ZCOORD,NATOMS)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c MomInert: a code for calculating moments of inertia
c Copyright (C) 2001 Nicolas F. Ortiz and John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
C     Modified by Amity Andersen and William Schneider (July 2000)
C
C     Rotates the cartesian coordinates with the three Euler angle
C     transformation matrices; the Euler angles are chosen randomly from 0 to
C     2*pi.  This procedure allows the cartesian coordinates of each atom to
C     change while leaving the geometry of the molecule intact, thereby
C     allowing the definition of planes in the main code.
 
      INTEGER I , NATOMS
      DOUBLE PRECISION XCOORD(150) , YCOORD(150) , ZCOORD(150)
      DOUBLE PRECISION X(150) , Y(150) , Z(150)
      DOUBLE PRECISION PHI , THETA , PSI , TWOPI , FAC
      DOUBLE PRECISION LAMBDA(3,3)
 
 
 
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
C..rotation algorithm using pseudorandom euler angles
C..define pi...
      TWOPI = 8.0D+00*ATAN(1.0D+00)
      FAC = 0.05D+00
      PHI = FAC*TWOPI
      THETA = FAC*TWOPI
      PSI = FAC*TWOPI

C..the phi, theta, and psi combined tranformation matrix, lambda
      LAMBDA(1,1) = COS(PSI)*COS(PHI) - SIN(PSI)*COS(THETA)*SIN(PHI)
      LAMBDA(1,2) = COS(PSI)*SIN(PHI) + SIN(PSI)*COS(THETA)*COS(PHI)
      LAMBDA(1,3) = SIN(PSI)*SIN(THETA)
      LAMBDA(2,1) = -SIN(PSI)*COS(PHI) - COS(PSI)*COS(THETA)*SIN(PHI)
      LAMBDA(2,2) = -SIN(PSI)*SIN(PHI) + COS(PSI)*COS(THETA)*COS(PHI)
      LAMBDA(2,3) = COS(PSI)*SIN(THETA)
      LAMBDA(3,1) = SIN(THETA)*SIN(PHI)
      LAMBDA(3,2) = -SIN(THETA)*COS(PHI)
      LAMBDA(3,3) = COS(THETA)
 
C..use matrix to rotate axes
      DO 100 I = 1 , NATOMS
         X(I) = LAMBDA(1,1)*XCOORD(I) + LAMBDA(1,2)*YCOORD(I)
     &          + LAMBDA(1,3)*ZCOORD(I)
         Y(I) = LAMBDA(2,1)*XCOORD(I) + LAMBDA(2,2)*YCOORD(I)
     &          + LAMBDA(2,3)*ZCOORD(I)
         Z(I) = LAMBDA(3,1)*XCOORD(I) + LAMBDA(3,2)*YCOORD(I)
     &          + LAMBDA(3,3)*ZCOORD(I)
         XCOORD(I) = X(I)
         YCOORD(I) = Y(I)
         ZCOORD(I) = Z(I)
 100  CONTINUE
 
      RETURN
      END
 
 
