**==alngam.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
 
      DOUBLE PRECISION FUNCTION ALNGAM(YY)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c DenSum: a code for calculating sums and densities of states.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c	Natural logarithm of the gamma FUNCTION of X
c
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE 
      PI = 4.0D+00*DATAN(1.0D+00)
      TWOPI = 2.0D+00*PI
      X = YY
      Z = 0.0
 100  IF ( X.GE.1.5 ) THEN
         X2 = X*X
         X3 = X2*X
         X5 = X2*X3
         X7 = X2*X5
         ALNGAM = -Z + (X-0.5)*LOG(X) - X + 0.5*LOG(TWOPI)
     &            + 1.0/(12.0*X) - 1.0/(360.0*X3) + 1.0/(1260.0*X5)
     &            - 1.0/(1680.0*X7)
      ELSE
         ALNGAM = 0.0
         IF ( X.GT.0.0 ) THEN
            Z = Z + LOG(X)
            X = X + 1.0
            GOTO 100
         ENDIF
      ENDIF
 200  RETURN
      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 Andrea Maranzana and John R. Barker
c
c Andrea Maranzana
c andrea.maranzana@unito.it
c Department of General and Organic Chemistry
c University of Torino
c Corso Massimo D'Azeglio, 48
c Torino  10125
c ITALY
c ++39-011-670-7637
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      Subroutine chemformula(i,formula)

      include 'declare.inc'
      character*90 formula, char2
      character*4 char1, char3
      integer y, z, L, maxlen, MaxL
      integer y1, y2, digit, ntype , niso
      integer numtot, times

      parameter(maxL=101)  
      parameter(ntype=101)
      parameter(niso=18)           ! number of isotopes (e.g. 'Si30')
      character*4 ATYPETEMP(maxL)
      integer Natomtemp(MaxL)
      character*4 AtomType(ntype)

      data AtomType/' C12',' C13',' C14', ' C16', ' O16', ' O17',' O18',
     2 ' H1','N14','N15','Cl35','Cl37','Br79','Br81','S32','S34','Si29',
     3 'Si30', 
     3 ' H', ' D', ' T', ' He',  ' Li', ' Be',  ' B', ' C',  ' N', ' O',
     4 ' F','Ne','Na','Mg','Al','Si',' P',' S','Cl','Ar',' K','Ca','Sc',
     5 'Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn','Ga',
     6 'Ge','As','Se','Br','Kr','Rb','Sr',' Y','Zr','Nb','Mo','Tc','Ru',
     7 'Rh','Pd','Ag','Cd','In','Sn','Sb','Te',' I','Xe','Cs','Ba','La',
     8 'Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb',
     9 'Lu','Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg','Pb'/

      L=0


!------------(R)n  ->  RRRRRR  ---------------------------------------
      char1="("
      char3=")"
      do
       y1=index(TRIM(formula),TRIM(char1))
       y2=index(TRIM(formula),TRIM(char3))
       IF(y1.eq.0.and.y2.eq.0) exit
       IF(y1.eq.0.and.y2.ne.0) STOP 'Error in chemical formula'
       IF(y1.ne.0.and.y2.eq.0) STOP 'Error in chemical formula'
       
       if(y2.eq.len(TRIM(formula))) then
        call delete(formula,y2,y2)
        call delete(formula,y1,y1)
        exit
       endif

       call checknumber(formula,y2+1,times)
       if(times.gt.1) then 
        call repeatText(formula,y1,y2,times)
       else
        call delete(formula,y2,y2)
        call delete(formula,y1,y1)
       endif

      enddo
!--------------------------------------------------------------------
      

100      k=0
      do 
         k=k+1
         if(k.gt.ntype) THEN
          OPEN (UNIT=10,STATUS='UNKNOWN',FILE='thermo.ERROR')          ! Error output
          write (10,*) 'Element not recognized in chemformula.f'
          write (*,*) 'Element not recognized in chemformula.f'
          CLOSE(10)
          STOP
         ENDIF

         char1=ADJUSTL(AtomType(k))
         char2=TRIM(ADJUSTL(formula))
         IF(char2.EQ.'') exit
         z=index(TRIM(formula),TRIM(char1))
         maxlen=len(TRIM(char1))
         if(z.eq.0) GOTO 1000
         IF(k.le.niso.AND.z.eq.1) GOTO 1000
         
         IF(z.gt.1) then
          IF(char2(z-1:z-1).ne."[".AND.k.le.niso) goto 1000
         endif

!   ---------to avoid C for Cr, Cu etc..-------------------------
         y1=ICHAR(char2(z+1:z+1))
         IF(y1.ge.97.and.maxlen.eq.1) goto 1000
!   -------------------------------------------------------------

         IF(k.le.niso) then    ! isotopes [XX]
                   y=1
         else
                   y=0
         endif

          L=L+1

          IF(L.gt.MaxL) then 
           OPEN (UNIT=10,STATUS='UNKNOWN',FILE='thermo.ERROR')   !  Error output
           write (10,*) 'Too many elements in chemformula.f'
           write (*,*)  'Too many elements in in chemformula.f'
           CLOSE(10)
           STOP
          ENDIF


          ATYPETEMP(L)=TRIM(char1)
  
          call checknumber(formula,z+maxlen+y,times)
          IF(times.le.9) then
           digit=1
          else
           digit=2
          endif
          if(times.le.0) then
             digit=0
             times=1
          endif
          Natomtemp(L)=times
          call delete(formula,z-y,z+maxlen+digit+y-1)
          GOTO 100
         
1000  CONTINUE
      enddo

!---------count ATYPE and Nelement-----------------------------------

      !ATYPE(i,ne) Natom(i,ne) Nelement(i)
      
      Nelement(i)=0
      do y1= 1, ntype
       numtot=0
       do y2= 1, L
        IF(TRIM(ADJUSTL(ATYPETEMP(y2))).eq.TRIM(ADJUSTL(AtomType(y1))))
     &    numtot=numtot+Natomtemp(y2)
       enddo
       IF(numtot.ne.0) then 
        Nelement(i)=Nelement(i)+1
        ATYPE(i,Nelement(i))=TRIM(ADJUSTL(AtomType(y1)))
        Natom(i,Nelement(i))=numtot
       endif
      enddo


      END subroutine


!--------------Delete characters from start to finish ---------------
      subroutine delete(formula,start,finish)
      Character*90 formula
      integer start,finish

       formula=(ADJUSTL(formula(1:start-1))
     &                    //ADJUSTL(formula(finish+1:len(formula))))
       
      return

      end subroutine


!--------------Repeat characters from start to finish  "times" times --
      subroutine repeatText(formula,start,finish,times)
      Character*90 formula
      Character*90 copytxt, txt
      integer start,finish,times, xx, digit
      IF(times.le.9) then
       digit=1
      else
       digit=2
      endif

      txt=""
      copytxt=TRIM(ADJUSTL(formula(start+1:finish-1)))
      do xx=1, times
       txt=TRIM(ADJUSTL(txt))//TRIM(ADJUSTL(copytxt)) 
      enddo
       formula=(ADJUSTL(formula(1:start-1))
     &  //TRIM(ADJUSTL(txt))//formula(finish+1+digit:len(formula)))

      return

      end subroutine


!--------------Check if character in start is a number ----------------
      subroutine Checknumber(formula,start,number)
      Character*90 formula
      Character*90 txt
      integer start,number, xx, numtemp(2)

      if(start.gt.LEN(TRIM(ADJUSTL(formula)))) then
        number=-1
        return
      endif

      do xx=0, 1
      if(start+xx.gt.LEN(TRIM(ADJUSTL(formula)))) then
        numtemp(2)=-1
        exit
      endif
       txt=TRIM(ADJUSTL(formula(start+xx:start+xx)))
       IF(ICHAR(TRIM(txt)).ge.48.AND.ICHAR(TRIM(txt)).le.57) then
        Read( txt,*)  numtemp(xx+1)
       ELSE
        numtemp(xx+1)=-1
       ENDIF
      enddo

       IF(numtemp(1).eq.0) GOTO 300
       IF(numtemp(1).lt.0) then
        number=-1
        return
       ENDIF
       IF(numtemp(2).lt.0) then
        number=numtemp(1) 
        return
       ELSE
        txt=TRIM(ADJUSTL(formula(start:start+1)))
        Read( txt,*) number
        return
       ENDIF

300    OPEN (UNIT=10,STATUS='UNKNOWN',FILE='thermo.ERROR')    ! Error output
       write (10,*) 'Error in the chemical formula (chemformula.f)'
       write (*,*)  'Error in the chemical formula (chemformula.f)'
       CLOSE(10)
       STOP

      return

      end subroutine


      subroutine rs(nm,n,a,w,matz,z,fv1,fv2,ierr)
c
      integer n,nm,ierr,matz
      double precision a(nm,n),w(n),z(nm,n),fv1(n),fv2(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a real symmetric matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a.
c
c        a  contains the real symmetric matrix.
c
c        matz  is an integer variable set equal to zero if
c        only eigenvalues are desired.  otherwise it is set to
c        any non-zero integer for both eigenvalues and eigenvectors.
c
c     on output
c
c        w  contains the eigenvalues in ascending order.
c
c        z  contains the eigenvectors if matz is not zero.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for tqlrat
c           and tql2.  the normal completion code is zero.
c
c        fv1  and  fv2  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 if (matz .ne. 0) go to 20
c     .......... find eigenvalues only ..........
      call  tred1(nm,n,a,w,fv1,fv2)
*  tqlrat encounters catastrophic underflow on the Vax
*     call  tqlrat(n,w,fv2,ierr)
      call  tql1(n,w,fv1,ierr)
      go to 50
c     .......... find both eigenvalues and eigenvectors ..........
   20 call  tred2(nm,n,a,w,fv1,z)
      call  tql2(nm,n,w,fv1,z,ierr)
   50 return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine tql1(n,d,e,ierr)
c
      integer i,j,l,m,n,ii,l1,l2,mml,ierr
      double precision d(n),e(n)
      double precision c,c2,c3,dl1,el1,f,g,h,p,r,s,s2,tst1,tst2,pythag
c
c     this subroutine is a translation of the algol procedure tql1,
c     num. math. 11, 293-306(1968) by bowdler, martin, reinsch, and
c     wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 227-240(1971).
c
c     this subroutine finds the eigenvalues of a symmetric
c     tridiagonal matrix by the ql method.
c
c     on input
c
c        n is the order of the matrix.
c
c        d contains the diagonal elements of the input matrix.
c
c        e contains the subdiagonal elements of the input matrix
c          in its last n-1 positions.  e(1) is arbitrary.
c
c      on output
c
c        d contains the eigenvalues in ascending order.  if an
c          error exit is made, the eigenvalues are correct and
c          ordered for indices 1,2,...ierr-1, but may not be
c          the smallest eigenvalues.
c
c        e has been destroyed.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the j-th eigenvalue has not been
c                     determined after 30 iterations.
c
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      if (n .eq. 1) go to 1001
c
      do 100 i = 2, n
  100 e(i-1) = e(i)
c
      f = 0.0d0
      tst1 = 0.0d0
      e(n) = 0.0d0
c
      do 290 l = 1, n
         j = 0
         h = dabs(d(l)) + dabs(e(l))
         if (tst1 .lt. h) tst1 = h
c     .......... look for small sub-diagonal element ..........
         do 110 m = l, n
            tst2 = tst1 + dabs(e(m))
            if (tst2 .eq. tst1) go to 120
c     .......... e(n) is always zero, so there is no exit
c                through the bottom of the loop ..........
  110    continue
c
  120    if (m .eq. l) go to 210
  130    if (j .eq. 30) go to 1000
         j = j + 1
c     .......... form shift ..........
         l1 = l + 1
         l2 = l1 + 1
         g = d(l)
         p = (d(l1) - g) / (2.0d0 * e(l))
         r = pythag(p,1.0d0)
         d(l) = e(l) / (p + dsign(r,p))
         d(l1) = e(l) * (p + dsign(r,p))
         dl1 = d(l1)
         h = g - d(l)
         if (l2 .gt. n) go to 145
c
         do 140 i = l2, n
  140    d(i) = d(i) - h
c
  145    f = f + h
c     .......... ql transformation ..........
         p = d(m)
         c = 1.0d0
         c2 = c
         el1 = e(l1)
         s = 0.0d0
         mml = m - l
c     .......... for i=m-1 step -1 until l do -- ..........
         do 200 ii = 1, mml
            c3 = c2
            c2 = c
            s2 = s
            i = m - ii
            g = c * e(i)
            h = c * p
            r = pythag(p,e(i))
            e(i+1) = s * r
            s = e(i) / r
            c = p / r
            p = c * d(i) - s * g
            d(i+1) = h + s * (c * g + s * d(i))
  200    continue
c
         p = -s * s2 * c3 * el1 * e(l) / dl1
         e(l) = s * p
         d(l) = c * p
         tst2 = tst1 + dabs(e(l))
         if (tst2 .gt. tst1) go to 130
  210    p = d(l) + f
c     .......... order eigenvalues ..........
         if (l .eq. 1) go to 250
c     .......... for i=l step -1 until 2 do -- ..........
         do 230 ii = 2, l
            i = l + 2 - ii
            if (p .ge. d(i-1)) go to 270
            d(i) = d(i-1)
  230    continue
c
  250    i = 1
  270    d(i) = p
  290 continue
c
      go to 1001
c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........
 1000 ierr = l
 1001 return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      subroutine tql2(nm,n,d,e,z,ierr)
c
      integer i,j,k,l,m,n,ii,l1,l2,nm,mml,ierr
      double precision d(n),e(n),z(nm,n)
      double precision c,c2,c3,dl1,el1,f,g,h,p,r,s,s2,tst1,tst2,pythag
c
c     this subroutine is a translation of the algol procedure tql2,
c     num. math. 11, 293-306(1968) by bowdler, martin, reinsch, and
c     wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 227-240(1971).
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a symmetric tridiagonal matrix by the ql method.
c     the eigenvectors of a full symmetric matrix can also
c     be found if  tred2  has been used to reduce this
c     full matrix to tridiagonal form.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        d contains the diagonal elements of the input matrix.
c
c        e contains the subdiagonal elements of the input matrix
c          in its last n-1 positions.  e(1) is arbitrary.
c
c        z contains the transformation matrix produced in the
c          reduction by  tred2, if performed.  if the eigenvectors
c          of the tridiagonal matrix are desired, z must contain
c          the identity matrix.
c
c      on output
c
c        d contains the eigenvalues in ascending order.  if an
c          error exit is made, the eigenvalues are correct but
c          unordered for indices 1,2,...,ierr-1.
c
c        e has been destroyed.
c
c        z contains orthonormal eigenvectors of the symmetric
c          tridiagonal (or full) matrix.  if an error exit is made,
c          z contains the eigenvectors associated with the stored
c          eigenvalues.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the j-th eigenvalue has not been
c                     determined after 30 iterations.
c
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      if (n .eq. 1) go to 1001
c
      do 100 i = 2, n
  100 e(i-1) = e(i)
c
      f = 0.0d0
      tst1 = 0.0d0
      e(n) = 0.0d0
c
      do 240 l = 1, n
         j = 0
         h = dabs(d(l)) + dabs(e(l))
         if (tst1 .lt. h) tst1 = h
c     .......... look for small sub-diagonal element ..........
         do 110 m = l, n
            tst2 = tst1 + dabs(e(m))
            if (tst2 .eq. tst1) go to 120
c     .......... e(n) is always zero, so there is no exit
c                through the bottom of the loop ..........
  110    continue
c
  120    if (m .eq. l) go to 220
  130    if (j .eq. 30) go to 1000
         j = j + 1
c     .......... form shift ..........
         l1 = l + 1
         l2 = l1 + 1
         g = d(l)
         p = (d(l1) - g) / (2.0d0 * e(l))
         r = pythag(p,1.0d0)
         d(l) = e(l) / (p + dsign(r,p))
         d(l1) = e(l) * (p + dsign(r,p))
         dl1 = d(l1)
         h = g - d(l)
         if (l2 .gt. n) go to 145
c
         do 140 i = l2, n
  140    d(i) = d(i) - h
c
  145    f = f + h
c     .......... ql transformation ..........
         p = d(m)
         c = 1.0d0
         c2 = c
         el1 = e(l1)
         s = 0.0d0
         mml = m - l
c     .......... for i=m-1 step -1 until l do -- ..........
         do 200 ii = 1, mml
            c3 = c2
            c2 = c
            s2 = s
            i = m - ii
            g = c * e(i)
            h = c * p
            r = pythag(p,e(i))
            e(i+1) = s * r
            s = e(i) / r
            c = p / r
            p = c * d(i) - s * g
            d(i+1) = h + s * (c * g + s * d(i))
c     .......... form vector ..........
            do 180 k = 1, n
               h = z(k,i+1)
               z(k,i+1) = s * z(k,i) + c * h
               z(k,i) = c * z(k,i) - s * h
  180       continue
c
  200    continue
c
         p = -s * s2 * c3 * el1 * e(l) / dl1
         e(l) = s * p
         d(l) = c * p
         tst2 = tst1 + dabs(e(l))
         if (tst2 .gt. tst1) go to 130
  220    d(l) = d(l) + f
  240 continue
c     .......... order eigenvalues and eigenvectors ..........
      do 300 ii = 2, n
         i = ii - 1
         k = i
         p = d(i)
c
         do 260 j = ii, n
            if (d(j) .ge. p) go to 260
            k = j
            p = d(j)
  260    continue
c
         if (k .eq. i) go to 300
         d(k) = d(i)
         d(i) = p
c
         do 280 j = 1, n
            p = z(j,i)
            z(j,i) = z(j,k)
            z(j,k) = p
  280    continue
c
  300 continue
c
      go to 1001
c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........
 1000 ierr = l
 1001 return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      subroutine tred1(nm,n,a,d,e,e2)
c
      integer i,j,k,l,n,ii,nm,jp1
      double precision a(nm,n),d(n),e(n),e2(n)
      double precision f,g,h,scale
c
c     this subroutine is a translation of the algol procedure tred1,
c     num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
c
c     this subroutine reduces a real symmetric matrix
c     to a symmetric tridiagonal matrix using
c     orthogonal similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the real symmetric input matrix.  only the
c          lower triangle of the matrix need be supplied.
c
c     on output
c
c        a contains information about the orthogonal trans-
c          formations used in the reduction in its strict lower
c          triangle.  the full upper triangle of a is unaltered.
c
c        d contains the diagonal elements of the tridiagonal matrix.
c
c        e contains the subdiagonal elements of the tridiagonal
c          matrix in its last n-1 positions.  e(1) is set to zero.
c
c        e2 contains the squares of the corresponding elements of e.
c          e2 may coincide with e if the squares are not needed.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      do 100 i = 1, n
         d(i) = a(n,i)
         a(n,i) = a(i,i)
  100 continue
c     .......... for i=n step -1 until 1 do -- ..........
      do 300 ii = 1, n
         i = n + 1 - ii
         l = i - 1
         h = 0.0d0
         scale = 0.0d0
         if (l .lt. 1) go to 130
c     .......... scale row (algol tol then not needed) ..........
         do 120 k = 1, l
  120    scale = scale + dabs(d(k))
c
         if (scale .ne. 0.0d0) go to 140
c
         do 125 j = 1, l
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = 0.0d0
  125    continue
c
  130    e(i) = 0.0d0
         e2(i) = 0.0d0
         go to 300
c
  140    do 150 k = 1, l
            d(k) = d(k) / scale
            h = h + d(k) * d(k)
  150    continue
c
         e2(i) = scale * scale * h
         f = d(l)
         g = -dsign(dsqrt(h),f)
         e(i) = scale * g
         h = h - f * g
         d(l) = f - g
         if (l .eq. 1) go to 285
c     .......... form a*u ..........
         do 170 j = 1, l
  170    e(j) = 0.0d0
c
         do 240 j = 1, l
            f = d(j)
            g = e(j) + a(j,j) * f
            jp1 = j + 1
            if (l .lt. jp1) go to 220
c
            do 200 k = jp1, l
               g = g + a(k,j) * d(k)
               e(k) = e(k) + a(k,j) * f
  200       continue
c
  220       e(j) = g
  240    continue
c     .......... form p ..........
         f = 0.0d0
c
         do 245 j = 1, l
            e(j) = e(j) / h
            f = f + e(j) * d(j)
  245    continue
c
         h = f / (h + h)
c     .......... form q ..........
         do 250 j = 1, l
  250    e(j) = e(j) - h * d(j)
c     .......... form reduced a ..........
         do 280 j = 1, l
            f = d(j)
            g = e(j)
c
            do 260 k = j, l
  260       a(k,j) = a(k,j) - f * e(k) - g * d(k)
c
  280    continue
c
  285    do 290 j = 1, l
            f = d(j)
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = f * scale
  290    continue
c
  300 continue
c
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      subroutine tred2(nm,n,a,d,e,z)
c
      integer i,j,k,l,n,ii,nm,jp1
      double precision a(nm,n),d(n),e(n),z(nm,n)
      double precision f,g,h,hh,scale
c
c     this subroutine is a translation of the algol procedure tred2,
c     num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
c
c     this subroutine reduces a real symmetric matrix to a
c     symmetric tridiagonal matrix using and accumulating
c     orthogonal similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the real symmetric input matrix.  only the
c          lower triangle of the matrix need be supplied.
c
c     on output
c
c        d contains the diagonal elements of the tridiagonal matrix.
c
c        e contains the subdiagonal elements of the tridiagonal
c          matrix in its last n-1 positions.  e(1) is set to zero.
c
c        z contains the orthogonal transformation matrix
c          produced in the reduction.
c
c        a and z may coincide.  if distinct, a is unaltered.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      do 100 i = 1, n
c
         do 80 j = i, n
   80    z(j,i) = a(j,i)
c
         d(i) = a(n,i)
  100 continue
c
      if (n .eq. 1) go to 510
c     .......... for i=n step -1 until 2 do -- ..........
      do 300 ii = 2, n
         i = n + 2 - ii
         l = i - 1
         h = 0.0d0
         scale = 0.0d0
         if (l .lt. 2) go to 130
c     .......... scale row (algol tol then not needed) ..........
         do 120 k = 1, l
  120    scale = scale + dabs(d(k))
c
         if (scale .ne. 0.0d0) go to 140
  130    e(i) = d(l)
c
         do 135 j = 1, l
            d(j) = z(l,j)
            z(i,j) = 0.0d0
            z(j,i) = 0.0d0
  135    continue
c
         go to 290
c
  140    do 150 k = 1, l
            d(k) = d(k) / scale
            h = h + d(k) * d(k)
  150    continue
c
         f = d(l)
         g = -dsign(dsqrt(h),f)
         e(i) = scale * g
         h = h - f * g
         d(l) = f - g
c     .......... form a*u ..........
         do 170 j = 1, l
  170    e(j) = 0.0d0
c
         do 240 j = 1, l
            f = d(j)
            z(j,i) = f
            g = e(j) + z(j,j) * f
            jp1 = j + 1
            if (l .lt. jp1) go to 220
c
            do 200 k = jp1, l
               g = g + z(k,j) * d(k)
               e(k) = e(k) + z(k,j) * f
  200       continue
c
  220       e(j) = g
  240    continue
c     .......... form p ..........
         f = 0.0d0
c
         do 245 j = 1, l
            e(j) = e(j) / h
            f = f + e(j) * d(j)
  245    continue
c
         hh = f / (h + h)
c     .......... form q ..........
         do 250 j = 1, l
  250    e(j) = e(j) - hh * d(j)
c     .......... form reduced a ..........
         do 280 j = 1, l
            f = d(j)
            g = e(j)
c
            do 260 k = j, l
  260       z(k,j) = z(k,j) - f * e(k) - g * d(k)
c
            d(j) = z(l,j)
            z(i,j) = 0.0d0
  280    continue
c
  290    d(i) = h
  300 continue
c     .......... accumulation of transformation matrices ..........
      do 500 i = 2, n
         l = i - 1
         z(n,l) = z(l,l)
         z(l,l) = 1.0d0
         h = d(i)
         if (h .eq. 0.0d0) go to 380
c
         do 330 k = 1, l
  330    d(k) = z(k,i) / h
c
         do 360 j = 1, l
            g = 0.0d0
c
            do 340 k = 1, l
  340       g = g + z(k,i) * z(k,j)
c
            do 360 k = 1, l
               z(k,j) = z(k,j) - g * d(k)
  360    continue
c
  380    do 400 k = 1, l
  400    z(k,i) = 0.0d0
c
  500 continue
c
  510 do 520 i = 1, n
         d(i) = z(n,i)
         z(n,i) = 0.0d0
  520 continue
c
      z(n,n) = 1.0d0
      e(1) = 0.0d0
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      double precision function pythag(a,b)
      double precision a,b
c
c     finds dsqrt(a**2+b**2) without overflow or destructive underflow
c
      double precision p,r,s,t,u
      p = dmax1(dabs(a),dabs(b))
      if (p .eq. 0.0d0) go to 20
      r = (dmin1(dabs(a),dabs(b))/p)**2
   10 continue
         t = 4.0d0 + r
         if (t .eq. 4.0d0) go to 20
         s = r/t
         u = 1.0d0 + 2.0d0*s
         p = u*p
         r = (s/u)**2 * r
      go to 10
   20 pythag = p
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Element: a subroutine for calculating atomic masses and enthalpy functions.
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful, 
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      SUBROUTINE element( ATYPE , MASS , Hfxn , Sfxn)
      
      DOUBLE PRECISION MASS , Hfxn , R , Sf , Sfxn
      CHARACTER ATYPE*6
      
      parameter(R=8.314472D+00)

      SAVE
c
c	      MASS (atomic mass units) from NIST / JANAF 1998
c         Hfxn = [H(298.15) - H(0)]/R per atom   [NIST / JANAF]
c         Sf   = entropy (per atom; J K-1 mol-1) of reference state at 298.15 K
c         Sfxn = Sf/R per atom   [NIST / JANAF]
c
         IF ( ATYPE.EQ.'C' ) THEN
            MASS = 12.011D+00
            Hfxn = 1.051
            Sf = 5.740
         ELSEIF ( ATYPE.EQ.'C12' ) THEN
            MASS = 12.0D+00
            Hfxn = 1.051                ! assumed to be the same as "C"
            Sf = 5.740
         ELSEIF ( ATYPE.EQ.'C13' ) THEN
            MASS = 13.003355D+00
            Hfxn = 1.051                ! assumed to be the same as "C"
            Sf = 5.740
         ELSEIF ( ATYPE.EQ.'C14' ) THEN
            MASS = 14.003242D+00
            Hfxn = 1.051                ! assumed to be the same as "C"
            Sf = 5.740
         ELSEIF ( ATYPE.EQ.'C16' ) THEN
            MASS = 16.0147D+00
            Hfxn = 1.051                ! assumed to be the same as "C"
            Sf = 5.740
         ELSEIF ( ATYPE.EQ.'H' ) THEN
            MASS = 1.00794D+00
            Hfxn = 8.467 / 2.0
            Sf = 130.680 / 2.0
         ELSEIF ( ATYPE.EQ.'H1' ) THEN
            MASS = 1.007825D+00
            Hfxn = 8.467 / 2.0          ! assumed to be the same as "H"
            Sf = 130.680 / 2.0
         ELSEIF ( ATYPE.EQ.'D' ) THEN
            MASS = 2.014102D+00
            Hfxn = 8.569 / 2.0
            Sf = 144.960 / 2.0
         ELSEIF ( ATYPE.EQ.'T' ) THEN
            MASS = 3.016049D+00
            Hfxn = 8.60 / 2.0             ! calculated by using parameters found in NIST web-book
            Sf = 153.24 / 2.0             ! calculated by using parameters found in NIST web-book
         ELSEIF ( ATYPE.EQ.'O' ) THEN
            MASS = 15.9994D+00
            Hfxn = 8.683 / 2.0
            Sf = 205.147 / 2.0
         ELSEIF ( ATYPE.EQ.'O16' ) THEN
            MASS = 15.994915D+00
            Hfxn = 8.68 / 2.0    ! Calculated using rot and vib constants from Edwards et al., J. Raman Spectrosc., 10, 60-63 (1981)
            Sf = 205.13 / 2.0    ! Calculated using rot and vib constants from Edwards et al., J. Raman Spectrosc., 10, 60-63 (1981)
         ELSEIF ( ATYPE.EQ.'O17' ) THEN
            MASS = 16.9991315D+00
            Hfxn = 8.68 / 2.0    ! Calculated using rot and vib constants from Edwards et al., J. Raman Spectrosc., 10, 60-63 (1981)
            Sf = 206.40 / 2.0    ! Calculated using rot and vib constants from Edwards et al., J. Raman Spectrosc., 10, 60-63 (1981)
         ELSEIF ( ATYPE.EQ.'O18' ) THEN
            MASS = 17.999160D+00
            Hfxn = 8.69 / 2.0    ! Calculated using rot and vib constants from Edwards et al., J. Raman Spectrosc., 10, 60-63 (1981)
            Sf = 207.60 / 2.0    ! Calculated using rot and vib constants from Edwards et al., J. Raman Spectrosc., 10, 60-63 (1981)
         ELSEIF ( ATYPE.EQ.'N' ) THEN
            MASS = 14.00674D+00
            Hfxn = 8.670 / 2.0
            Sf = 191.609 / 2.0
         ELSEIF ( ATYPE.EQ.'N14' ) THEN
            MASS = 14.003074D+00
            Hfxn = 8.670 / 2.0    ! Calculated using rot and vib constants from Gilson et al., J. Raman Spectrosc. 9, 361-368 (1980) & Bendtsen, J. Raman Spectrosc. 2, 133-145 (1974)
            Sf = 191.60 / 2.0     ! Calculated using rot and vib constants from Gilson et al., J. Raman Spectrosc. 9, 361-368 (1980) & Bendtsen, J. Raman Spectrosc. 2, 133-145 (1974)
         ELSEIF ( ATYPE.EQ.'N15' ) THEN
            MASS = 15.00010897D+00
            Hfxn = 8.670 / 2.0    ! Calculated using rot and vib constants from Gilson et al., J. Raman Spectrosc. 9, 361-368 (1980) & Bendtsen, J. Raman Spectrosc. 2, 133-145 (1974)
            Sf = 193.03 / 2.0     ! Calculated using rot and vib constants from Gilson et al., J. Raman Spectrosc. 9, 361-368 (1980) & Bendtsen, J. Raman Spectrosc. 2, 133-145 (1974)
         ELSEIF ( ATYPE.EQ.'F' ) THEN
            MASS = 18.998403D+00
            Hfxn = 8.825 / 2.0
            Sf = 202.789 / 2.0
         ELSEIF ( ATYPE.EQ.'Cl' ) THEN
            MASS = 35.453D+00
            Hfxn = 9.181 / 2.0
            Sf = 223.079 / 2.0
         ELSEIF ( ATYPE.EQ.'Cl35' ) THEN
            MASS = 34.96885271D+00
            Hfxn = 9.17 / 2.0      ! Calculated using rot and vib constants from Bermejo et al., J. Mol. Spectrosc. 212, 186-193 (2002)
            Sf = 222.69 / 2.0      ! Calculated using rot and vib constants from Bermejo et al., J. Mol. Spectrosc. 212, 186-193 (2002)
         ELSEIF ( ATYPE.EQ.'Cl37' ) THEN
            MASS = 36.9659D+00
            Hfxn = 9.16 / 2.0      ! Calculated using rot and vib constants from Bermejo et al., J. Mol. Spectrosc. 212, 186-193 (2002)
            Sf = 223.84 / 2.0      ! Calculated using rot and vib constants from Bermejo et al., J. Mol. Spectrosc. 212, 186-193 (2002)
         ELSEIF ( ATYPE.EQ.'Br' ) THEN
            MASS = 79.904D+00
            Hfxn = 24.509 / 2.0
            Sf = 152.206 / 2.0
         ELSEIF ( ATYPE.EQ.'Br79' ) THEN
            MASS = 78.918338D+00
            Hfxn = 24.509 / 2.0    ! assumed to be the same as "Br"
            Sf = 152.206 / 2.0     ! assumed to be the same as "Br"
         ELSEIF ( ATYPE.EQ.'Br81' ) THEN
            MASS = 80.916291D+00
            Hfxn = 24.509 / 2.0    ! assumed to be the same as "Br"
            Sf = 152.206 / 2.0     ! assumed to be the same as "Br"
         ELSEIF ( ATYPE.EQ.'I' ) THEN
            MASS = 126.9045D+00
            Hfxn = 13.198 / 2.0
            Sf = 116.142 / 2.0
         ELSEIF ( ATYPE.EQ.'S' ) THEN
            MASS = 32.06D+00
            Hfxn = 4.412
            Sf = 32.056
         ELSEIF ( ATYPE.EQ.'S32' ) THEN
            MASS = 31.9720707D+00
            Hfxn = 4.412             ! assumed to be the same as "S"
            Sf = 32.056              ! assumed to be the same as "S"
         ELSEIF ( ATYPE.EQ.'S34' ) THEN
            MASS = 33.9678668D+00
            Hfxn = 4.412             ! assumed to be the same as "S"
            Sf = 32.056              ! assumed to be the same as "S"
         ELSEIF ( ATYPE.EQ.'P' ) THEN
            MASS = 30.97376D+00
            Hfxn = 5.360
            Sf = 41.077
         ELSEIF ( ATYPE.EQ.'Si' ) THEN
            MASS = 28.0855D+00
            Hfxn = 3.218
            Sf = 18.820
         ELSEIF ( ATYPE.EQ.'B' ) THEN
            MASS = 10.81D+00
            Hfxn = 1.214
            Sf = 5.834
         ELSEIF ( ATYPE.EQ.'Li' ) THEN
            MASS = 6.941D+00
            Hfxn = 4.622
            Sf = 29.085
         ELSEIF ( ATYPE.EQ.'Hg' ) THEN
            MASS = 200.59D+00
            Hfxn = 9.343
            Sf = 76.028
         ELSEIF ( ATYPE.EQ.'K' ) THEN
            MASS = 39.0983D+00
            Hfxn = 7.082
            Sf = 64.670
         ELSEIF ( ATYPE.EQ.'Rb' ) THEN
            MASS = 85.4678D+00
            Hfxn = 7.490
            Sf = 76.778
         ELSEIF ( ATYPE.EQ.'Se' ) THEN
            MASS = 78.96D+00
            Hfxn = 5.519
            Sf =  42.442
         ELSEIF ( ATYPE.EQ.'Na' ) THEN
            MASS = 22.98977D+00
            Hfxn = 6.447
            Sf = 51.455
         ELSEIF ( ATYPE.EQ.'Te' ) THEN
            MASS = 127.60D+00
            Hfxn = 6.121
            Sf =  49.71
         ELSEIF ( ATYPE.EQ.'Sn' ) THEN
            MASS = 118.69D+00
            Hfxn = 6.297
            Sf = 51.18
         ELSEIF ( ATYPE.EQ.'Si' ) THEN
            MASS = 28.0855D+00
            Hfxn = 3.218
            Sf = 18.820
         ELSEIF ( ATYPE.EQ.'Si29' ) THEN
            MASS = 28.98D+00
            Hfxn = 3.218              ! assumed to be the same as Si
            Sf = 18.820               ! assumed to be the same as Si
         ELSEIF ( ATYPE.EQ.'Si30' ) THEN
            MASS = 29.97D+00
            Hfxn = 3.218              ! assumed to be the same as Si
            Sf = 18.820               ! assumed to be the same as Si
         ELSEIF ( ATYPE.EQ.'He' ) THEN
            MASS = 4.00260D+00
            Hfxn = 6.197
            Sf = 126.152
         ELSEIF ( ATYPE.EQ.'Ne' ) THEN
            MASS = 20.179D+00
            Hfxn = 6.197
            Sf = 146.327
         ELSEIF ( ATYPE.EQ.'Ar' ) THEN
            MASS = 39.948D+00
            Hfxn = 6.197
            Sf = 154.845
         ELSEIF ( ATYPE.EQ.'Kr' ) THEN
            MASS = 83.80D+00
            Hfxn = 6.197
            Sf = 164.084
         ELSEIF ( ATYPE.EQ.'Xe' ) THEN
            MASS = 131.29D+00
            Hfxn = 6.197
            Sf = 169.684
         ELSE
            STOP 'Element not recognized in subroutine element.f'
         ENDIF

            Hfxn = Hfxn/R
            Sfxn = Sf/R

      RETURN
      END
      
      

	SUBROUTINE GHRLEV(EV,NN,Nmax,Emax,B,NCV,NCF,CV,CF,
     &		Nsiv,Nsif,Vhr,Bhr,Phav,Phab,Vo,Vm)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c GHRLEV: a code of general purposes to calculate eigenvalues of 1D-hindered internal rotation 
c Copyright (C) 2009 Lam T. Nguyen
c
c	DATE:	Feb. 13, 2009
c
c Lam T. Nguyen
c NGUYENLT@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c
c or contact
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C	INPUT:	
C		1) Emax		: maximum energy in Master Equation
C		2) B		: average rotational constant, defined as:
C			B = (Integral of B(x)dx from 0 to 2*PI) / (2*PI)
C		3) NCV, NCF	: number of elements in vectors of CV and CF, respectively
C		4) CV		: vector of coefficients with NCV elements in torsional 
C			potential energy function, which is expressed as = CVo/2 + Sum of CVi*(1-cos(i*x*Nsig))/2
C		5) CF		: vector of coefficients with NCF elements in rotational constant,
C			which is given by a Fourier series = CFo + Sum of CFi*cos(i*x*Nsig)
C		6) Nsiv, Nsif	: symmetry numbers for tortional potential E function and rotational constant, respectively.
C		7) NN		: maximum number of elements in vector EV
C		8) Vhr		: model for torsional potential energy function
C		9) Bhr		: model for rotational constant
C		10) Phav, Phab	: phases of torsional angles in Vhr and Bhr, respectively.  	 
C
C	OUTPUT:	1) EV(Nmax)	: vector of eigenvalues with Nmax elements
C		2) Nmax		: number of elements of vector EV
C
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
      PARAMETER (NX=151)
C
C.....Declare arrays.
      DIMENSION EV(NN), CV(NCV), CF(NCF)
        CHARACTER Vhr*5, Bhr*5


	IF((Vhr.EQ.'VHRD2').OR.(Vhr.EQ.'Vhrd2').OR.
     &	(Vhr.EQ.'VHRD3').OR.(Vhr.EQ.'Vhrd3')) THEN
        CALL CALVo(Vo,Vm,CV,NCV,Nsiv,Vhr,Phav)
	CALL ODQHR(EV,NN,NCV,NCF,CV,CF,Nsiv,Nsif,Vhr,Bhr,Phav,Phab,Vm)
	ELSE
        CALL CALVo(Vo,Vm,CV,NCV,Nsiv,Vhr,Phav)
	Vm=0.0d0
        CALL ODQHR(EV,NN,NCV,NCF,CV,CF,Nsiv,Nsif,Vhr,Bhr,Phav,Phab,Vm)
	ENDIF
	Nmax=NX

	Vtp=EV(Nmax)

!	write(*,999) "Maximum energy (cm-1) = ", Emax
!	write(*,999) "The highest eigenvalue (cm-1) = ", Vtp
!	write(*,999) "Vo = Vmax (cm-1) = ", Vo
!	write(*,999) "Vmin (cm-1) = ", Vm
!999	FORMAT(1X,A33,1X,F10.1)

	IF(Vtp.LT.Vo) THEN
		write(*,*) "EIGENVALUES from HinRotor are not reliable !!!"
		write(*,*) "You have to increase number of grid points"
		write(*,*) "OR Harmonic approximation is good enough"
		STOP
	ENDIF
 
	IF(Emax.LT.Vo*10) Emax=Vo*10 
	CALL CALEI(EV,NN,Nmax,Emax,B)

	RETURN 
      END


C****************************************************************************************************************
C	NAME:	Subroutine ODQHR 
C	USE:	To obtain a vector of quantum eigenvalues of 1D-hindered internal rotor, in which  
C		both torsional potential energy function and moment inertia are explicitly treated as 
C		functions of internal rotational angle, i.e. non-rigid rotor, based on Meyer's algorithm:
C		R. Meyer J. Chem. Phys. 52 (1970) 2053-2059.  
C
C	AUTHORS:	Lam T. Nguyen and John R. Barker 
C
C	DATE:	Jan. 26, 2009
C
C****************************************************************************************************************
C     
C	 NX  : Number of grid points
C        XA  : Position on a grid.
C        AR  : Hamiltonian Matrix, i.e. Meyer's symmetrical matrix
C        ER  : Vector of eigenvalues 
C        ZR  : Eigenvectors (X,Y); where
C                                      X : Wavefunction.
C                                      Y : Energy level.       
C        NPR      : 0 for eigenvalue only and 1 for both eigenvalue and eigenvector 
C        RMIN     : Starting point of grid
C        RMAX     : End point of grid
C        ZL       : Grid length
C        DX       : Grid spacings
C
C****************************************************************************************************************
C
C	INPUT:	1) NCV, NCF	= Number of coefficients derived from fitting rotational energy profile and moment inertia
C		2) CV(NCV)	= Vector of coefficients from rotational energy profile, with NCV elements
C		3) CF(NCF)	= Vector of coefficients from moment inertia (rotational constant), with NCF elements
C		4) Nsig		= rotational symmetry number
C	OUTPUT:	1) ER 		= Vector of eigenvalues of 1D-hindered internal rotor, with NX=151 elements 
C
C*****************************************************************************************************************

	SUBROUTINE ODQHR(ER,NN,NCV,NCF,CV,CF,Nsiv,Nsif,Vhr,Bhr,
     &		Phav,Phab,Vm)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
      PARAMETER (NX=151)
C
C.....Declare arrays.
      DIMENSION AR(NX,NX),ER(NN),ZR(NX,NX),XA(NX) 
      DIMENSION D(NX,NX), F(NX), V(NX), DT(NX,NX),
     & T(NX,NX), FT(NX,NX)
	DIMENSION  CF(NCF), CV(NCV), FV1(NX), FV2(NX)
        CHARACTER Vhr*5, Bhr*5

C.....	DIMENSION WORK(NX*3)

C
C.....Variable data input.

      DATA NPR/0/

C.....Now compute Hamiltonian matrix:

	CALL CMM(AR,NCV,NCF,CV,CF,Nsiv,Nsif,Vhr,Bhr,Phav,Phab,Vm)
					
C.....Now call eigenvalue solver using RS subroutine of EISPACK.

	CALL rs(NX,NX,AR,ER,NPR,ZR,FV1,FV2,IERR) 

C...... Alterative option: using subroutine DSYEV from LAPACK 
C......	CALL DSYEV( 'V', 'U', NX, AR, NX, ER, WORK, NX*3, IERR )
C......

	RETURN 
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C.....	CMM stands for Constructing Meyer's Matrix, AR, for 1D-hindered internal rotor using Meyer's method, 
C.....	R. MEYER J. Chem. Phys. 52 (1970) 2053.
C.....	Both rotational energy profile and moment inertia are properly treated as functions of 
C.....	internal rotation angle, i.e. non-rigid rotor
C.....	INPUT:	1) NCF, NCV = Number of coefficients drived from fitting rotational energy profile and moment inertia
C.....		2) CV(NCV) = Vector of coefficients from rotational energy profile, with NCV elements
C.....		3) CF(NCF) = Vector of coefficients from moment inertia, with NCF elements
C.....		4) Nsig = Rotational symmetry number, it can be either one or two or three or whatever 
C.....	OUTPUT: 1) AR(NX,NX) = Meyer's symmetrical matrix, with a size of NX--number of grid points   


	SUBROUTINE CMM(AR,NCV,NCF,CV,CF,Nsiv,Nsif,Vhr,Bhr,Phav,Phab,Vm)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
	PARAMETER (NX=151)
C
C.....Declare arrays.
	DIMENSION AR(NX,NX),XA(NX) 
	DIMENSION D(NX,NX), F(NX), V(NX), DT(NX,NX),
     & T(NX,NX), FT(NX,NX)
	DIMENSION  CF(NCF), CV(NCV)
	CHARACTER Vhr*5, Bhr*5

C
C.....Variable data input.

	PI=acos(-1.D0)
C
C.....Set up grid
	RMIN=0.0D0
	RMAX=PI*2
	ZL=(RMAX-RMIN)
	DX=ZL/NX

C.....Now compute Meyer's symmetrical matrix:

	DO I=1, NX
		XA(I)=RMIN+DX*I
		CALL VX(V(I),XA(I)+Phav,CV,NCV,Nsiv,Vhr,Vm)
		CALL FX(F(I),XA(I)+Phab,CF,NCF,Nsif,Bhr)
		DO J=1, NX
			ImJ=I-J
			IF(ImJ.EQ.0) THEN
				D(I,J)=0.0D0
			ELSE
				tp1=PI*ImJ/dble(NX)
				tp2=(-1.0D0)**ImJ
				D(I,J)=tp2/2.0D0/dsin(tp1)
			ENDIF
			DT(I,J)=-D(I,J)
			FT(I,J)=F(I)*DELTA(I,J)
		ENDDO
	ENDDO

	DO I=1, NX
		DO J=1, NX
			SU=0.0D0
			DO K=1, NX
				SU=SU + FT(I,K)*D(K,J)
			ENDDO
			T(I,J)=SU
		ENDDO
	ENDDO

	DO I=1, NX
		DO J=1, NX
			SU=V(I)*DELTA(I,J)
			DO K=1, NX
				SU=SU + DT(I,K)*T(K,J)
			ENDDO
			AR(I,J)=SU
		ENDDO
	ENDDO	
	RETURN 
      END
C..........
C..........
	SUBROUTINE VX(V,X,CV,N,Nsig,Vhr,Vm)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
	DIMENSION CV(N)
	CHARACTER Vhr*5
	DOUBLE PRECISION Vm

	IF((Vhr.EQ.'Vhrd1').OR.(Vhr.EQ.'VHRD1')) THEN
		V=0.0d0
		DO I=1, N
			V=V+CV(I)*(1.0d0-dcos(X*Nsig*I))/2.0d0
		ENDDO
	ELSEIF((Vhr.EQ.'Vhrd2').OR.(Vhr.EQ.'VHRD2')) THEN
		V=CV(1)
		DO I=2, N
			V=V+CV(I)*dcos(X*Nsig*(I-1))
		ENDDO
        ELSEIF((Vhr.EQ.'Vhrd3').OR.(Vhr.EQ.'VHRD3')) THEN
		V=CV(1)
		Nc=(N+1)/2
		DO I=2, N
			IF(I.LE.Nc) THEN
				V=V+CV(I)*dcos(X*Nsig*(I-1))
			ELSE
				V=V+CV(I)*dsin(X*Nsig*(I-Nc))
			ENDIF
		ENDDO
	ELSE
		write(*,*) "ERROR at INPUT for torsional function = Vhrd"
		STOP
	ENDIF

	V=V-Vm

	RETURN
	END
C..........
C..........
	SUBROUTINE FX(F,X,CF,N,Nsig,Bhr)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
	DIMENSION CF(N)
	PARAMETER (CON=16.85763D0)
	CHARACTER Bhr*5

	IF((Bhr.EQ.'Bhrd1').OR.(Bhr.EQ.'BHRD1')) THEN
		F=CF(1)
		DO I=2, N
			F=F+CF(I)*dcos(X*Nsig*(I-1))
		ENDDO
        ELSEIF((Bhr.EQ.'Ihrd1').OR.(Bhr.EQ.'IHRD1')) THEN
                F=CF(1)
                DO I=2, N
                        F=F+CF(I)*dcos(X*Nsig*(I-1))
                ENDDO
		F=CON/F
	ELSE
                write(*,*) "ERROR at INPUT for Bhrd or Ihrd"
		STOP
	ENDIF

	RETURN
	END
C.........
C.........      
	Double Precision Function DELTA(I,J)
	INTEGER I, J

	IF(I.EQ.J) THEN
		DELTA=1.0D0
	ELSE
		DELTA=0.0D0
	ENDIF
	
	RETURN
	END
C.........
C.........

CCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCC

	SUBROUTINE CALEI(EV,NN,Nmax,Emax,B)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c CALEI: a code to compute/select eigenvalues of torsional motion based on Emax 
c Copyright (C) 2009 Lam T. Nguyen and John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C	INPUT:	1) EV(Nmax)	: a vector of eigenvalues with Nmax elements
C		2) Nmax		: number of elements of vector EV
C		3) Emax		: maximum energy in Master Equation
C		4) B		: average rotational constant, defined as:
C			B = (Integral of B(x)dx from 0 to 2*PI) / (2*PI)
C	OUTPUT:	1) EV(Nmax)
C		2) Nmax	
C
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
      DIMENSION EV(NN)

	I=Nmax

C.......IF The largest eigenvalue is larger than the maximum energy, 
C.......THEN searching for an eigenvalue, which is <= Emax
11	E=EV(I)
	IF(E.GT.Emax) THEN
		I=I-1
		goto 11
	ENDIF
	Nmax=I

C.......Looking for higher-lying eigenvalues with double degeneracy
111	NE1=NINT(EV(I))
	NE2=NINT(EV(I-1))
	IF(NE1.GT.NE2) THEN
		I=I-1
		goto 111
	ENDIF

C.......Switching from a hindered rotor to a Pitzer rotor
C.......Pitzer rotor is defined as E = Eo + B*(JP**2)
C.......Two variables Eo and JP will be computed as below
	tp=EV(I-1) - EV(I-2)
	JP=NINT((tp/B - 1.0d0)/2.0d0)
	Eo=EV(I-2)-B*JP*JP

1111	EV(I+1)=Eo + B*(JP+2)*(JP+2)
	EV(I+2)=EV(I+1)
	IF(EV(I+2).LE.Emax) THEN
		I=I+2
		JP=JP+1
		goto 1111
	ENDIF
	Nmax=I

	RETURN
 
      END

CCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCC

	SUBROUTINE CALVo(Vo,Vm,CV,NCV,Nsiv,Vhr,Pha)

	IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
	DIMENSION CV(NCV)
	CHARACTER Vhr*5

	PI=acos(-1.0d0)

        RMIN=0.0D0
        RMAX=PI*2
        ZL=(RMAX-RMIN)
        DX=ZL/3600.0d0
        CALL VX(Vo,0.0d0+Pha,CV,NCV,Nsiv,Vhr,0.0d0)
	Vm=Vo
        DO I=1, 3600 
                XA = RMIN + DX*I
                CALL VX(Vtp,XA+Pha,CV,NCV,Nsiv,Vhr,0.0d0) 
		IF(Vtp.GT.Vo) Vo=Vtp
                IF(Vtp.LT.Vm) Vm=Vtp
	ENDDO
	RETURN
	END

CCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCC

       subroutine hindrance_fit

       include 'declare.inc'
       Double precision a0

       x=1
       DO i=1,200             ! Max iterations

      call thermochem                         ! THERMOCHEMISTY CALCULATION
       
       Kcinold=Kcin
       Kcin=AK(2)
      if(i.eq.1) x=1.010
      if(i.gt.1) then 
        if(i.eq.2) xold=1.000
!       Approx:  Y=aX**m
        m=log(Kcin/Kcinold)/log(x/xold)
        a0=Kcin/(x**m)
        xold2=x

!       Y'=a*m*X**(m-1)
        x=x-((Kcin-Kexp(Temp))/(m*a0*x**(m-1)))   !Newton method with approx Y'
!       x=x-((Kcin-Kexp(temp))/((Kcin-Kcinold)/(x-xold)))   !Newton method
c      write(*,*) i, Kexp(temp), Kcin, x

       if(x.lt.0) x=ABS(xold/2)
        xold=xold2
       if(ABS(x-xold).lt.1E-5.AND.                  ! Convergence thresholds
     &ABS(Kcin-Kexp(Temp))/Kexp(Temp).lt.1E-5) then
         gamma(Temp)=x
c         write(*,*) i,' iterations'
         return
       endif

      endif
      ENDDO
       write(*,*) "FATAL: Unable to fit experimental rate constant ****"
       write(*,*) '      ',i,' iterations'
       stop
      
       end subroutine
 
c
      function lenstr(string)
c
      implicit      none
c
      character*(*) string,  !input string
     2              null*1   !null character
c
      integer*4     i,       !string index
     2              iend,    !candidate for string length
     3              j,       !index used for stepping through string
     4              length,  !defined length of input
     5              lenstr   !length of string
c
      length=len(string)
c
c     Look for the existence of nulls; if there
c     are any, the first one marks one character past the
c     end of the defined string. If there are no nulls,
c     pick up the final nonspace character, and call that
c     the defined length of the string.
c
      null=char(0)
c
c     Look for nulls
c
      iend=index(string(1:length),null)
c
c     No nulls, look for the location of the last nonspace.
c
      if(iend.eq.0)then
          do i=1,length
              j=length+1-i
              if(string(j:j).ne.' ')then
                  lenstr=j
                  return
              endif
          enddo
c
c         all spaces
c
          lenstr=0
          return
      else
c
c         first null-1
c
          lenstr=iend-1
          return
      endif
      end

      subroutine MaxVeff(Nt,beta,POT,c,De,re,mu,T,rmax,I2dGorin,V,
     &Veff,Eunits)

      Character POT*7, Eunits*4
      Double precision De,beta, re,derVeff,der2Veff,c, T
      Double precision I2dGorin,rmax,Veff,V,bet,mu
      INTEGER J, Nt
      Double precision a,aold,start

! Newton method 
      J=0
      start=re+0.5
      a=start
10    DO
 
      if(start.gt.9) then
       write(*,*) "**** FATAL: Unable to find maximum Veff(r). ****"
       stop
      endif

      J=J+1
      if(J.gt.1E6) then                     ! Max iterations  1.0E6
       write(*,*) "**** FATAL: Unable to find maximum Veff(r). ****"
       stop
      endif   
      derVeff=De*beta*(exp(-beta*(a-re))-exp(-2*beta*(a-re)))  ! Morse  V=De(1-exp(-beta0(r-re)))**2   beta0=SRQT(mu/De)
     &-(T/1.4388)/a

      if(POT.eq."VARSHNI") then   ! Varshni  V=De((1-re/r) exp(-beta(r**2-re**2)))**2   beta= 0.5(beta0-1/re)/re
      derVeff=2*De*re*(exp(-beta*(a**2-re**2)))*
     &(1-(re/a)*exp(-beta*(a**2-re**2)))*(2*beta+1/(a**2))-
     &2*(T/1.4388)/a
      endif

      if(POT.eq."sMORSE") then           ! Stiff Morse  V=De(1-exp(-beta(r-re)))**2   beta=beta0(1+C(r-re)**2)
       derVeff=2*De*beta*(2*c*a+1-2*c*re)*
     &(exp(-beta*(1+c*((a-re)**2))*(a-re))
     &-exp(-2*beta*(1+c*((a-re)**2))*(a-re)))-
     &2*(T/1.4388)/a
      endif


      der2Veff=(-De*beta**2)*(exp(-beta*(a-re))-2*
     &exp(-2*beta*(a-re)))+(T/1.4388)/(a**2)

      if(POT.eq."VARSHNI") then
      der2Veff=2*De*re*(-exp(-beta*(a**2-re**2))*
     &(4*(beta**2)*a-2/(a**3)-2*beta)+re*beta*exp(-2*beta*(a**2-re**2))*
     &(2/(a**2)+8*beta+3/(beta*(a**4))+4/(a**2)))+2*(T/1.4388)/(a**2)
      endif

      if(POT.eq."sMORSE") then
      der2Veff=4*De*beta*c*
     &((exp(-beta*(1+c*((a-re)**2))*(a-re))
     &-exp(-2*beta*(1+c*((a-re)**2))*(a-re))))-
     &2*De*(beta**2)*((2*a*c+1-2*c*re)**2)*
     &((exp(-beta*(1+c*((a-re)**2))*(a-re))
     &-2*exp(-2*beta*(1+c*((a-re)**2))*(a-re))))+
     &2*(T/1.4388)/(a**2)
      endif

      aold=a
      a=a-derVeff/der2Veff
      if(a.lt.re.OR.a.gt.100) then    !  re < a < 100
          start=start+1
          a=start 
          J=0
          goto 10
      endif
      if(ABS(aold-a).lt.1E-4.AND.ABS(derVeff).lt.1E-8) then   ! Convergence thresholds
         if(der2Veff.gt.0) then
          start=start+1
          a=start
          j=0
          goto 10
         endif
         rmax=a         
         I2dGorin=mu*(a**2)
         V=De*(1-exp(-beta*(a-re)))**2-De

         if(POT.eq."VARSHNI") then
         V=De*(1-(re/a)*exp(-beta*(a**2-re**2)))**2-De
         endif

         if(POT.eq."sMORSE") THEN
         V=De*(1-exp(-beta*(1+c*(a-re)**2)*(a-re)))**2-De
         endif

         Veff=V+(T/1.4388)
          IF ( Eunits.EQ.'KCAL' .OR. Eunits.EQ.'kcal' ) THEN
          V=V/349.76
          Veff=Veff/349.76
          ELSEIF ( Eunits.EQ.'KJOU' .OR. Eunits.EQ.'kjou' ) THEN
          V=V/83.59
          Veff=Veff/83.59
          ENDIF

          IF(POT.eq.'sMORSE') beta=beta*(1+c*(a-re)**2)
          return
      endif
      ENDDO   !10



      end subroutine

**==qvib.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
      FUNCTION Qbox(T,w,g,C,S,H,zpe)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c Thermo: a code for thermochemical calculations.
c Copyright (C) 2002 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c	Last modified: 
c       11/02 Fixed yet another bug related to vibrational degeneracies
c 
c
c	Particle-in-a-Box partition function
c
c	T	= temperature
c       g       = degeneracy
c	w	= vibrational frequency (cm-1)
c	C	= heat capacity at constant pressure (units of R)
c	S	= entropy (units of R)
c	H	= [H(T)-H(0)]/RT
c       zpe     = zero point energy
c
 
      IMPLICIT NONE
 
      DOUBLE PRECISION Q0 , Q1 , Q2 , T , w , C , S , H , Ered , E , 
     &                 hor , Fac , Qbox , x , zpe
 
      PARAMETER (hor = 1.4387752D+00)
 
      INTEGER g , v
 
      SAVE 
 
      zpe = w
      Qbox = 0.0D+00
      Q0 = 0.0D+00
      Q1 = 0.0D+00
      Q2 = 0.0D+00
      Fac = 1.0D+00
      v = 1
 
      DO WHILE ( Fac.GE.1.0D-12 )
         E = w*v*v - zpe             ! Energy zero at zero pint energy
         Ered = hor*E/T
         Fac = EXP(-Ered)
         Q0 = Q0 + Fac
         Q1 = Q1 + Ered*Fac
         Q2 = Q2 + Ered*Ered*Fac
         v = v + 1
      ENDDO
 
c	Thermo formulae from Pitzer and Gwinn, J. Chem. Phys. 10, 428 (1942)
 
      C = Q2/Q0 - (Q1/Q0)**2
      H = Q1/Q0
      S = (H+log(Q0))

      C = g*C
      H = g*H
      S = g*S
 
      Qbox = Q0**g
      zpe = g*zpe
 
      RETURN
 
      END
**==qrot.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
      FUNCTION Qele(T , ns , n , Elev , g , C , S , H)
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c Thermo: a code for thermochemical calculations.
c Copyright (C) 2004 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c	Rotational partition function (see Robinson & Holbrook, Appendix 5)
c
c       T	    = temperature
c       ns          = species index number
c	n	    = number of electronic levels
c	Elev(ns,i)  = array of level energies (lowest level at Elev = 0)
c	g(ns,i)	    = array of level degeneracies
c	C	    = constant p heat capacity (units of R)
c	S	    = entropy (units of R)
c	H	    = [H(T)-H(0)]/RT
c
 
      IMPLICIT NONE
 
      DOUBLE PRECISION Qele , T , Elev , C , S , H , 
     &                 Ered , Fac , hor , Q0 , Q1 , Q2

      INTEGER n , ns , i , g
  
      DIMENSION Elev(6,10) , g(6,10)
 
      PARAMETER (hor = 1.4387752D+00)

      SAVE
         Q0 = 0.0d+00
         Q1 = 0.0d+00
         Q2 = 0.00d+00
      
      DO 100 i = 1 , n
         Ered = hor*Elev(ns,i)/T
         Fac = g(ns,i)*EXP(-Ered)
         Q0 = Q0 + Fac
         Q1 = Q1 + Ered*Fac
         Q2 = Q2 + Ered*Ered*Fac
 100  CONTINUE

      Qele = Q0
      C = Q2/Q0 - (Q1/Q0)**2
      H = Q1/Q0
      S = (H+log(Q0))
      RETURN
 
      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Qhin: a subroutine for hindered rotor partition fxn calculations.
c Copyright (C) 2009 Lam T. Nguyen and John R. Barker
c
c Lam T. Nguyen
c NGUYENLT@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c
c	Quantum Hindered Rotor partition function 
c
c	T	= temperature
c	EV	= vector of eigenvalues (cm-1) with INMAX elements [from ghrlev.f]
c	INMAX= number of elements in vector EV 
c	nsig	= symmetry number of internal rotor
c	C	= constant p heat capacity (units of R)
c	SE	= entropy (units of R)
c	H	= [H(T)-H(0)]/RT
c    zpe  = zero point energy (cm-1)
c
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      FUNCTION Qhin(T,EV,INMAX,nsig,C,SE,H,zpe)
 
      IMPLICIT NONE
 
      DOUBLE PRECISION Qhin , T, C , SE , H, zpe
      DOUBLE PRECISION Q0 , Q1 , Q2 , Ered , Fac, hor, Temp 

	INTEGER INMAX 
	DOUBLE PRECISION EV(INMAX)
 
      INTEGER  L, nsig  

      PARAMETER (hor = 1.4387752D+00)
 
      SAVE 
 
      Temp = T

      Q0 = 0.0d+00
      Q1 = 0.0D+00
      Q2 = 0.0D+00
	Fac=1.0d0
	L=1

	zpe=EV(1)

	DO WHILE ((Fac.GE.1.0d-30).and.(L.LE.INMAX))
		Ered = hor*(EV(L)-zpe)/Temp
		Fac=exp(-Ered)
		Q0 = Q0 + Fac
		Q1 = Q1 + Ered*Fac
		Q2 = Q2 + Ered*Ered*Fac
		L=L+1
	ENDDO

      Q0 = Q0/nsig
      Q1 = Q1/nsig
      Q2 = Q2/nsig

c	Thermo formulae from Pitzer and Gwinn, J. Chem. Phys. 10, 428 (1942)
 
      Qhin = Q0
      C = Q2/Q0 - (Q1/Q0)**2
      H = Q1/Q0
      SE = (H+log(Q0))
 
      RETURN
 
      END



**==qroq.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
      FUNCTION Qroq(T,B,d,sig,C,S,H)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
c
c Thermo: a code for thermochemical calculations.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c	Rotational partition function for quantum rotor
c
c	T	= temperature
c	B	= rotational constant (cm-1)
c	d	= rotor dimension
c	sig	= rotor symmetry (foldedness)
c	C	= constant p heat capacity (units of R)
c	S	= entropy (units of R)
c	H	= [H(T)-H(0)]/RT
c
 
      IMPLICIT NONE
 
      DOUBLE PRECISION Q0 , Q1 , Q2 , T , B , C , S , H , Ered , E , 
     &                 hor , F , Fac , Qroq
      INTEGER d , sig , j
      PARAMETER (hor = 1.4387752D+00)
 
      SAVE 
 
 
c     At j = 0:
c
      Q0 = 1.0D+00
      Q1 = 0.0D+00
      Q2 = 0.0D+00
      Fac = 1.0D+00
c
c     Now start loop

      j = 1
 
      DO WHILE ( Fac.GE.1.0D-12 )
         IF ( d.EQ.1 ) THEN
            F = 2.d+00
            E = B*j*j
         ELSEIF ( d.EQ.2 ) THEN
            F = 2.d+00*j + 1.d+00
            E = B*j*(j+1.d+00)
         ELSEIF ( d.EQ.3 ) THEN
            F = (2.d+00*j+1.d+00)*(2.d+00*j+1.d+00)
            E = B*j*(j+1.d+00)
         ENDIF
         Ered = hor*E/T
         Fac = F*EXP(-Ered)
         Q0 = Q0 + Fac
         Q1 = Q1 + Ered*Fac
         Q2 = Q2 + Ered*Ered*Fac
         j = j + 1
      ENDDO
 
c	Thermo formulae from Pitzer and Gwinn, J. Chem. Phys. 10, 428 (1942)
 
      Q0 = Q0/sig
      Q1 = Q1/sig
      Q2 = Q2/sig
      C = Q2/Q0 - (Q1/Q0)**2
      H = Q1/Q0
      S = (H+log(Q0))
 
      Qroq = Q0
 
      RETURN
 
      END
      FUNCTION Qrot(T,B,d,sig,C,S,H)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Thermo: a code for thermochemical calculations.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c	Rotational partition function (see Robinson & Holbrook, Appendix 5)
c
c	T	= temperature
c	B	= rotational constant (cm-1)
c	d	= rotor dimension
c	sig	= rotor symmetry (foldedness)
c	C	= constant p heat capacity (units of R)
c	S	= entropy (units of R)
c	H	= [H(T)-H(0)]/RT
c
 
      IMPLICIT NONE
 
      DOUBLE PRECISION Qrot , T , B , ALNGAM , GAM , C , S , H , hor
 
      INTEGER d , sig
 
      PARAMETER (hor = 1.4387752D+00)

      EXTERNAL ALNGAM
 
      SAVE 
 
      C = 0.5*d
      GAM = EXP(ALNGAM((DBLE(d)/2.0)))
      Qrot = (1.0D+00/sig)*GAM*SQRT(T/(hor*B))**d

      S = log(Qrot) + 0.5*d
      H = 0.5*d
 
      RETURN
 
      END
      FUNCTION QStop(T,BJ,BK,sig,C,S,H)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Thermo: a code for thermochemical calculations.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c	Rotational partition function for symmetric top rotor
c
c	T	= temperature
c	BJ	= 2-D rotational constant (cm-1)
c	BK	= 1-D rotational constant (cm-1) (K-rotor)
c	sig	= rotor symmetry (foldedness)
c	C	= constant p heat capacity (units of R)
c	S	= entropy (units of R)
c	H	= [H(T)-H(0)]/RT
c
 
      IMPLICIT NONE
 
      DOUBLE PRECISION Q0 , Qtot(2), T, T2, BJ , BK, C , S , H , Ered ,
     &                 E , hor , F , Fac , Qstop, Q , H2, S2
 
      INTEGER  sig, j , k, i
      PARAMETER (hor = 1.4387752D+00)
 
      SAVE 
      
      T2=T     
c
c     Now start loop
      DO i=1,2

c     At j = 0:
c
!--------------------------------------------

       Q =  0.0D+00
       Fac = 1.0D+00

       j=-1
       DO WHILE ( Fac.GE.1.0D-12 )
        j=j+1
        Q0=0
        DO k=-j,j
         E=(BK-BJ)*(k**2)
         Ered = hor*E/T2
         Fac = EXP(-Ered)
         Q0 = Q0 + Fac
        ENDDO  !k
        F = (2.d+00*j+1.d+00)
        E = BJ*j*(j+1.d+00)
        Ered = hor*E/T2
        Fac = F*EXP(-Ered)*Q0
        Q=Q+Fac

       ENDDO !j
        Qtot(i)=Q/sig
        T2=T+T/1E5


      ENDDO  ! i

!     S/R=(lnQ + T dlnQ/dT)
      S=log(Qtot(1)) + T * (log(Qtot(2))-log(Qtot(1)))/(T2-T)
      S2=log(Qtot(2))+ T2 * (log(Qtot(2))-log(Qtot(1)))/(T2-T)

!     H/RT= S- lnQ
      H=S-log(Qtot(1))
      H2=S2-log(Qtot(2))

!     Cp/R= dH/dT
      C= T*(H2-H)/(T2-T)
       
      QStop = Qtot(1)
!     write(*,*) "Q Symm Top ",T, QStop
      RETURN
 
      END
**==qvib.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
      FUNCTION Qvib(T,w,x,g,C,S,H,zpe)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Thermo: a code for thermochemical calculations.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the "ReadMe" file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c	Last modified: 
c       11/02 Fixed yet another bug related to vibrational degeneracies
c 
c
c	Vibrational partition function
c
c	T	= temperature
c	w	= harmonic vibrational frequency (cm-1)
c	x	= anharmonicity
c	g	= degeneracy
c	C	= heat capacity at constant pressure (units of R)
c	S	= entropy (units of R)
c	H	= [H(T)-H(0)]/RT
c       zpe     = zero point energy
c
 
      IMPLICIT NONE
 
      DOUBLE PRECISION Q0 , Q1 , Q2 , T , w , C , S , H , Ered , E , 
     &                 hor , Fac , Qvib , x , zpe
 
      PARAMETER (hor = 1.4387752D+00)
 
      INTEGER g , v , vmax
 
      SAVE 
 
      zpe = w*0.5 + x*0.25
      vmax = 10000
      IF ( x .LT. 0.0d+00) vmax = (-w/(2.0d+00*x) - 0.5d+00)
      Q0 = 1.0D+00
      Q1 = 0.0D+00
      Q2 = 0.0D+00
      Fac = 1.0d+00
      v = 1
 
      DO WHILE ( Fac.GE.1.0D-12 .AND. v .LE. vmax )
         E = w*(v+0.5d+00) + x*(v+0.5d+00)*(v+0.5d+00) - zpe
         Ered = hor*E/T
         Fac = EXP(-Ered)
         Q0 = Q0 + Fac
         Q1 = Q1 + Ered*Fac
         Q2 = Q2 + Ered*Ered*Fac
         v = v + 1
      ENDDO
 
c	Thermo formulae from Pitzer and Gwinn, J. Chem. Phys. 10, 428 (1942)
 
      C = Q2/Q0 - (Q1/Q0)**2
      H = Q1/Q0
      S = (H+log(Q0))

      C = g*C
      H = g*H
      S = g*S
 
      Qvib = Q0**g
      zpe = g*zpe
 
      RETURN
 
      END
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 Andrea Maranzana and John R. Barker
c
c Andrea Maranzana
c andrea.maranzana@unito.it
c Department of General and Organic Chemistry
c University of Torino
c Corso Massimo D'Azeglio, 48
c Torino  10125
c ITALY
c ++39-011-670-7637
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!     READ THERMO.DAT  AND CALC ZPE

      subroutine read_dat

      include 'declare.inc'
      Double Precision Mass(2), dum , amass , Hfxn, Tmax
      CHARACTER readpot*15
      CHARACTER formula*90
      CHARACTER keyword*4 , VROT*4
      DIMENSION keyword(2)
      INTEGER ki
      INTEGER LNBLNK
      Double Precision Vo, Vm	

      hindrance=0
      Gorin=0
      c=0
      a1=0

      OPEN (UNIT=4,STATUS='OLD',FILE='thermo.dat')                      ! General Data file

      READ (4,*) Eunits , Sunits
 
      IF ( Eunits.EQ.'KCAL' .OR. Eunits.EQ.'kcal' ) THEN
         Rgas = 8.314472D+00/4.184d+00
      ELSEIF ( Eunits.EQ.'KJOU' .OR. Eunits.EQ.'kjou' ) THEN
         Rgas = 8.314472D+00
      ELSEIF ( Eunits.EQ.'CM-1' .OR. Eunits.EQ.'cm-1' ) THEN
         Rgas = 0.6950356D+00
      ELSE
         OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
         write(7,*) '*** FATAL: Unknown Energy Units ***'
         write(*,*)  '*** FATAL: Unknown Energy Units ***'
         STOP  '*** FATAL: Unknown Energy Units ***'
      ENDIF
 
      IF ( Sunits.EQ.'ATM' .OR. Sunits.EQ.'atm' ) THEN
         UNITS = 'atmosphere'
      ELSEIF ( Sunits.EQ.'BAR' .OR. Sunits.EQ.'bar' ) THEN
         UNITS = 'bar'
      ELSEIF ( Sunits.EQ.'MCC' .OR. Sunits.EQ.'mcc' ) THEN
         UNITS = 'molecule/cc'
      ELSE
         OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
         write(7,*) '*** FATAL: Unknown Standard State ***'
         write(*,*)  '*** FATAL: Unknown Standard State ***'
         STOP  '*** FATAL: Unknown Standard State ***'
      ENDIF
c
c	Number of temperatures (K)
c
      READ (4,*) Nt
      READ (4,*) (T(j),j=1,Nt)  ! Read list of temperatures

C......To find Emax (cm-1), the upper limit for eigenvalues of Hindered rotor 

	Tmax=T(1)
	DO j=2, Nt
		IF(T(j).GT.Tmax) Tmax=T(j)	! To find Tmax (maximum of Temperature) 
	ENDDO
	IF(Tmax.LT.3000.0d0) THEN
        	Tmax=3000.0d0
	ENDIF	
	Emax=10.0d0*(0.6950356D+00)*Tmax	! Emax = 10RT

C.......

      Hdiff = 0.0
      Nreac = 0
      Nprod = 0
      Nctst = 0
 
      READ (4,*) Ns
c
c	Number of species
c
      DO 100 i = 1 , Ns
         Warning(i)=0
         READ (4,*) REPROD(i) , MOLNAME(i) , DelH(i) 
         READ (4,*) Formula
           CALL ChemFormula(i,Formula)
          
c
c	reac/prod, name, Enthalpy(0 K), number of elements
c   empirical formula
c
         AMU(i) = 0.0d+00
         Hfxn298(i) = 0.0d+00
         DO ne = 1 , Nelement(i)                                    ! Empirical formula
            CALL element( ATYPE(i,ne) , amass , Hfxn , Sfxn)
            AMU(i) = AMU(i) + Natom(i,ne)*amass                     ! Atomic masses
            Hfxn298(i) = Hfxn298(i) + Natom(i,ne)*Hfxn*1000.0       ! [H(298.15) - H(0)]/Rgas (enthalpy function)
            Sfel(i) = Sfel(i) + Natom(i,ne)*Sfxn                    ! Sf/Rgas entropy of elements at 298.15 K
         END DO
         Hfxn298(i) = Hfxn298(i)*Rgas
         Sfel(i) = Sfel(i)*Rgas
c         
         READ (4,99114) TITLE1(i)
         READ (4,99114) TITLE2(i)
         READ (4,99114) TITLE3(i)
c
c   Three comment lines
c
c   symmetry number, optical isomers, number of electronic levels
         READ (4,*) Sym(i) , Sopt(i) , Nele(i) 
c
c   electronic energy levels and degeneracies
         READ (4,*) (Elev(i,ne) , gele(i,ne) , ne=1,Nele(i))
c
c   number of internal degrees of freedom (rots + vibs) to be read,
c      and two keywords
         READ (4,*) N(i) , keyword(1) , keyword(2)
c     KEYWORDS:
c          VHAR = 'HAR' for harmonic vibs, 
c       or VHAR = 'OBS' FOR observed (0-1 transitions)
c      and, for qro and rot types [NOT hindered rotor types]:
c          VROT = 'AMUA' for moment of inertia in units of amu*Ang^2
c       or      = 'GMCM' for moment of inertia units of gram*cm^2
c       or      = 'CM-1' for rotational constant in units of cm^-1
c       or      = 'MHZ' for rotational constant in units of MHz
c         
         DO ki = 1 , 2
           IF     ( keyword(ki) .EQ. 'HAR' .OR. 
     &              keyword(ki) .EQ. 'har' .OR.
     &              keyword(ki) .EQ. 'Har' ) THEN
             VHAR = 'HAR'
           ELSEIF ( keyword(ki) .EQ. 'OBS' .OR.
     &              keyword(ki) .EQ. 'obs' .OR. 
     &              keyword(ki) .EQ. 'Obs' ) THEN
             VHAR = 'OBS'
           ELSE
             VROT = keyword(ki)
             dum = 1.0
             CALL rotunits( VROT , dum )   ! check validity of keyword VROT: if not valid, rotunits will kill execution
           ENDIF
         END DO

         IF ( Nele(i) .LT. 1 ) then
           OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
           write(7,*) '*** FATAL: Requires at least 1 electronic level'
           write(*,*) '*** FATAL: Requires at least 1 electronic level'
           STOP '*** FATAL: Requires at least 1 electronic level ***'
         ELSEIF ( Nele(i) .gt. 10 ) then
           Warning(i)=1
           OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
           write(7,*) "**** WARNING: the maximum number of energy levels
     &is 10. ****"
           write(*,*) "**** WARNING: the maximum number of energy levels
     &is 10. ****"
           write(*,*)  Nele(i)-10, " levels ignored."
           Nele(i)=10
         ENDIF
c
c               Electronic level energies and degeneracies (for Nele levels); note that
c               lowest electronic energy level should be at Elev = 0 cm-1.
c
            Nflag = 0
         IF ( REPROD(i).EQ.REAC ) THEN
            a1=a1+1
            mass(a1)=AMU(i)

            Nreac = Nreac + 1
            Hdiff = Hdiff - 1000.*DelH(i)       ! Hdiff in cal/mole or J/mole
            Nflag = 1
         ELSEIF ( REPROD(i).EQ.PROD ) THEN
            Nprod = Nprod + 1
            Hdiff = Hdiff + 1000.*DelH(i)       ! Hdiff in cal/mole or J/mole
            Nflag = 1
         ELSEIF ( REPROD(i).EQ.CTST) THEN
            Nctst = Nctst + 1
            Hdiff = Hdiff + 1000.*DelH(i)       ! Hdiff in cal/mole or J/mole
            Nflag = 1
         ELSEIF ( REPROD(i).EQ.NON ) THEN
            Nnone = Nnone + 1
         ELSE 
            OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
            write(7,*) '***FATAL: unrecognized reac/prod type: ',
     &          REPROD(i)
            stop 
         ENDIF

      IF ( Nctst .GT. 1 ) THEN
         OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
         write(7,*) 'Too many transition states; only is one allowed!'
         write(*,*) 'Too many transition states; only is one allowed!'
         STOP 'Too many transition states; only is one allowed!'
      ENDIF

      IF ( Nctst .EQ. 1 .AND. Nprod.GT.0 ) THEN
         OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
         write(7,*) '"prod" not allowed in Canonical TST calculation!'
         write(*,*) '"prod" not allowed in Canonical TST calculation!'
         STOP '"prod" not allowed in Canonical TST calculation!'
      ENDIF

 
         zzpe(i) = 0.0       
         IF ( N(i).GT.0 ) THEN
            DO 20 II = 1 , N(i)
               READ (4,*) MODE(i,II) , IDOF(i,II) , WE(i,II) , ANH(i,II)
     &                    , NG(i,II)

               IF ( WE(i,II) .LT. 0.0 ) THEN
                  OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
                  WRITE(*,*) '***FATAL: WE(i) negative value: ',WE(i,II)
                  WRITE(7,*) '***FATAL: WE(i) negative value: ',WE(i,II)
                  STOP
               ENDIF
     
              IF ( IDOF(i,II).EQ.VIB ) THEN                    ! VIBRATION
                if(NG(i,II).eq.10.AND.REPROD(i).EQ.PROD) then
                   freq=WE(i,II)
                   NG(i,II)=1
                endif
                  W(i,II) = WE(i,II)
                  IF ( VHAR .EQ. HAR ) THEN
                   WOBS(i,II) = WE(i,II)+2.*ANH(i,II)           ! WOBS = observed freq
                  ELSEIF ( VHAR .EQ. OBS ) THEN
                   WOBS(i,II) = WE(i,II)
                   WE(i,II)= WE(i,II)-2.*ANH(i,II)        ! Convert WE to harmonic frequency
                  ENDIF
                 qq=Qvib(10.d+00,WE(i,II),ANH(i,II),NG(i,II),Cvib,Svib,
     &                    Hvib,zap)
                  zzpe(i) = zzpe(i) + zap
               ELSEIF ( IDOF(i,II).EQ.BOX ) THEN                    ! PARTICLE IN A BOX 
                  W(i,II) = WE(i,II)
                  IF ( VHAR .EQ. HAR ) THEN
                   WOBS(i,II) = 3.0d+00*WE(i,II)                ! WOBS = observed freq (note that ANH is a placeholder: not used)
                  ELSEIF ( VHAR .EQ. OBS ) THEN
                   WOBS(i,II) = WE(i,II)
                   WE(i,II)= WE(i,II)/3.0d+00             ! Convert WE to harmonic frequency
                  ENDIF
                 zap = W(i,II)
                 zzpe(i) = zzpe(i) + zap
                ELSEIF ( IDOF(i,II).EQ.ROT ) THEN                ! CLASSICAL ROTOR
                  call rotunits( VROT , WE(i,II) )                ! unit conversion
                  AMOM(i,II) = WE(i,II)
                ELSEIF ( IDOF(i,II).EQ.QRO ) THEN                ! QUANTUM ROTOR
                  call rotunits( VROT , WE(i,II) )                ! unit conversion
                  AMOM(i,II) = WE(i,II)
             
                ELSEIF (IDOF(i,II).EQ. GOR) THEN                 ! GORIN
                  call rotunits( VROT , WE(i,II) )                ! unit conversion
                  AMOM(i,II) = WE(i,II)
                  Gorin=Gorin+1
                ELSEIF ( IDOF(i,II).EQ.FIT) THEN                ! HINDRANCE
                  call rotunits( VROT , WE(i,II) )                ! unit conversion
                  AMOM(i,II) = WE(i,II)
                  hindrance=hindrance+1
                  Weorig(hindrance)= WE(i,II)
                ELSEIF ( IDOF(i,II).EQ.TOP ) THEN               ! Symmetric Top
                  call rotunits( VROT , WE(i,II) )                ! unit conversion
                  AMOM(i,II) = WE(i,II)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

                ELSEIF ( IDOF(i,II).EQ.HRA ) THEN                ! SYMMETRICAL HINDERED ROTOR 
                  IF ( NG(i,II) .LT. 0 ) THEN
                      READ(4,*) NSIG(i,II)
                      NG(i,II) = -NG(i,II)
                    ELSE
                      NSIG(i,II) = NG(i,II)
                  ENDIF
                  W(i,II) = WE(i,II)                    ! small vibration frequency
                  AMOM(i,II) = ANH(i,II)                ! moment of inertia
                  call rotunits( VROT , AMOM(i,II) )                ! unit conversion
                  B(i,II) = 16.85763D+00/AMOM(i,II)     ! rotational constant (cm-1)
                  VV(i,II) = ((W(i,II)/NG(i,II))**2)/B(i,II)
                                                        ! hindrance barrier (cm-1)
C.............To find eigenvalues and zero-point energy

                NSV(i,II)=NSIG(i,II)

		CALL SHRLEV(Emax,EVh,B(i,II),VV(i,II),
     &		NSIG(i,II),1,IMAX(i,II),zap,'Vhrd1','Bhrd1',
     &		0.0d0,0.0d0,Vo,Vm)
     
          	zpe(i,II) = zap
                Vmax(i,II) = Vo
		Vmin(i,II) = Vm 

		DO LL=1, IMAX(i,II)
			EV(i,II,LL)=EVh(LL)
		ENDDO

                  zzpe(i) = zzpe(i) + zap
                  IDOF(i,II) = HIN

CCCCCCCCCCCCCCCCCCCCCCCCCC

                ELSEIF ( IDOF(i,II).EQ.HRB ) THEN                ! SYMMETRICAL HINDERED ROTOR 
                  IF ( NG(i,II) .LT. 0 ) THEN
                      READ(4,*) NSIG(i,II)
                      NG(i,II) = -NG(i,II)
                    ELSE
                      NSIG(i,II) = NG(i,II)
                  ENDIF
                  W(i,II) = WE(i,II)            ! small vibration frequency
                  VV(i,II) = ANH(i,II)                  ! hindrance barrier (cm-1)
                  IF (VV(i,II) .LT. 1.0d-05) STOP
     &            'Rotation barrier too small. Hit RETURN to terminate'
                  B(i,II) = ((W(i,II)/NG(i,II))**2)/VV(i,II)
                                                        ! rotational constant (cm-1)
                  AMOM(i,II) = 16.85763D+00/B(i,II)     ! rotational constant (cm-1)

C.............To find eigenvalues and zero-point energy

                NSV(i,II)=NSIG(i,II)

                CALL SHRLEV(Emax,EVh,B(i,II),VV(i,II),
     &          NSIG(i,II),1,IMAX(i,II),zap,'Vhrd1','Bhrd1',
     &		0.0d0,0.0d0,Vo,Vm)

                zpe(i,II) = zap
                Vmax(i,II) = Vo
                Vmin(i,II) = Vm


                DO LL=1, IMAX(i,II)
                        EV(i,II,LL)=EVh(LL)
                ENDDO

                  zzpe(i) = zzpe(i) + zap
                  IDOF(i,II) = HIN

CCCCCCCCCCCCCCCCCCCCCCCCCC

                ELSEIF ( IDOF(i,II).EQ.HRC ) THEN                ! SYMMETRICAL HINDERED ROTOR 
                  IF ( NG(i,II) .LT. 0) THEN
                      READ(4,*) NSIG(i,II)
                      NG(i,II) = -NG(i,II)
                    ELSE
                      NSIG(i,II) = NG(i,II)
                  ENDIF
                  AMOM(i,II) = WE(i,II)                 ! moment of inertia
                  call rotunits( VROT , AMOM(i,II) )                ! unit conversion
                  B(i,II) = 16.85763D+00/AMOM(i,II)     ! rotational constant (cm-1)
                  VV(i,II) = ANH(i,II)                  ! hindrance barrier (cm-1)
                  W(i,II) = NG(i,II)*SQRT(B(i,II)*VV(i,II))
                                                        ! small vibration frequency

C.............To find eigenvalues and zero-point energy

		      NSV(i,II)=NSIG(i,II)

                CALL SHRLEV(Emax,EVh,B(i,II),VV(i,II),
     &          NSIG(i,II),1,IMAX(i,II),zap,'Vhrd1','Bhrd1',
     &		0.0d0,0.0d0,Vo,Vm)

                zpe(i,II) = zap
                Vmax(i,II) = Vo
                Vmin(i,II) = Vm


                DO LL=1, IMAX(i,II)
                        EV(i,II,LL)=EVh(LL)
                ENDDO

                  zzpe(i) = zzpe(i) + zap
                  IDOF(i,II) = HIN

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

		ELSEIF ( IDOF(i,II).EQ.HRD ) THEN	 ! NON-RIGID, UNSYMMETRICAL HINDERED ROTOR

			NSIG(i,II) = NG(i,II)
			NCV(i,II)=INT(WE(i,II))
			NCB(i,II)=INT(ANH(i,II))
			READ(4,*) VHRD(i,II), NSV(i,II), Phav(i,II), 
     &				(CV(i,II,LL), LL=1, NCV(i,II))
			READ(4,*) BHRD(i,II), NSB(i,II), Phab(i,II), 
     &				(CB(i,II,LL), LL=1, NCB(i,II))

			DO LL=1, NCB(i,II)
				CBB(LL)=CB(i,II,LL)
			ENDDO
			DO LL=1, NCV(i,II)
				CVV(LL)=CV(i,II,LL)
			ENDDO 

C.............To find eigenvalues and zero-point energy

			CALL UHRLEV(Emax,EVh,NCB(i,II),NCV(i,II),
     &		CBB,CVV,NSV(i,II),NSB(i,II),IMAX(i,II),zap,
     &		VHRD(i,II),BHRD(i,II),Phav(i,II),Phab(i,II),Vo,Vm)
     
		zpe(i,II) = zap
                Vmax(i,II) = Vo
                Vmin(i,II) = Vm

		DO LL=1, IMAX(i,II)
                        EV(i,II,LL)=EVh(LL)
		ENDDO
               
		zzpe(i) = zzpe(i) + zap
		IDOF(i,II) = HRD

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

                ELSE
                  OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
                  write(7,*) "**** FATAL: DOF type not recognized: ",
     &                   IDOF(i,II)        
                  write(*,*) "**** FATAL: DOF type not recognized: ",
     &                   IDOF(i,II)        
                  stop
               ENDIF
 20         CONTINUE
!           IF(vts.ne.0.AND.REPROD(i).eq.PROD) read(4,*) re, DDelH
            mu=(mass(1)*mass(2))/(mass(1)+mass(2))

		IF(De.ne.0.0d0) THEN

            beta=0.1217788*freq*SQRT(mu/De)

		ELSE
			beta = 0.0d0
		ENDIF

         ENDIF
 
 100  CONTINUE
  
      IF(hindrance.gt.0) READ (4,*) (Kexp(j),j=1,Nt)
      IF(Gorin.gt.0) then
         read(4,*) readpot   ! Potential
         read(4,*) freq      ! CM-1
         read(4,*) De        ! Eunit    Without ZPE
!        read(4,*) I2d       ! amu A**2
         read(4,*) re        ! Re, between centers of mass, A
         Deorig=De
         IF ( Eunits.EQ.'KCAL' .OR. Eunits.EQ.'kcal' ) THEN
          De=De*349.76
          ELSEIF ( Eunits.EQ.'KJOU' .OR. Eunits.EQ.'kjou' ) THEN
          De=De*83.59
         ENDIF

         a1=0
         do i=1,Ns
           IF(REPROD(i).EQ.REAC) then
            a1=a1+1
            mass(a1)=AMU(i)
           ENDIF 
         enddo 
         IF(a1.ne.2) then
           OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
           write(7,*) "**** FATAL: Wrong number of reactants ****"
           write(*,*) "**** FATAL: Wrong number of reactants ****"
           stop
         ENDIF

         mu=(mass(1)*mass(2))/(mass(1)+mass(2))   
!        re=SQRT(I2d/mu)
         beta=0.1217788*freq*SQRT(mu/De)
 
         readpot=readpot(1:lnblnk(readpot))
         IF(readpot.eq."MORSE".OR.readpot.eq."morse") then
          POT="MORSE"
         elseif(readpot.eq."VARSHNI".OR.readpot.eq."varshni") then
          POT="VARSHNI"
          beta=0.5*(beta-(1/re))/re
         elseif (readpot.eq."sMORSE".OR.readpot.eq."smorse") then
          POT="sMORSE"
          read(4,*) c        ! read stiff Morse Parameter
         ELSE
          OPEN( 7, status='UNKNOWN', file='thermo.ERROR')
          write(7,*) "**** FATAL: Potential not recognized"
          write(*,*) "**** FATAL: Potential not recognized"
          stop
         ENDIF

      ENDIF
        
      CLOSE(4)

99114 FORMAT (A120)

	RETURN 
      end subroutine 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Thermo: a code for thermochemical calculations.
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      SUBROUTINE rotunits( VROT , X )
      
      IMPLICIT NONE
      CHARACTER VROT*4      
      DOUBLE PRECISION X
      SAVE
     
c      CONVERT UNITS TO amu*Ang^2
c      For qro and rot types [NOT hindered rotorS]:
c          VROT = 'AMUA' for moment of inertia in units of amu*Ang^2
c       or      = 'GMCM' for moment of inertia units of gram*cm^2
c       or      = 'CM-1' for rotational constant in units of cm^-1
c       or      = 'MHZ' for rotational constant in units of MHz
c       or      = 'GHZ' for rotational constant in units of GHz
c         
      IF ( VROT .EQ. 'AMUA' .OR. VROT .EQ. 'amua' ) THEN
        RETURN
      ELSEIF ( VROT .EQ. 'GMCM' .OR. VROT .EQ. 'gmcm' ) THEN
        X = X / 1.660538782d-040
        RETURN
      ELSEIF ( VROT .EQ. 'CM-1' .OR. VROT .EQ. 'cm-1' ) THEN
        X = 16.85763D+00 / X
        RETURN
      ELSEIF ( VROT .EQ. 'MHZ' .OR. VROT .EQ. 'MHz' 
     &      .OR. VROT .EQ. 'mhz' .OR. VROT .EQ. 'Mhz' ) THEN
        X = 5.05379D+005 / X
      ELSEIF ( VROT .EQ. 'GHZ' .OR. VROT .EQ. 'GHz' 
     &      .OR. VROT .EQ. 'ghz' .OR. VROT .EQ. 'Ghz' ) THEN
        X = 5.05379D+002 / X
        RETURN
      ELSE
        write (*,*) 'FATAL: units (VROT) for rotations not recongized'
        STOP
      ENDIF

      END
      
      
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c SHRLEV: a code to calculate eigenvalues of symmetrical, rigid 1D-hindered internal rotation
c Copyright (C) 2009 Lam T. Nguyen and John R. Barker
c
c	DATE:	Feb. 13, 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	SUBROUTINE SHRLEV(Emax,EV,B,V,n1,n2,NIMAX,zpe,
     &		Vhr,Bhr,Phav,Phab,Vo,Vm)

	IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
	PARAMETER (NN=2000, No=1)
	DIMENSION EV(NN), CV(No), CF(No) 
	CHARACTER Vhr*5, Bhr*5

	NCV=1
	NCF=1
	CV(1)=V
	CF(1)=B

	CALL GHRLEV(EV,NN,NIMAX,Emax,B,NCV,NCF,CV,CF,n1,n2,
     &		Vhr,Bhr,Phav,Phab,Vo,Vm)

	zpe=EV(1)	! zero-point energy (cm-1)

	RETURN
	END


	SUBROUTINE thermochem 

!  THERMOCHEMISTRY CALCULATION
      include 'declare.inc'
      Double precision Qvibration(NMax), Qtotal(Nmax), Qrotat(Nmax)
      Double precision CStop, HStop, SStop, QStop , delAMU

         Dzpe = 0.0d+00
         DDelH = 0.0d+00
         DDelH298 = 0.0d+00
         delAMU = 0.0d+00
         Nflag = 0     ! no reaction
!     IF(vts.eq.1) Ns=3

      DO i = 1 , Ns
            IF ( REPROD(i).EQ.REAC ) THEN
               DDelH = DDelH - DelH(i)          ! Delta H(0) for reaction
               Dzpe = Dzpe - zzpe(i)            ! Delta zpe for reaction
               delAMU = delAMU - AMU(i)         ! Delta molar mass for reaction
               Nflag = 1                        ! reaction
            ELSEIF ( REPROD(i).EQ.PROD .OR. REPROD(i).EQ.CTST ) THEN
               DDelH = DDelH + DelH(i)          ! Delta H(0) for reaction
               Dzpe = Dzpe + zzpe(i)            ! Delta zpe for reaction
               delAMU = delAMU + AMU(i)         ! Delta molar mass for reaction
               Nflag = 1                        ! reaction
            ENDIF
      END DO
 
      IF ( ABS( delAMU ) .GT. 1.0d-004 ) THEN
c        PAUSE '*** FATAL: Empirical formulas do not match ***'
        STOP '*** FATAL: Empirical formulas do not match ***'
      ENDIF
      
      IF ( Nflag .EQ. 1) THEN                   ! reaction thermo
      ENDIF
      
c
c	Thermodynamic functions at T
c

       Tdel = Tfrac*T(Temp)
       TT = T(Temp) - 2.d+00*Tdel
       DO 401 jj = 1 , 3
       TT = TT + Tdel         
         Qreac = 1.0d+00
         Qprod = 1.0d+00
         DO 250 i = 1 , Ns

            Qrotat(i)=1       
            Qvibration(i)=1       

            q = Qele(TT,i,Nele(i),Elev,gele,Cel,Sel,Hel)   ! electronic partition function
            Qtotal(i)=q
            Cp(i) =Rgas*Cel
            S(i) = Rgas*Sel
            H(i) = Rgas*Hel*TT        ! H(T)-H(0)
            IF ( Sunits.EQ.'ATM' ) THEN ! first part of translational part. fxn.
               q = q*(DBLE(Sopt(i))/DBLE(Sym(i)))*0.02560786*TT    ! (std. state= 1 atm)
            ELSEIF ( Sunits.EQ.'BAR' ) THEN
               q = q*(DBLE(Sopt(i))/DBLE(Sym(i)))*0.02594716*TT    ! (std. state= 1 bar)
            ELSEIF ( Sunits.EQ.'MCC' ) THEN
               q = q*(DBLE(Sopt(i))/DBLE(Sym(i)))*(1.879333E+20)   ! (std. state= 1 molecule/cc)
            ENDIF
            q = q*(AMU(i)*TT)**1.5    ! second part of translational part. fxn.

            ff = 3.6648556 - 1.5*log(AMU(i)) - 2.5*log(TT)
            H(i) = H(i) + 2.5*Rgas*TT        ! H(T)-H(0)
            Cp(i) = Cp(i) + 2.5*Rgas
            S(i) = S(i) + Rgas*((2.5-ff) + 
     &                 log(DBLE(Sopt(i))/DBLE(Sym(i))))
            IF ( N(i).NE.0 ) THEN                                   ! for non-monatomic species
               DO 210 j = 1 , N(i)
                  IF ( IDOF(i,j).EQ.VIB ) THEN  ! VIBRATION
                       qq = Qvib(TT,WE(i,j),ANH(i,j),NG(i,j),Cvib,Svib,
     &                    Hvib,zap)
                     q = q*qq
                     Qvibration(i)=Qvibration(i)*qq
                     Cp(i) = Cp(i) + Cvib*Rgas
                     H(i) = H(i) + Rgas*Hvib*TT        ! H(T)-H(0)
                     S(i) = S(i) + Rgas*Svib
                  ELSEIF ( IDOF(i,j).EQ.BOX ) THEN  ! PARTICLE IN A BOX
                     qq = Qbox(TT,WE(i,j),NG(i,j),Cpib,Spib,Hpib,zap)
                     q = q*qq
                     Cp(i) = Cp(i) + Cpib*Rgas
                     H(i) = H(i) + Rgas*Hpib*TT        ! H(T)-H(0)
                     S(i) = S(i) + Rgas*Spib
                  ELSEIF ( IDOF(i,j).EQ.GOR ) THEN   ! I2d Gorin
                     WE(i,j)=I2dGorin(Temp)
                      if (WE(i,j).gt.10) then 
                                                 ! CLASSICAL ROTOR
                       BB = 16.85763D+00/WE(i,j)  ! rotational constant (cm-1)
                       dim = NG(i,j)              ! rotor dimension
                       ss = INT(ANH(i,j))         ! rotor symmetry number (not included in over-all symmetry)
                       qq = Qrot(TT,BB,dim,ss,Crot,Srot,Hrot)
                       q = q*qq
                       Cp(i) = Cp(i) + Crot*Rgas
                       H(i) = H(i) + Hrot*Rgas*TT        ! H(T)-H(0)
                       S(i) = S(i) + Srot*Rgas
                      else
                                                ! QUANTUM ROTOR
                       BB = 16.85763D+00/WE(i,j)  ! rotational constant (cm-1)
                       dim = NG(i,j)
                                ! rotor dimension
                       ss = INT(ANH(i,j))
                                ! rotor symmetry number (not included in over-all symmetry)
                       qq = Qroq(TT,BB,dim,ss,Croq,Sroq,Hroq)
                       q = q*qq
                       Cp(i) = Cp(i) + Croq*Rgas
                       H(i) = H(i) + Hroq*Rgas*TT        ! H(T)-H(0)
                       S(i) = S(i) + Sroq*Rgas
                      endif
                  ELSEIF ( IDOF(i,j).EQ.FIT ) THEN   ! Hindrance
                       if (WE(i,j)*x.gt.10) then
                                                 ! CLASSICAL ROTOR
                       BB = 16.85763D+00/(WE(i,j)*x)  ! rotational constant (cm-1)
                       dim = NG(i,j)              ! rotor dimension
                       ss = INT(ANH(i,j))         ! rotor symmetry number (not included in over-all symmetry)
                       qq = Qrot(TT,BB,dim,ss,Crot,Srot,Hrot)
                       q = q*qq
                       Cp(i) = Cp(i) + Crot*Rgas
                       H(i) = H(i) + Hrot*Rgas*TT        ! H(T)-H(0)
                       S(i) = S(i) + Srot*Rgas
                      else
                                                ! QUANTUM ROTOR
                       BB = 16.85763D+00/(WE(i,j)*x)  ! rotational constant (cm-1)
                       dim = NG(i,j)
                                ! rotor dimension
                       ss = INT(ANH(i,j))
                                ! rotor symmetry number (not included in over-all symmetry)
                       qq = Qroq(TT,BB,dim,ss,Croq,Sroq,Hroq)
                       q = q*qq
                       Cp(i) = Cp(i) + Croq*Rgas
                       H(i) = H(i) + Hroq*Rgas*TT        ! H(T)-H(0)
                       S(i) = S(i) + Sroq*Rgas
                      endif
 

                  ELSEIF ( IDOF(i,j).EQ.ROT ) THEN
                                                ! CLASSICAL ROTOR
                     BB = 16.85763D+00/WE(i,j)  ! rotational constant (cm-1)
                     dim = NG(i,j)
                                ! rotor dimension
                     ss = INT(ANH(i,j))
                                ! rotor symmetry number (not included in over-all symmetry)
                     qq = Qrot(TT,BB,dim,ss,Crot,Srot,Hrot)
                     Qrotat(i)=Qrotat(i)*qq
                     q = q*qq
                     Cp(i) = Cp(i) + Crot*Rgas
                     H(i) = H(i) + Hrot*Rgas*TT        ! H(T)-H(0)
                     S(i) = S(i) + Srot*Rgas

                  ELSEIF ( IDOF(i,j).EQ.QRO ) THEN
                                                ! QUANTUM ROTOR
                     BB = 16.85763D+00/WE(i,j)  ! rotational constant (cm-1)
                     dim = NG(i,j)
                                ! rotor dimension
                     ss = INT(ANH(i,j))
                                ! rotor symmetry number (not included in over-all symmetry)
                     qq = Qroq(TT,BB,dim,ss,Croq,Sroq,Hroq)
                     q = q*qq
                     Cp(i) = Cp(i) + Croq*Rgas
                     H(i) = H(i) + Hroq*Rgas*TT        ! H(T)-H(0)
                     S(i) = S(i) + Sroq*Rgas

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

                  ELSEIF ((IDOF(i,j).EQ.HIN).OR.(IDOF(i,j).EQ.HRD)) THEN                     ! HINDERED ROTOR

			DO LL=1, IMAX(i,j)
				EVh(LL)=EV(i,j,LL)
			ENDDO
                     qq=Qhin(TT,EVh,IMAX(i,j),NSIG(i,j),
     &				Chin,Shin,Hhin,zap)
                     q = q*qq
                     Cp(i) = Cp(i) + Chin*Rgas
                     H(i) = H(i) + Hhin*Rgas*TT        ! H(T)-H(0)
                     S(i) = S(i) + Shin*Rgas

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

                  ELSEIF ( IDOF(i,j).EQ.TOP ) THEN                     ! SYMMETRIC TOP (QUANTUM)
                     BJ = 16.85763D+00/WE(i,j)    ! J-rotor rotational constant (cm-1)
                     BK = 16.85763D+00/ANH(i,j)   ! K-rotor rotational constant (cm-1)
                     ss = NG(i,j)                 ! rotor symmetry number (not included in over-all symmetry)
                     qq = QStop(TT,BJ,BK,ss,CStop,SStop,HStop)
                     q = q*qq
                     Cp(i) = Cp(i) + CStop*Rgas
                     H(i) = H(i) + HStop*Rgas*TT        ! H(T)-H(0)
                     S(i) = S(i) + SStop*Rgas
                  ENDIF
 210           CONTINUE
            ENDIF
            IF ( REPROD(i).EQ.REAC ) THEN
               Qreac = Qreac*q
            ELSEIF ( REPROD(i).EQ.PROD .OR. REPROD(i).EQ.CTST ) THEN
            Qprod = Qprod*q
            ENDIF
 250     CONTINUE
 
         IF ( Sunits.EQ.'ATM' ) THEN
            Sfac = 0.0
         ELSEIF ( Sunits.EQ.'BAR' ) THEN
            Sfac = Rgas*log(1.01325)
         ELSEIF ( Sunits.EQ.'MCC' ) THEN
            Sfac = Rgas*log(1.87915E+20/(0.02594*TT))
         ENDIF
 
         DSR = 0.0D+00
         DHR = Hdiff
!        if(vts.eq.1) DHR=DDelH*1000
         DCp = 0.0d+00
         DO 300 i = 1 , Ns
            IF ( REPROD(i).EQ.REAC ) THEN
               DSR = DSR - (Sfac+S(i))          ! Delta S for reaction
               DHR = DHR - H(i)                 ! Delta H for reaction
               DCp = DCp - Cp(i)                ! Delta Cp for reaction
            ELSEIF ( REPROD(i).EQ.PROD.OR.REPROD(i).EQ.CTST ) THEN
               DSR = DSR + (Sfac+S(i))          ! Delta S for reaction
               DHR = DHR + H(i)                 ! Delta H for reaction
               DCp = DCp + Cp(i)                ! Delta Cp for reaction
            ENDIF
 300     CONTINUE
 
         DG = (DSR - DHR/TT)/Rgas

         AK(jj) = exp(DG)                      ! Equilibrium constant

         IF ( Nctst .EQ. 1 ) THEN              ! Canonical TST rate constant
           AK(jj) = AK(jj)*2.0837D+10*TT       ! * kT/h
         ENDIF
     
 401  CONTINUE
      BB = -(LOG(AK(3)/AK(1)))*(T(Temp)**2)/(2.0d+00*Tdel)          ! K       
      AA = AK(2)*exp( -BB / T(Temp) )                               ! 1/s
      
      end subroutine 
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Thermo: a code for thermochemical calculations.
c Copyright (C) 2009 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c
c	Equilibrium constants and thermodynamic parameters
c	based on molecular properties
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      PROGRAM THERMO

      include 'declare.inc' 

      Double Precision rmax0,I2dGorin0, Veff0
      INTEGER ix
      

!     OPEN (UNIT=4,STATUS='OLD',FILE='thermo.dat')              ! General Data file  (read_dat.f)
!     OPEN (UNIT=3,STATUS='UNKNOWN',FILE='thermo.out')          ! Full output        (write_out.f)


      
      call read_dat                            ! READ THERMO.DAT AND CALCULATE ZPE
      
      T(Nt+1) = 298.15                       ! always run at 298.15 K, but don't print this one
      
      DO Temp=1,Nt+1  ! Nt  number of temperatures
       
        if(Gorin.gt.0 ) then 
         call MaxVeff(Nt,beta,POT,c,De,re,mu,T(Temp),rmax0,I2dGorin0,V0,
     &                Veff0,Eunits)                             ! I2d Gorin Subroutine

         V(Temp)=V0
         Veff(temp)=Veff0
         I2dGorin(Temp)=I2dGorin0
         bet(Temp)=beta
         rmax(Temp)=rmax0
        endif

        if(hindrance.gt.0 .AND. Temp.LE.Nt) then 
           call hindrance_fit                         !  Hindrance calculation
        ELSE
           call thermochem                            !  Thermochemistry calculation
        ENDIF

           T_AK(Temp)= AK(2)
           T_AA(Temp)= AA
           T_BB(Temp)=BB
           T_DSR(Temp)=DSR
           T_DHR(Temp)=DHR
           T_DCp(Temp)=DCp
           T_Sfac(Temp)=Sfac
           do ix=1,Ns
            T_S(Temp,ix)=S(ix)
            T_Cp(Temp,ix)=Cp(ix)
            T_H(Temp,ix)=H(ix)
            IF ( Temp .EQ. Nt+1 ) THEN
              delH298(ix) = delH(ix) + (H(ix) - Hfxn298(ix))/1000.          ! delH at 298.15 K; calculate enthalpy fxn for elements at 298.15 K
              delG298(ix) = delH298(ix) - 0.29815*(Sfac+S(ix)-Sfel(ix))     ! delG at 298.15 K (in kcal or kJ)
            ENDIF
           enddo
      ENDDO

      call write_out                                  ! Write thermo.out 
  

 
      END


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c UHRLEV: a code to calculate eigenvalues of unsymmetrical, non-rigid 1D-hindered internal rotation
c Copyright (C) 2009 Lam T. Nguyen and John R. Barker
c
c	DATE:	Feb. 13, 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	SUBROUTINE UHRLEV(Emax,EV,NCB,NCV,CB,CV,n1,n2,NIMAX,
     &		zpe,Vhr,Bhr,Phav,Phab,Vo,Vm)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER(I-N)
      PARAMETER (NN=2000)
      DIMENSION EV(NN), CV(NCV), CB(NCB) 
	CHARACTER Vhr*5, Bhr*5

	PI=acos(-1.0d0)

	IF((Bhr.EQ.'Bhrd2').OR.(Bhr.EQ.'BHRD2')) THEN	! Average rotational constant
		B=0.0d0
		DO I=1, n2
			B=B + (CB(I)/I)*((PI*2)**(I-1))
		ENDDO
	ELSEIF((Bhr.EQ.'Ihrd2').OR.(Bhr.EQ.'IHRD2')) THEN	! Average moment of inertia
                B=0.0d0
                DO I=1, n2
                        B=B + (CB(I)/I)*((PI*2)**(I-1))
                ENDDO
		B=16.85763d0 / B	! convert from I to B
        ELSEIF((Bhr.EQ.'Ihrd1').OR.(Bhr.EQ.'IHRD1')) THEN	! Average moment of inertia
                B=16.85763d0/CB(1)	! convert from I to B
        ELSEIF((Bhr.EQ.'Bhrd1').OR.(Bhr.EQ.'BHRD1')) THEN	! Average rotational constant			
		B=CB(1)
	ELSE
		write(*,*) "ERROR at INPUT for Bhr or Ihr"
	ENDIF

	CALL GHRLEV(EV,NN,NIMAX,Emax,B,NCV,NCB,CV,CB,n1,n2,
     &		Vhr,Bhr,Phav,Phab,Vo,Vm)

	zpe=EV(1)	! zero-point energy (cm-1)

	RETURN
	END


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 Andrea Maranzana and John R. Barker
c
c Andrea Maranzana
c andrea.maranzana@unito.it
c Department of General and Organic Chemistry
c University of Torino
c Corso Massimo D'Azeglio, 48
c Torino  10125
c ITALY
c ++39-011-670-7637
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      Subroutine write_out

      include 'declare.inc'
      
      DOUBLE PRECISION Dum, qqele
      DIMENSION qqele(100)
      INTEGER LNBLNK

      OPEN (UNIT=3,STATUS='UNKNOWN',FILE='thermo.out')          ! Full output

      DO Temp=1,Nt

      WRITE (3,99002) AVERSION , ADATE ,  AVERSION , ADATE

      DO  i=1,Ns
         
         WRITE (3,99014) MOLNAME(i)(1:lnblnk(MOLNAME(i))),
     &           AMU(i) , ( ADJUSTR(ATYPE(i,ne)) , Natom(i,ne) , 
     &           ne=1,Nelement(i) )

99014 FORMAT (//A10, 5X,'Molecular Wt. =', F8.3,
     &       '  ;  Empirical Formula:', 15(1x, A6 ,1x, I2 ,1x) ) 

         WRITE (3,99222) TITLE1(i), TITLE2(i), TITLE3(i)
99222    FORMAT( 10x, A150/, 10x, A150/, 10x, A150 )

         WRITE (3,99022)  (Elev(i,ne) , gele(i,ne) , ne=1,Nele(i))
         IF (Warning(i).eq.1) then 
           WRITE(3,*) "**** WARNING: Used 10 energy levels only. ****"
           WRITE(3,*)
         ENDIF
      
         IF ( N(i).GT.0 ) THEN
            DO 20 II = 1 , N(i)
               IF ( IDOF(i,II).EQ.VIB ) THEN                    ! VIBRATION
                  qq=Qvib(10.d+00,WE(i,II),ANH(i,II),NG(i,II),Cvib,Svib,
     &                    Hvib,zap)
                  WRITE (3,99010) MODE(i,II) , WOBS(i,II) , We(i,II) ,
     &                      ANH(i,II) , zap , NG(i,II)
               ELSEIF ( IDOF(i,II).EQ.BOX ) THEN                    ! PARTICLE IN A BOX
                  zap = W(i,II)
                  WRITE (3,99110) MODE(i,II) , WOBS(i,II) , W(i,II) ,
     &                      zap , NG(i,II)
               ELSEIF ( IDOF(i,II).EQ.ROT ) THEN                ! CLASSICAL ROTOR
                  BB = 16.85763D+00/AMOM(i,II)                  ! rotational constant (cm-1)
                  WRITE (3,99011) MODE(i,II) , WE(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
               ELSEIF ( IDOF(i,II).EQ.QRO ) THEN                ! QUANTUM ROTOR
                  BB = 16.85763D+00/AMOM(i,II)                  ! rotational constant (cm-1)
                  WRITE (3,99012) MODE(i,II) , WE(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
              ELSEIF (IDOF(i,II).EQ.GOR) THEN                   ! GORIN
               AMOM(i,II)=I2DGorin(Temp)
               WE(i,II)=AMOM(i,II)
               BB = 16.85763D+00/AMOM(i,II)
               if (AMOM(i,II).le.10)  THEN
                  WRITE (3,99012) MODE(i,II) , WE(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
               ELSE
                  WRITE (3,99011) MODE(i,II) , WE(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
               ENDIF
               ELSEIF ( IDOF(i,II).EQ.FIT) THEN                 ! HINDRANCE
                  AMOM(i,II) = WE(i,II)*gamma(Temp)
                  BB = 16.85763D+00/AMOM(i,II)                  ! rotational constant (cm-1)
                  if (AMOM(i,II).le.10)  THEN
                  WRITE (3,99012) MODE(i,II) , AMOM(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
                    ELSE
                  WRITE (3,99011) MODE(i,II) , AMOM(i,II), ANH(i,II) ,
     &                            NG(i,II) , BB
                  endif
              ELSEIF ( IDOF(i,II).EQ.HIN ) THEN                ! SYMMETRICAL HINDERED ROTOR 

                  WRITE (3,99001) MODE(i,II) , W(i,II) , AMOM(i,II) ,
     &            NG(i,II), NSIG(i,II), B(i,II), zpe(i,II), VV(i,II)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

		ELSEIF ( IDOF(i,II).EQ.HRD ) THEN	! NON-RIGID, UNSYMMETRICAL HINDERED ROTOR

             WRITE (3,99040) MODE(i,II), NG(i,II), zpe(i,II)
             WRITE (3,99041) VHRD(i,II), NSV(i,II),Phav(i,II),
     &			 (CV(i,II,LL), LL=1, NCV(i,II))
             WRITE (3,99042) BHRD(i,II), NSB(i,II),Phab(i,II),
     &			 (CB(i,II,LL), LL=1, NCB(i,II))

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

               ELSEIF ( IDOF(i,II).EQ.TOP ) THEN               ! SYMMETRIC TOP
                  BJ = 16.85763D+00/WE(i,II)
                  BK = 16.85763D+00/ANH(i,II)
                  WRITE (3,99113) MODE(i,II) , WE(i,II) , 
     &                  BJ , ANH(i,II) , BK , NG(i,II)
              ENDIF
20          ENDDO  ! II
       ENDIF
       ENDDO   ! i

      DDelH298 = 0.0d+00
      DDelG298 = 0.0d+00
      DO i = 1 , Ns
        IF ( REPROD(i).EQ.REAC ) THEN
           DDelH298 = DDelH298 - delH298(i)                      ! Delta H(298) for reaction
           DDelG298 = DDelG298 - delG298(i)                      ! Delta G(298) for reaction
        ELSEIF ( REPROD(i).EQ.PROD .OR. REPROD(i).EQ.CTST ) THEN
           DDelH298 = DDelH298 + delH298(i)                      ! Delta H(298) for reaction
           DDelG298 = DDelG298 + delG298(i)                      ! Delta G(298) for reaction
        ENDIF
      END DO

      IF ( Eunits.EQ.'KCAL' ) THEN
         WRITE (3,99004) UNITS 
      ELSEIF ( Eunits.EQ.'KJOU' ) THEN
         WRITE (3,99005) UNITS 
      ENDIF

       WRITE (3,99016) ( T(j) , j=1,Nt )

       DO i=1,Ns
         DO j=1,Nt
           qqele(j) = Qele(T(j),i,Nele(i),Elev,gele,Cel,Sel,Hel)
         END DO
         WRITE (3,99017) REPROD(i) , MOLNAME(i) ,
     &     AMU(i) , DelH(i) , delH298(i) , delG298(i) , zzpe(i) , 
     &     Sym(i) , Sopt(i) , ( qqele(j) , j=1,Nt )
       ENDDO  ! i

      IF ( Nflag .EQ. 1) THEN                   ! reaction thermo
         WRITE (3,99021)
         WRITE (3,99020) DDelH, DDelH298 , DDelG298 , Dzpe
      ENDIF

           IF (Nctst .EQ. 1 ) THEN                                  ! Canonical TST rate constant
         WRITE (3,99106) UNITS , 1-Nreac , 
     &     (MOLNAME(i)(1:lenstr(MOLNAME(i))) , REPROD(i),i=1,Ns)
         WRITE (3,99103) (CAP,i=1,Ns)
      ELSE
         WRITE (3,99006) (MOLNAME(i)(1:lenstr(MOLNAME(i))),         ! Keq and thermodynamics output
     &            REPROD(i),i=1,Ns)
         WRITE (3,99003) (CAP,i=1,Ns)
      ENDIF


      IF(hindrance.eq.0.AND.Gorin.eq.0) then 
       DO j=1,Nt
       WRITE (3,99007) T(j) , T_AK(j) , T_AA(j) ,T_BB(j) ,T_DSR(j) ,
     & T_DHR(j)/1000. , T_DCp(j) ,
     & (T_DHR(j)-T(j)*T_DSR(j))/1000. ,
     & (T_Sfac(j)+T_S(j,i),T_Cp(j,i),T_H(j,i)/1000., i=1,Ns)
       ENDDO
       CLOSE(3)
       STOP
      ENDIF

       WRITE (3,99007) T(temp) , T_AK(temp) , T_AA(temp) ,T_BB(temp) ,
     & T_DSR(temp) , T_DHR(temp)/1000. , T_DCp(temp) ,
     & (T_DHR(temp)-T(temp)*T_DSR(temp))/1000. ,
     & (T_Sfac(temp)+T_S(temp,i),T_Cp(temp,i),T_H(temp,i)/1000., i=1,Ns)
         

 501    IF(Gorin.NE.0.OR.hindrance.ne.0) then
           if(hindrance.ne.0.AND.Gorin.eq.0) then
            write(*,*)
            write(3,*)
            write(*,*) "AUTOMATIC FITTING CALCULATION "
            write(3,*) "AUTOMATIC FITTING CALCULATION "
           endif

           if(hindrance.eq.0.AND.Gorin.ne.0) then
            write(*,*) 
            write(3,*) 
            write(*,*) "GORIN CALCULATION "
            write(3,*) "GORIN CALCULATION "
           endif

           if(hindrance.ne.0.AND.Gorin.ne.0) then
            write(*,*) 
            write(3,*) 
            write(*,*) "AUTOMATIC FITTING AND GORIN CALCULATION "
            write(3,*) "AUTOMATIC FITTING AND GORIN CALCULATION "
           endif

        write(*,*) 
        write(3,*)
        write(*,*) "T =",T(temp)
        write(3,*) "T =",T(temp) 
        ENDIF

        IF(Gorin.NE.0) then
         TypePOT=POT
         IF(POT.eq.'sMORSE') typePOT='Stiff MORSE'
         write(*,*) "   Potential:  ",TypePOT
         write(3,*) "   Potential:  ",TypePOT
         write(*,*) "   Frequency:  ", freq," cm-1"
         write(3,*) "   Frequency:  ", freq," cm-1"
!         write(*,*) "   2-D moment: ",I2d," amu A**2"
!         write(3,*) "   2-D moment: ",I2d," amu A**2"
         write(*,*) "   De Energy:  ", Deorig," ",Eunits
         write(3,*) "   De Energy:  ", Deorig," ",Eunits
         write(*,*) "   Equil. re:  ", re, " A"
         write(3,*) "   Equil. re:  ", re, " A"
         if(POT.eq.'VARSHNI') then
          write(*,*) "   Beta:       ", bet(temp), " A-2"
          write(3,*) "   Beta:       ", bet(temp), " A-2"
          else
          write(*,*) "   Beta:       ", bet(temp), " A-1"
          write(3,*) "   Beta:       ", bet(temp), " A-1"
          endif
         if(POT.eq.'sMORSE') then 
          write(*,*) "   stiff c:    ",c
          write(3,*) "   stiff c:    ",c
         endif 
         write(*,99023) I2dGorin(temp),rmax(temp)
         write(3,99023) I2dGorin(temp),rmax(temp)
         write(*,99024)  V(temp) , Eunits
         write(3,99024)  V(temp) , Eunits
         write(*,99025)  Veff(temp) , Eunits
         write(3,99025)  Veff(temp) , Eunits
        ENDIF

         IF(hindrance.ne.0) then
          write(*,*) "   Kexp       =  ",Kexp(temp)
          write(3,*) "   Kexp       =  ",Kexp(temp)
         IF(gamma(Temp).gt.1) then
         write(*,*) "**** WARNING: Gamma >1.0 (Maybe Kexp too big) ****"
         write(3,*) "**** WARNING: Gamma >1.0 (Maybe Kexp too big) ****"
         endif
        write(*,99026)  gamma(Temp), 1-gamma(Temp)**2                    ! Print Gamma and eta
        write(3,99026)  gamma(Temp), 1-gamma(Temp)**2                    ! Print Gamma and eta
        do i=1,hindrance
         write(*,99027) Weorig(i)*gamma(Temp)             !Print Optimized moment of inertia
         write(3,99027) WeOrig(i)*gamma(Temp)             !Print Optimized moment of inertia
        enddo
         ENDIF
       
       write(3,*) 
       write(3,*) 
       write(3,*) 

       ENDDO
       CLOSE(3)
 

99001 FORMAT (I5,2X,'Hind.Rot',2x,'Freq(har)=',F8.2,2x,'Mom=',F8.3,2x,
     &       'fold=',I2,2x,'symm=',I2,2x,'B=',F8.4,' cm-1',2x,
     &        'zpe(cm-1)=',F8.1,2x,'Uo=',F7.1,' cm-1')
99002 FORMAT (
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'                                John R. Barker'/8x,
     &'        Thermo-',A6,'           University of Michigan'/8x,
     &'                                Ann Arbor, MI 48109-2143'/8x,
     &'        ',A8,'                jrbarker@umich.edu'/8x,
     &'                                (734) 763 6239'//8x,
     &'      http://aoss.engin.umich.edu/multiwell/'//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'Suggested Literature Citation:'//8x,
     &'a) MultiWell-',A6,' Software, ',A8,', designed and'/11x,
     &'maintained by J.R. Barker with contributors N.F. Ortiz,'/11x,
     &'J.M. Preses, L.L. Lohr, A. Maranzana, P.J. Stimac, T. L.'/11x,
     &'Nguyen, and T. J. Dhilip Kumar, University of Michigan,'/11x,
     &'Ann Arbor, MI; http://aoss.engin.umich.edu/multiwell/',//8x,
     &'b) J.R. Barker, Int. J. Chem. Kinetics, 33, 232-45 (2001).',//8x,
     &//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'/)
99003 FORMAT (8x,'T(K)',6x,'Kequil',4x,'A(T)',7x,'B(T)',4x,'DelS(rxn)',
     &       1x,'DelH(rxn)',1x,'DelCp(rxn)',1x,'DelG(rxn)',5x,6(A27,1x))
99103 FORMAT (8x,'T(K)',6x,'k(T)  ',4x,'A(T)',7x,'B(T)',4x,'DelS(rxn)',
     &       1x,'DelH(rxn)',1x,'DelCp(rxn)',1x,'DelG(rxn)',5x,6(A27,1x))
99004 FORMAT (//'*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  ',
     &'*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *'//, 
     &'THERMODYNAMIC QUANTITIES',10x,'Std. State = ',A12,/,3x,
     &        'Entropy & Cp units: cal/K/mole'/3x,
     &        'DelS         units: cal/K/mole'/3x,
     &        '[H(T)-H(0)]  units: kcal/mole'/3x,
     &        'DelH & DelG  units: kcal/mole'/)
99005 FORMAT (//'*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  ',
     &'*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *'//, 
     &'THERMODYNAMIC QUANTITIES',10x,'Std. State = ',A12,/,3x,
     &        'Entropy & Cp units: J/K/mole'/3x,
     &        'DelS         units: J/K/mole'/3x,
     &        '[H(T)-H(0)]  units: kJ/mole'/3x,
     &        'DelH & DelG  units: kJ/mole'/)
c99006 FORMAT (/86x,6(7x,A10,11x)/,
99006 FORMAT (//25x,'Kequil = A*exp(B/T)',
     &        43x,6(5x,A10,x,'(',A4,')',6x))
99106 FORMAT (//15x,'RATE k(T) = A*exp(B/T)',1x,
     &       '(',A12,')**(',I2,') * sec-1',
     &        21x,6(5x,A10,1x,'(',A4,')',6x))
99007 FORMAT (1x,f11.2,2(2x,1pe10.3),2x,0pf7.0,1x,0pf9.2,1x,0pf8.2, 
     &        1x,0pf10.2,1x,0pf10.2,2x,6(2x,0pf8.2,1x,f8.2,1x,f8.2)) 
99008 FORMAT (/)
99009 FORMAT (1x,f10.1,1x,I10,1x,f10.1,1x,I10,1x,f10.1)
99010  FORMAT (I5,2X,'Vibrator',2x,'Freq(obs)=',F8.2,2x,
     &        'Freq(har)=',F8.2,2x,'Anh(cm-1)=',F8.2,2X,
     &        'zpe(cm-1) =',F8.1,2x,'   g =',I2)
99110  FORMAT (I5,2X,'P-in-Box',2x,'Freq(obs)=',F8.2,2x,
     &        'Freq(har)=',F8.2,2x,
     &        'zpe(cm-1) =',F8.1,2x,'   g =',I2)
99011 FORMAT (I5,2X,'Clas.Rot',2x,'AmuAng^2 =',F8.2,2x,'Symm =',F4.0,2x,
     &        ' dim =',I2,2x,'B =',F8.4,' cm-1')
99012 FORMAT (I5,2X,'Quan.Rot',2x,'AmuAng^2 =',F8.2,2x,'Symm =',F4.0,2x,
     &        ' dim =',I2,2x,'B =',F8.4,' cm-1')
99113 FORMAT (I5,2X,'Symm Top',2x,'J-Moment =',F8.2,' BJ =',F8.4,' cm-1'
     &      ,2x,'K-Moment =',F8.2,' BK =',F8.4,' cm-1',2x,'Symm = ',I1)
99013 FORMAT (/'  No.  Freq(cm-1)  ANH(cm-1)      Degeneracy'/)
99114 FORMAT (A80)
99015 FORMAT (F10.1,4x,3(1pe10.3,4x),6(1pe10.3,1x))
99016 FORMAT ('Species Properties'/,
     &  30x,'----Enthalpy----',45x,'Electronic Partition Function',/,
     &  ' TYPE  NAME         Mol.Wt.    (O K)  (298.15 K) DelG(298)  '
     &  'ZPE(cm-1) Symmetry  opt.isomers   T =',50(1x,F8.0))
99017 FORMAT(1x,A4,2x,A10,1x,F8.3,2(2x,F8.2),2x,F8.2,
     & 6x,F7.1,2x,I5,I10,5x,'qele =', 50(2x,F7.2))
99018 FORMAT (A100)
99019 FORMAT (1x,A10,2(5x,F10.2))
99020 FORMAT (5x,'NET (prod - react):',
     &        3x,F9.2,1x,F9.2,1x,F9.2,4x,F9.1)
99021 FORMAT (29x,'------- ---------  --------      -------')
99022 FORMAT (4X, 'Electronic Levels (degeneracies) ',
     &             10(/,10x,F10.2,1x,'cm-1 (',I2,')'))
99023 FORMAT ('>>> Gorin external 2-D moment =',F9.4,' amu A**2 <<<',/
     &        '    Rmax       = ',F8.3,' A')
99024 FORMAT ('    V(Rmax)    = ',F8.3, ' ',4A)
99025 FORMAT ('    Veff(Rmax) = ',F8.3, ' ',4A)
99026 FORMAT ('    Gamma      =  ',F8.4,/
     &        '    Eta        =  ',F8.4)
99027 FORMAT ('    Moment * Gamma =',F8.3,' amu A**2')

99040 FORMAT (I5,2X,'Non-Rigid HinRotor:',2x,'Rotor symm. =',I2,
     & 34x,'zpe(cm-1) =',F8.1 )
99041 FORMAT (8X,A5,1x,' ; symmV =',I2,2x,'; Phase(rad.) = ',
     & F8.4,2x,'; Coeff. =',20(F10.4,1x))

99042 FORMAT (8X,A5,1x,' ; symmM =',I2,2x,'; Phase(rad.) = ',
     & F8.4,2x,'; Coeff. =',20(F10.4,1x))

99044 FORMAT (8X,'Torsional potential: Vmax =',1x,F8.1,1x,'cm-1',1x,
     &	'and Vmin = ',1x,F8.1,1x,'cm-1')

      END subroutine

