c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 Thanh Lam Nguyen
c
c Authors: Thanh Lam Nguyen 
c          nguyenlt@umich.edu
c          Dec. 23, 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


	SUBROUTINE CMXYZ(N,M,X,Y,Z,AMT,AM)

        Integer NMAX, MMAX
        Parameter (NMAX=100, MMAX=500)

        Integer N, M, I, J
        Double precision AM(NMAX), AMT
        Double precision X(MMAX,NMAX), Y(MMAX,NMAX), Z(MMAX,NMAX)
        Double precision CMX, CMY, CMZ

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C To transform X,Y,Z to the central mass of the molecule
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	DO I=1, M
		CMX=0.0d0
		CMY=0.0d0
		CMZ=0.0d0
		DO J=1, N
			CMX=CMX+AM(J)*X(I,J)
			CMY=CMY+AM(J)*Y(I,J)
			CMZ=CMZ+AM(J)*Z(I,J)
		ENDDO

		CMX=CMX/AMT
		CMY=CMY/AMT
		CMZ=CMZ/AMT
		DO J=1, N
			X(I,J)=X(I,J)-CMX
			Y(I,J)=Y(I,J)-CMY
			Z(I,J)=Z(I,J)-CMZ
		ENDDO
	ENDDO
	RETURN
	END


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 Thanh Lam Nguyen
c
c Authors: Thanh Lam Nguyen 
c          nguyenlt@umich.edu
c          Dec. 23, 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


	SUBROUTINE CONGI(N,M,GI,X,Y,Z,AM,DELA)

        Integer NMAX, MMAX
        Parameter (NMAX=100, MMAX=500)

        Integer N, M, I, J
        Double precision DELA, AM(NMAX), PI, DEL
        Double precision X(MMAX,NMAX), Y(MMAX,NMAX), Z(MMAX,NMAX)
        Double precision A(3,3), GI(MMAX,4,4)
        Double precision ABX(NMAX), ABY(NMAX), ABZ(NMAX)
        Double precision DX(NMAX), DY(NMAX), DZ(NMAX)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C To construct G(-1) matrix
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	PI=acos(-1.0d0)
	DEL=DELA*PI/180.0d0

	DO J=2, M-1

	DO I=1, N
		DX(I)=(X(J+1,I)-X(J-1,I))/2/DEL   ! The first derivative of X using the central different approach
		DY(I)=(Y(J+1,I)-Y(J-1,I))/2/DEL
		DZ(I)=(Z(J+1,I)-Z(J-1,I))/2/DEL
	ENDDO

	DO I=1, N
		ABX(I)=Y(J,I)*DZ(I)-Z(J,I)*DY(I) ! The product of two vectors: X and DX
		ABY(I)=Z(J,I)*DX(I)-X(J,I)*DZ(I)
		ABZ(I)=X(J,I)*DY(I)-Y(J,I)*DX(I)
	ENDDO

	DO I=1, 3
		DO K=1, 3
			A(I,K)=0.0d0
		ENDDO
	ENDDO

	DO I=1, N
		A(1,1)=A(1,1)+AM(I)*( Y(J,I)**2 + Z(J,I)**2 )
		A(2,2)=A(2,2)+AM(I)*( X(J,I)**2 + Z(J,I)**2 )
		A(3,3)=A(3,3)+AM(I)*( X(J,I)**2 + Y(J,I)**2 )
		A(1,2)=A(1,2)-AM(I)*X(J,I)*Y(J,I)
		A(2,3)=A(2,3)-AM(I)*Y(J,I)*Z(J,I)
		A(1,3)=A(1,3)-AM(I)*X(J,I)*Z(J,I)
	ENDDO
	A(2,1)=A(1,2)
	A(3,1)=A(1,3)
	A(3,2)=A(2,3)

	DO I=1, 3
		DO K=1, 3
			GI(J,I,K)=A(I,K)
		ENDDO
	ENDDO

	DO I=1, 4
		GI(J,4,I)=0.0d0
	ENDDO

	DO I=1, N
		GI(J,4,1)=GI(J,4,1)+AM(I)*ABX(I)
		GI(J,4,2)=GI(J,4,2)+AM(I)*ABY(I)
		GI(J,4,3)=GI(J,4,3)+AM(I)*ABZ(I)
		GI(J,4,4)=GI(J,4,4)+AM(I)*( DX(I)**2 + DY(I)**2 + DZ(I)**2 )
	ENDDO
	GI(J,1,4)=GI(J,4,1)
	GI(J,2,4)=GI(J,4,2)
	GI(J,3,4)=GI(J,4,3)

	ENDDO

	RETURN
	END


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 Thanh Lam Nguyen
c
c Authors: Thanh Lam Nguyen 
c          nguyenlt@umich.edu
c          Dec. 23, 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


	SUBROUTINE INVG(G44,GI,M)
	Integer M, MMAX, I, J, K
	Parameter (MMAX=500)
	Double precision G(4,4), GI(MMAX,4,4), Gtp(4,4)
	Double precision G44(MMAX)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C To invert the GI matrix to obtain G44 = 1/I
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	DO J=2, M-1
	
		DO I=1, 4
			DO K=1, 4
				Gtp(I,K)=GI(J,I,K)
			ENDDO
		ENDDO

		CALL INVM(Gtp,G,4)
		G44(J)=G(4,4)

	ENDDO

	G44(1)=2*G44(2)-G44(3)    ! linear extrapolation for G44(1) and G44(M)
	G44(M)=2*G44(M-1)-G44(M-2)
	
	RETURN
	END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


        SUBROUTINE INVM(A,Y,N)
        Double precision A(N,N), Y(N,N), INDX(N), D
        Integer I, J

        DO I=1, N
                DO J=1, N
                        Y(I,J)=0.0d0
                ENDDO
                Y(I,I)=1.0d0
        ENDDO

        CALL LUDCMP(A,N,N,INDX,D)
        DO J=1, N
                CALL LUBKSB(A,N,N,INDX,Y(1,J))
        ENDDO
        RETURN
        END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE LUDCMP(A,N,NP,INDX,D)
      PARAMETER (NMAX=100,TINY=1.0D-20)
      DOUBLE PRECISION A(NP,NP),INDX(N),VV(NMAX),D
      D=1.
      DO 12 I=1,N
        AAMAX=0.
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
!!!        IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'

        IF (AAMAX.EQ.0.) goto 100 
        VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        IF (J.GT.1) THEN
          DO 14 I=1,J-1
            SUM=A(I,J)
            IF (I.GT.1)THEN
              DO 13 K=1,I-1
                SUM=SUM-A(I,K)*A(K,J)
13            CONTINUE
              A(I,J)=SUM
            ENDIF
14        CONTINUE
        ENDIF
        AAMAX=0.
        DO 16 I=J,N
          SUM=A(I,J)
          IF (J.GT.1)THEN
            DO 15 K=1,J-1
              SUM=SUM-A(I,K)*A(K,J)
15          CONTINUE
            A(I,J)=SUM
          ENDIF
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(J.NE.N)THEN
          IF(A(J,J).EQ.0.)A(J,J)=TINY
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      IF(A(N,N).EQ.0.)A(N,N)=TINY
100      RETURN
      END

      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
      DOUBLE PRECISION A(NP,NP),INDX(N),B(N)
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        IF(I.LT.N)THEN
          DO 13 J=I+1,N
            SUM=SUM-A(I,J)*B(J)
13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


 
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 Thanh Lam Nguyen
c
c Authors: Thanh Lam Nguyen   
c          nguyenlt@umich.edu       
c          December 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c    PROGRAM Large-Amplitude Motion (LAMM) 
c
c    by
c
c    Thanh Lam Nguyen    
c    nguyenlt@umich.edu        
c
c
c
c@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
c    Citations:
c
c    1. M. A. Harthcock and J. Laane, J. Phys. Chem. 89, 4231-4240 (2001).
c
c    2. T. L. Nguyen and J. R. Barker, to be published (2010).
c
c@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

C
C DEFINITION for VARIABLES used in the Red-I program
C

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C N       = number of atoms in the molecule
C M       = number of optimized points on the potential energy surface
C AM(I)   = mass of ith atom, in amu
C ATM     = total mass of molecule, in g/mol or amu
C X, Y, Z = coordinates
C ANG     = a vector of torsional/inversion angle
C Amin    = minimum of ANGLE
C Amax    = maximum of ANGLE
C DELA    = stepsize of ANGLE
C GI      = GI matrix
C G44     = 1/I
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


	Program LAMM 

        Integer NMAX, MMAX
        Parameter (NMAX=100, MMAX=500)

        Integer N, M, I, J
        Double precision AMT, DELA, ANG(MMAX), AM(NMAX)
        Double precision X(MMAX,NMAX), Y(MMAX,NMAX), Z(MMAX,NMAX)
        Double precision GI(MMAX,4,4)
        Double precision G44(MMAX), E(MMAX)

	Character C1*100, C2*100, C3*100

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C To compute reduced moment of inertia as a function of torsional/inversion/ring-puckering angle
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


C
C To read data in 
C

	CALL READ_IN(N,M,ANG,X,Y,Z,AMT,AM,DELA,C1,C2,C3,E)

C
C To identify center of mass and to transform the origin to the center of mass 
C

	CALL CMXYZ(N,M,X,Y,Z,AMT,AM)

C
C To construct ro-vibrational matrix GI
C

	CALL CONGI(N,M,GI,X,Y,Z,AM,DELA)

C
C To invert GI matrix to gain G44 = 1/I
C

	CALL INVG(G44,GI,M)

C
C To write out results for the effective reduced I
C

	CALL WRITE_OUT(G44,ANG,M,C1,C2,C3,DELA,E)

	END


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 Thanh Lam Nguyen
c
c Authors: Thanh Lam Nguyen 
c          nguyenlt@umich.edu
c          Dec. 23, 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

C
C To read data for the LAMM program
C


	SUBROUTINE READ_IN(N,M,ANG,X,Y,Z,AMT,AM,DELA,C1,C2,C3,E)
        Integer NMAX, MMAX
	Parameter (NMAX=100, MMAX=500)

	Integer N, M, I, J
        Double precision AMT, Amin, Amax, DELA, ANG(MMAX), AM(NMAX)
        Double precision X(MMAX,NMAX), Y(MMAX,NMAX), Z(MMAX,NMAX)
        Double precision E(MMAX), TANG

	Character C1*100, C2*100, C3*100

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C N       = number of atoms in the molecule 
C M       = number of optimized points on the potential energy surface
C AM(I)   = mass of ith atom, in amu 
C ATM     = total mass of molecule, in g/mol or amu
C X, Y, Z = coordinates
C ANG     = a vector of torsional/inversion angle
C Amin    = minimum of ANG
C Amax    = maximum of ANG
C DELA    = stepsize of ANG 
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

        open (unit=1,file='lamm.dat',status='old',
     &  access='sequential')

	read(1,99) C1
	read(1,99) C2

	read(1,*) N
	read(1,*) Amin, M, DELA
        AMT=0.0d0
        DO I=1, N
                read(1,*) AM(I)
                AMT=AMT + AM(I)
        ENDDO

!!!	M=INT((Amax-Amin)/DELA) + 1

	Amax = (M-1)*DELA + Amin

	DO I=1, M
                ANG(I)=Amin + (I-1)*DELA
	ENDDO
	
	DO I=1, M
		DO J=1, N
			read(1,*) X(I,J), Y(I,J), Z(I,J)
		ENDDO
	ENDDO

	read(1,*) C3

	DO I=1, M
		read(1,*) TANG, E(I)
	ENDDO

        close (unit=1, status='keep')

99	FORMAT(A100)

	RETURN
	END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c Copyright (C) 2009 Thanh Lam Nguyen
c
c Authors: Thanh Lam Nguyen 
c          nguyenlt@umich.edu
c          Dec. 23, 2009
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


C
C To write out the results
C


	SUBROUTINE WRITE_OUT(G44,ANG,M,C1,C2,C3,DELA,E)

	Double precision C, DELA, CC
	Parameter (C=16.85763D0)
	Integer MMAX, M, I, MM
	Parameter (MMAX=500)
	Double precision G44(MMAX), ANG(MMAX), E(MMAX)

	CHARACTER C1*100, C2*100, C3*100

	CHARACTER AVERSION*6 , ADATE*8 
	PARAMETER ( AVERSION='2010', ADATE='Jan 2010' )

	CC = acos(-1.0d0)/180.0d0

	OPEN(UNIT=4,STATUS='UNKNOWN',FILE='lamm.out')

	WRITE(4,9001) AVERSION , ADATE , AVERSION , ADATE

	write(4,*)
        
	WRITE(4,99) C1
        WRITE(4,99) C2

	write(4,*)
        WRITE(4,99) C3
        write(4,*)

	write(4,9999) "  INDEX    ANG(DEG)    ANG(RAD)      E(cm-1) 
     &I(amu.A**2)   B(cm-1)"

	IF(ANG(M).eq.(360.0d0-DELA)) THEN
		MM=M+1
		G44(MM)=G44(1)
		G44(MM-1)=G44(2)
		ANG(MM)=360.0d0
		E(MM)=E(1)
	ELSE
		MM=M
	ENDIF

	DO I=1, MM
		write(4,999) I, ANG(I), ANG(I)*CC, E(I), 1.0d0/G44(I), C*G44(I)
	ENDDO

        CLOSE (unit=4, status='keep')

99	FORMAT(A100)
999	FORMAT(1X,I5,7X,F5.1,7X,F8.6,5X,F7.1,5X,F7.3,6X,F5.1)
9999	FORMAT(A73)

9001  FORMAT (
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//,
     &'                      LAMM-',A6,//
     &'                       ',A8,//,
     &'                   Thanh Lam Nguyen',/
     &'                   nguyenlt@umich.edu',//
     &'                   University of Michigan',/
     &'               Ann Arbor, Michigan 48109-2143',//
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%',//,
     & 3x,'MultiWell Citation:'//,
     & 3x,'MultiWell-',A6,' Software, ',A8,
     &     ', designed and maintained by'/,
     & 6x,'J.R. Barker with contributors N.F. Ortiz, J.M. Preses, ',/,
     & 6x,'L.L. Lohr, A. Maranzana, P.J. Stimac, T.L. Nguyen, ',/, 
     & 6x,'and T.J. Dhilip Kumar',/,
     & 6x,'University of Michigan, Ann Arbor, MI; ',/,
     & 6x,'http://aoss.engin.umich.edu/multiwell/.',//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'/)

	RETURN
	END
